﻿;==========================================================================================================================================================
; Add a new category to the database
;==========================================================================================================================================================

Procedure EditCategory()
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  Program\CurrentLine = GetGadgetState(#Gadget_PiccyDb_Category)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  If Program\CurrentLine <> #NothingSelected
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    Program\CurrentRecord = GetGadgetItemText(#Gadget_PiccyDb_Category, Program\CurrentLine, #CategoryRecordColumn)
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    If Program\CurrentRecord  <>  #EmptyString
      
      ;--------------------------------------------------------------------------------------------
      ; Check if an existing window is opened
      ;--------------------------------------------------------------------------------------------
      
      If Program\WindowMutex <> #True
        
        ;------------------------------------------------------------------------------------------
        ; Try to open the data form window
        ;------------------------------------------------------------------------------------------
        
        If Window_PiccyCategory()
          
          ;----------------------------------------------------------------------------------------
          ; Window was opened so set mutex to prevent other windows from opening
          ;----------------------------------------------------------------------------------------
          
          Program\WindowMutex = #True
          
          ;----------------------------------------------------------------------------------------
          ; Prevent user input on the main window
          ;----------------------------------------------------------------------------------------
          
          DisableWindow(#Window_PiccyDb, #True)
          
          ;----------------------------------------------------------------------------------------
          ; Add the hover gadgets to this window
          ;----------------------------------------------------------------------------------------
          
          AddHoverGadget(GadgetID(#Gadget_PiccyCategory_SaveCategory))
          
          AddHoverGadget(GadgetID(#Gadget_PiccyCategory_ExitCategory))
          
          ;----------------------------------------------------------------------------------------
          ; Add the fast form close keyboard shortcut
          ;----------------------------------------------------------------------------------------
          
          AddKeyboardShortcut(#Window_PiccyCategory, #PB_Shortcut_Escape,                   #Shortcut_CloseCategory)
          
          AddKeyboardShortcut(#Window_PiccyCategory, #PB_Shortcut_Alt     | #PB_Shortcut_S, #Shortcut_SaveCategory)

          AddKeyboardShortcut(#Window_PiccyCategory, #PB_Shortcut_Alt     | #PB_Shortcut_X, #Shortcut_ExitCategory)
          
          ;----------------------------------------------------------------------------------------
          ; Set the last window message for the closure routine later
          ;----------------------------------------------------------------------------------------
          
          Program\LastWindow = "Edit An Old Category"
          
          ;----------------------------------------------------------------------------------------
          ; Show new record number and status in the data window
          ;----------------------------------------------------------------------------------------
          
          SetWindowTitle(#Window_PiccyCategory, Program\LastWindow)
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
          Program\OldCategoryString = RepQuote(Trim(StringField(GetGadgetItemText(#Gadget_PiccyDb_Category, Program\CurrentLine, #CategoryTitleColumn), 1, "(")))
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
          SetGadgetText(#Gadget_PiccyCategory_lCategory, "Edit (" + Program\OldCategoryString + ")")
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
          SetGadgetText(#Gadget_PiccyCategory_Category, Program\OldCategoryString)
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
          SetGadgetText(#Gadget_PiccyCategory_RecordNumber, "Record No: " + GetGadgetItemText(#Gadget_PiccyDb_Category, Program\CurrentLine, #CategoryRecordColumn))
          
          ;----------------------------------------------------------------------------------------
          ; Show new record number and status in the main window
          ;----------------------------------------------------------------------------------------
          
          SetInfoBarArea("Headings", "Info", Program\LastWindow, "EditCategory")
          
          ;----------------------------------------------------------------------------------------
          ; Make sure the data form window is topmost
          ;----------------------------------------------------------------------------------------
          
          SetActiveWindow(#Window_PiccyCategory)
          
          ;----------------------------------------------------------------------------------------
          ; Make sure the version field is selected
          ;----------------------------------------------------------------------------------------
          
          SetActiveGadget(#Gadget_PiccyCategory_Category)
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
          HideWindow(#Window_PiccyCategory, #False)
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
        Else
          
          SetInfoBarArea("Headings", "Error", "The ["  + Program\LastWindow + "] window could not be opened.", "EditCategory")
          
        EndIf
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
      Else
        
        SetInfoBarArea("Headings", "Warn",  "The ["  + Program\LastWindow + "] program window is still open, close that one first.", "EditCategory")
        
      EndIf
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
    Else
      
      SetInfoBarArea("Headings", "Warn", "There was no record number found on the selected line.", "EditCategory")
      
    EndIf
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
  Else
    
    SetInfoBarArea("Headings", "Warn", "There is no category selected for editing.", "EditCategory")
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure

; IDE Options = PureBasic 5.31 (Windows - x86)
; CursorPosition = 88
; FirstLine = 66
; Folding = -
; EnableXP
; HideErrorLog