﻿;==============================================================================================================================================================================
; Export the list of categories to disk
;==============================================================================================================================================================================

Procedure ExportCategories()
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  CategoryFileName.s = SaveFileRequester("Save categories", Program\TemporaryDirectory  + #Basename + "_Categories.txt", "Text (*.txt)|*.txt;*.asc", 0)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  If CategoryFileName.s <> #EmptyString
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    CategoryFileId.i = CreateFile(#PB_Any, CategoryFileName.s)
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    If CategoryFileId.i <> #NoFileHandle
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      QueryString.s = "SELECT Category FROM Categories"
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      If DatabaseQuery(Program\DatabaseHandle, QueryString.s) <> #DatabaseQueryFail
        
        While NextDatabaseRow(Program\DatabaseHandle)
  
          WriteStringN(CategoryFileId.i,  GetDatabaseString(Program\DatabaseHandle, 0))
          
        Wend
          
        FinishDatabaseQuery(Program\DatabaseHandle)
      
      Else
        
        SetInfoBarArea("Headings",  "Warn",  "No categories found in category table", "ExportCategories")
        
      EndIf        
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      CloseFile(CategoryFileId.i)
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
    Else
      
      SetInfoBarArea("Headings",  "Error",  "No category file handle was created", "ExportCategories")
      
    EndIf
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
  Else
    
    SetInfoBarArea("Headings",  "Info",  "Nothing to save, user cancelled", "ExportCategories")
    
  EndIf

  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure

; IDE Options = PureBasic 5.31 (Windows - x86)
; CursorPosition = 78
; FirstLine = 32
; Folding = -
; EnableAsm
; EnableUnicode
; EnableXP