﻿;==============================================================================================================================================================================
; Import a list of categories from a text file
;==============================================================================================================================================================================

Procedure ImportCategories()
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  CategoryFileName.s = OpenFileRequester("Add categories", Program\TemporaryDirectory  + #Basename + "_Categories.txt", "Text (*.txt)|*.txt;*.asc", 0)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  If CategoryFileName.s <> #EmptyString
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    CategoryFileId.i = ReadFile(#PB_Any, CategoryFileName.s)
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    If CategoryFileId.i <> #NoFileHandle
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      While Eof(CategoryFileId.i) = #NotEndOfFile
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        CurrentCategoryString.s = ProperCaseString(ReadString(CategoryFileId.i))
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        If CurrentCategoryString.s <> #EmptyString And Len(CurrentCategoryString.s) >= 8
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
          DatabaseUpdate.s  = "INSERT INTO Categories(Category, Itemcount) "
          
          DatabaseUpdate.s  + "VALUES('"  + CurrentCategoryString.s + "'"
          
          DatabaseUpdate.s  + "'0'"
          
          ;----------------------------------------------------------------------------------------
          ; Import into the database
          ;----------------------------------------------------------------------------------------
          
          If DatabaseUpdate(Program\DatabaseHandle, QueryString.s)  <> #DatabaseUpdateFail
            
            ;--------------------------------------------------------------------------------------
            ; Get the new record number if any
            ;--------------------------------------------------------------------------------------
            
            NewRecordNumber.s = DatabaseLastInsertRowId()
            
            ;--------------------------------------------------------------------------------------
            ; Proceed if we got a record number
            ;--------------------------------------------------------------------------------------
            
            If NewRecordNumber.s  <> #EmptyString
              
              ;------------------------------------------------------------------------------------
              ; Display the new string of data
              ;------------------------------------------------------------------------------------
              
              AddGadgetItem(#Gadget_PiccyDb_Category, #AtTheEndOfTheList, CurrentCategoryString.s + #LF$ + #EmptyString +  #LF$ + NewRecordNumber.s, ImageID(#Image_List_Normal))
              
              ;------------------------------------------------------------------------------------
              ; 
              ;------------------------------------------------------------------------------------
              
              ; UpdateCategoryItemCount(CategoryString.s)
              
              ;------------------------------------------------------------------------------------
              ; Sort the strings
              ;------------------------------------------------------------------------------------
              
              SortCategoryEntries()
              
              ;------------------------------------------------------------------------------------
              ; 
              ;------------------------------------------------------------------------------------
              
              CurrentCategoryString.s = #EmptyString
              
              DatabaseUpdate.s        = #EmptyString
              
              NewRecordNumber.s       = #EmptyString
              
              ;------------------------------------------------------------------------------------
              ; 
              ;------------------------------------------------------------------------------------
              
            Else
              
              SetInfoBarArea("Headings", "Error", "Database failed to be updated so we didn't get a new record number.", "ImportCategories")
              
            EndIf
            
            ;--------------------------------------------------------------------------------------
            ; 
            ;--------------------------------------------------------------------------------------
            
          Else
            
            SetInfoBarArea("Headings", "Error", "The database query failed or was empty. " + DatabaseError(), "ImportCategories")
            
          EndIf
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
        Else
          
          SetInfoBarArea("Headings", "Error", "The category string is either empty or shorter than 5 characters.", "ImportCategories")
          
        EndIf
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
      Wend
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      CloseFile(CategoryFileId.i)      
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
    Else
      
      SetInfoBarArea("Headings", "Error", "No category file handle was created.", "ImportCategories")
      
    EndIf
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
  Else
    
    SetInfoBarArea("Headings", "Warn", "Nothing to open, user cancelled.", "ImportCategories")
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure

; IDE Options = PureBasic 5.31 (Windows - x86)
; CursorPosition = 80
; Folding = -
; EnableAsm
; EnableUnicode
; EnableXP