﻿;==============================================================================================================================================================================
; Load all the categories into the category bar
;==============================================================================================================================================================================

Procedure LoadCategories()
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  QueryString.s = "SELECT * FROM Categories ORDER BY Category ASC"
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  If DatabaseQuery(Program\DatabaseHandle,  QueryString.s)  <> #DatabaseQueryFail
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    AddGadgetItem(#Gadget_PiccyDb_Category, #AtTheEndOfTheList, "All pictures"      + #LF$ + #EmptyString  + #LF$ + #EmptyString, ImageID(#Image_List_Allitems))
    
    AddGadgetItem(#Gadget_PiccyDb_Category, #AtTheEndOfTheList, "No title"          + #LF$ + #EmptyString  + #LF$ + #EmptyString, ImageID(#Image_List_NoTitle))
    
    AddGadgetItem(#Gadget_PiccyDb_Category, #AtTheEndOfTheList, "No category"       + #LF$ + #EmptyString  + #LF$ + #EmptyString, ImageID(#Image_List_NoCategory))
    
    AddGadgetItem(#Gadget_PiccyDb_Category, #AtTheEndOfTheList, "No subcategory"    + #LF$ + #EmptyString  + #LF$ + #EmptyString, ImageID(#Image_List_NoSubcategory))
    
    AddGadgetItem(#Gadget_PiccyDb_Category, #AtTheEndOfTheList, "Favourites"        + #LF$ + #EmptyString  + #LF$ + #EmptyString, ImageID(#Image_List_Favourite))
    
    AddGadgetItem(#Gadget_PiccyDb_Category, #AtTheEndOfTheList, "Locked pictures"   + #LF$ + #EmptyString  + #LF$ + #EmptyString, ImageID(#Image_List_Locked))
    
    AddGadgetItem(#Gadget_PiccyDb_Category, #AtTheEndOfTheList, "Deleted pictures"  + #LF$ + #EmptyString  + #LF$ + #EmptyString, ImageID(#Image_List_Deleted))
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    While NextDatabaseRow(Program\DatabaseHandle)
      
      CatCategory.s  = KillQuote(GetDatabaseString(Program\DatabaseHandle,   #CategoryTitleColumn))
      
      CatItemcount.s = KillQuote(GetDatabaseString(Program\DatabaseHandle,   #CategoryItemsColumn))
      
      CatRecord.s    =           GetDatabaseString(Program\DatabaseHandle,   #CategoryRecordColumn) 
      
      AddGadgetItem(#Gadget_PiccyDb_Category, #AtTheEndOfTheList, CatCategory.s + " ("  + CatItemcount.s + ")" + #LF$ + CatItemcount.s + #LF$ + CatRecord.s, ImageID(#Image_List_Normal))
      
    Wend
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    FinishDatabaseQuery(Program\DatabaseHandle)
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    If CountGadgetItems(#Gadget_PiccyDb_Category) <> #NoItems
      
      SetGadgetState(#Gadget_PiccyDb_Category, #FirstItem)
      
      ; Debug "We are in LoadCategories()"
      
      PostEvent(#PB_Event_Gadget, #Window_PiccyDb, #Gadget_PiccyDb_Category, #PB_EventType_Change)
      
    EndIf
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
  Else
    
    SetInfoBarArea("Headings", "Error", "Could not retrieve categories from the database. " + DatabaseError(), "LoadCategories")
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------

EndProcedure

; IDE Options = PureBasic 5.31 (Windows - x86)
; CursorPosition = 87
; FirstLine = 30
; Folding = -
; EnableXP
; HideErrorLog