﻿;==========================================================================================================================================================
; Save the changed category data to the database
;==========================================================================================================================================================

Procedure SaveCategory()
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  CategoryString.s = RepQuote(GetGadgetText(#Gadget_PiccyCategory_Category))
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  If CategoryString.s <> #EmptyString
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    Select Program\LastWindow
        
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
        
      Case  "Add A New Category"
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        DatabaseUpdate.s = "INSERT INTO Categories(Category) VALUES('" + CategoryString.s + "')"
        
        ;------------------------------------------------------------------------------------------
        ; Now update the database with the new record
        ;------------------------------------------------------------------------------------------
        
        If DatabaseUpdate(Program\DatabaseHandle, DatabaseUpdate.s) <> #DatabaseUpdateFail
          
          ;----------------------------------------------------------------------------------------
          ; Get the new record number if any
          ;----------------------------------------------------------------------------------------
          
          NewRecordNumber.s = DatabaseLastInsertRowId()
          
          ;----------------------------------------------------------------------------------------
          ; Proceed if we got a record number
          ;----------------------------------------------------------------------------------------
          
          If NewRecordNumber.s  <> #EmptyString
            
            ;--------------------------------------------------------------------------------------
            ; Display the new string of data
            ;--------------------------------------------------------------------------------------
            
            AddGadgetItem(#Gadget_PiccyDb_Category, #AtTheEndOfTheList, CategoryString.s + #LF$ + #EmptyString + #LF$ + NewRecordNumber.s, ImageID(#Image_List_Normal))
            
            ;--------------------------------------------------------------------------------------
            ; 
            ;--------------------------------------------------------------------------------------
            
          Else
            
            SetInfoBarArea("Headings", "Error", "Database failed to be updated so we didn't get a new record number.", "SaveCategory")
            
          EndIf
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
        Else
          
          SetInfoBarArea("Headings", "Error", "The database query failed or was empty. " + DatabaseError(), "SaveCategory")
          
        EndIf
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
      Case  "Edit An Old Category"
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        DatabaseUpdate.s = "UPDATE Categories "
        
        DatabaseUpdate.s + "SET Category = '" + CategoryString.s       + "' "
        
        DatabaseUpdate.s + "WHERE Record = '" + Program\CurrentRecord  + "'"
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        If DatabaseUpdate(Program\DatabaseHandle, DatabaseUpdate.s) <> #DatabaseUpdateFail
          
          ;----------------------------------------------------------------------------------------
          ; Display the new or edited string of data
          ;----------------------------------------------------------------------------------------
          
          SetGadgetItemText(#Gadget_PiccyDb_Category, Program\CurrentLine, KillQuote(CategoryString.s), #CategoryTitleColumn)
          
          ;----------------------------------------------------------------------------------------
          ; Create the main table category update
          ;----------------------------------------------------------------------------------------
          
          DatabaseUpdate.s = "UPDATE PictureInfo SET Category = '"  + CategoryString.s           + "' "
          
          DatabaseUpdate.s + "WHERE Category = '"                   + Program\OldCategoryString  + "'"
          
          ;----------------------------------------------------------------------------------------
          
          ; Update main table when category string has changed
          ;----------------------------------------------------------------------------------------
          
          If DatabaseUpdate(Program\DatabaseHandle, DatabaseUpdate.s) <> #DatabaseUpdateFail
            
            SetInfoBarArea("Headings", "Info", "Categories updated in main database with new category name.", "SaveCategory")
            
          Else
            
            SetInfoBarArea("Headings", "Error", "Could not update categories in main database with new category.", "SaveCategory")
            
          EndIf
          
          ;----------------------------------------------------------------------------------------
          ; Tell the user about the new update
          ;----------------------------------------------------------------------------------------
          
          SetInfoBarArea("Headings", "Info", "Old record: " + Program\CurrentRecord + ", " + KillQuote(CategoryString.s) + " has been saved to the database.", "SaveCategory")
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
        Else
          
          SetInfoBarArea("Headings", "Error", "The database query failed or was empty. " + DatabaseError(), "SaveCategory")
          
        EndIf
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
    EndSelect
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    CloseMyWindow(#Window_PiccyCategory)
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------

    UpdateCategoryItemCount(CategoryString.s)
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    SortCategoryEntries()
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
  Else
    
    SetInfoBarArea("Headings", "Warn", "The category string was empty, there is nothing to save.", "SaveCategory")
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure


; IDE Options = PureBasic 5.31 (Windows - x86)
; CursorPosition = 187
; FirstLine = 130
; Folding = -
; EnableXP
; HideErrorLog