﻿;==============================================================================================================================================================================
; Show the  category selected in the category tree
;==============================================================================================================================================================================

Procedure ShowCategory()
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  CurrentLine.i = GetGadgetState(#Gadget_PiccyDb_Category)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  If CurrentLine <> #NothingSelected
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    CurrentCategory.s = RepQuote(Trim(StringField(GetGadgetItemText(#Gadget_PiccyDb_Category, CurrentLine.i, #CategoryTitleColumn), 1, "(")))
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    If CurrentCategory.s <> #EmptyString
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      SetGadgetItemText(#Gadget_PiccyDb_Titles, #ListIconHeadingArea, ">> ", #TitleColumn)
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      ClearGadgetItems(#Gadget_PiccyDb_Titles)
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      Select CurrentCategory.s

        ;------------------------------------------------------------------------------------------
        ; Select the chosen category display parameters
        ;------------------------------------------------------------------------------------------
          
        Case "All pictures"
          
          ;----------------------------------------------------------------------------------------
          ; Show all pictures except for deleted, favourite or locked pictures
          ;----------------------------------------------------------------------------------------
          
          QueryString.s   = "SELECT * FROM PictureInfo WHERE Title <> '' "
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
        Case "No title"      ; Where the title is empty
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
          QueryString.s   = "SELECT * FROM PictureInfo WHERE Title = '' "
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
        Case "No category"      ; Where the title isn't empty and isn't marked deleted
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
          QueryString.s   = "SELECT * FROM PictureInfo WHERE Category = '' "
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
        Case "No subcategory"      ; Where the title isn't empty and isn't marked deleted
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
          QueryString.s   = "SELECT * FROM PictureInfo WHERE Subcategory = '' OR Subcategory IS NULL "
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
        Case "Favourites"     ; Where the title isn't empty and the title is a favourite and isn't marked deleted
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
          QueryString.s   = "SELECT * FROM PictureInfo WHERE Favourite = '1' "
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
        Case "Locked pictures"   ; Where the title isn't empty and the title is locked and isn't marked deleted
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
          QueryString.s   = "SELECT * FROM PictureInfo WHERE Locked = '1' "
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
        Case "Deleted pictures"  ; Where the item is marked deleted
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
          QueryString.s   = "SELECT * FROM PictureInfo WHERE Deleted = '1' "
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
        Default
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
          QueryString.s   = "SELECT * FROM PictureInfo WHERE Category = '" + CurrentCategory.s + "' "
          
;           QueryString.s   + "AND Favourite <> '1' "
;           
;           QueryString.s   + "AND Deleted <> '1' "
;           
;           QueryString.s   + "AND Locked <> '1' "
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
      EndSelect
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      QueryString.s + "ORDER BY Title ASC"
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      PseudoCounter.i         = #NoItems
      
      DeletedPseudoCounter.i  = #NoItems
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      If DatabaseQuery(Program\DatabaseHandle,  QueryString.s)  <> #DatabaseQueryFail
        
        While NextDatabaseRow(Program\DatabaseHandle)
          
          Picture\Title           = KillQuote(GetDatabaseString(Program\DatabaseHandle,  0))
          
          Picture\Artist          = KillQuote(GetDatabaseString(Program\DatabaseHandle,  1))
          
          Picture\Copyright       = KillQuote(GetDatabaseString(Program\DatabaseHandle,  2))
          
          Picture\Homepage        = KillQuote(GetDatabaseString(Program\DatabaseHandle,  3))
          
          Picture\Category        = KillQuote(GetDatabaseString(Program\DatabaseHandle,  4))
          
          Picture\Subcategory     = KillQuote(GetDatabaseString(Program\DatabaseHandle,  5))
          
          Picture\Comment         = KillQuote(GetDatabaseString(Program\DatabaseHandle,  6))
          
          Picture\Directory       = KillQuote(GetDatabaseString(Program\DatabaseHandle,  7))
          
          Picture\Filename        = KillQuote(GetDatabaseString(Program\DatabaseHandle,  8))
          
          Picture\MD5Fingerprint  =           GetDatabaseString(Program\DatabaseHandle,  9)
          
          Picture\Created         =           GetDatabaseString(Program\DatabaseHandle, 10)
          
          Picture\Modified        =           GetDatabaseString(Program\DatabaseHandle, 11)
          
          Picture\Accessed        =           GetDatabaseString(Program\DatabaseHandle, 12)
          
          Picture\Archived        =           GetDatabaseString(Program\DatabaseHandle, 13)
          
          Picture\Horizontal      =           GetDatabaseString(Program\DatabaseHandle, 14)
          
          Picture\Vertical        =           GetDatabaseString(Program\DatabaseHandle, 15)
          
          Picture\Depth           =           GetDatabaseString(Program\DatabaseHandle, 16)
          
          Picture\Favourite       =           GetDatabaseString(Program\DatabaseHandle, 17) 
          
          Picture\Locked          =           GetDatabaseString(Program\DatabaseHandle, 18) 
          
          Picture\Deleted         =           GetDatabaseString(Program\DatabaseHandle, 19) 
          
          Picture\RecordId        =           GetDatabaseString(Program\DatabaseHandle, 20)
          
          ;         If Picture\Deleted  = "1"
          ;             
          ;           DeletedPseudoCounter.i + 1
          ;             
          ;         EndIf
          
          DisplayTitleString("AddMode", PseudoCounter.i)
          
          PseudoCounter.i + 1
          
        Wend
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        FinishDatabaseQuery(Program\DatabaseHandle)
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        SetGadgetItemText(#Gadget_PiccyDb_Category, #ListIconHeadingArea, "Category >> " + CurrentCategory.s, #TitleColumn)
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        If PseudoCounter.i = 0; And DeletedPseudoCounter.i = 0
          
          SetGadgetItemText(#Gadget_PiccyDb_Titles, #ListIconHeadingArea, ">> No items in [" + CurrentCategory.s + "]", #TitleColumn)
          
        Else
          
          If PseudoCounter.i = 0
            
            ItemMessage.s = " items in ["
            
          ElseIf PseudoCounter.i  = 1
            
            ItemMessage.s = " item in ["
            
          ElseIf PseudoCounter.i >= 2
            
            ItemMessage.s = " items in ["
            
          EndIf
          
          SetGadgetItemText(#Gadget_PiccyDb_Titles, #ListIconHeadingArea, ">> " + Str(PseudoCounter.i) + ItemMessage.s + CurrentCategory.s + "]", #TitleColumn)
          
        EndIf
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        SetInfoBarArea("Records", #EmptyString, Str(PseudoCounter.i), "ShowCategory")
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        If CountGadgetItems(#Gadget_PiccyDb_Titles) <> #NoItems
          
          SetGadgetState(#Gadget_PiccyDb_Titles, #FirstItem)
          
          ; Debug "We are in ShowCategory()"
          
          PostEvent(#PB_Event_Gadget, #Window_PiccyDb, #Gadget_PiccyDb_Titles, #PB_EventType_Change)

        Else
          
          ResizeImage(#Image_PiccyData_picture, #MainPictureWidth, #MainPictureHeight, #PB_Image_Smooth)
          
          SetGadgetState(#Gadget_PiccyDb_picture,     ImageID(#Image_PiccyData_picture))
          
          SetGadgetText(#Gadget_PiccyDb_sCategory,    #EmptyString)
          
          SetGadgetText(#Gadget_PiccyDb_sSubcategory, #EmptyString)
          
          SetGadgetText(#Gadget_PiccyDb_Artist,       #EmptyString)
          
          SetGadgetText(#Gadget_PiccyDb_Copyright,    #EmptyString)
          
          SetGadgetText(#Gadget_PiccyDb_Homepage,     #EmptyString)
          
          SetGadgetText(#Gadget_PiccyDb_Comment,      #EmptyString)
          
          SetGadgetText(#Gadget_PiccyDb_created,      #EmptyString)
          
          SetGadgetText(#Gadget_PiccyDb_modified,     #EmptyString)
          
          SetGadgetText(#Gadget_PiccyDb_accessed,     #EmptyString)
          
          SetGadgetText(#Gadget_PiccyDb_archivedOn,   #EmptyString)
          
          SetGadgetText(#Gadget_PiccyDb_Horizontal,   #EmptyString)
          
          SetGadgetText(#Gadget_PiccyDb_Vertical,     #EmptyString)
          
          SetGadgetText(#Gadget_PiccyDb_Depth,        #EmptyString)

        EndIf

        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        SetInfoBarArea("Records", #EmptyString, Str(CountGadgetItems(#Gadget_PiccyDb_Titles)), "ShowCategory")
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
      Else
      
        SetInfoBarArea("Headings",  "Error",  "The database query has failed or was empty " + DatabaseError(), "ShowCategory")
        
      EndIf
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
    Else
      
      SetInfoBarArea("Headings",  "Info",  "No category string was found on that line.", "ShowCategory")
      
    EndIf
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
  Else
     
    SetInfoBarArea("Headings",  "Info",  "There is no current line selected.", "ShowCategory")
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure

; IDE Options = PureBasic 5.31 (Windows - x86)
; CursorPosition = 152
; FirstLine = 114
; Folding = -
; EnableXP
; HideErrorLog