﻿;==========================================================================================================================================================
; Based on sorting code from Reginald Venaglia
;==========================================================================================================================================================

Procedure SortCategoryEntries()
  
  ;------------------------------------------------------------------------------------------------
  ; Get number items in ListIcon
  ;------------------------------------------------------------------------------------------------
  
  NumberOfItems.i = CountGadgetItems(#Gadget_PiccyDb_Category)
  
  ;------------------------------------------------------------------------------------------------
  ; Get number of items in ListIcon. That's standard categories + 2
  ;------------------------------------------------------------------------------------------------
  
  If NumberOfItems.i > 8
    
    ;----------------------------------------------------------------------------------------------
    ; Get number items in ListIcon
    ;----------------------------------------------------------------------------------------------
    
    NewList Categories.CategoryData()
    
    ;----------------------------------------------------------------------------------------------
    ; Place each item text into the list. Must start at Zero
    ;----------------------------------------------------------------------------------------------
    
    For LoopCounter.i = 0 To NumberOfItems.i - 1
      
      AddElement(Categories())
      
      Categories()\Category      = GetGadgetItemText(#Gadget_PiccyDb_Category, LoopCounter.i, #CategoryTitleColumn)
      
      Categories()\ItemCount     = GetGadgetItemText(#Gadget_PiccyDb_Category, LoopCounter.i, #CategoryItemsColumn)
      
      Categories()\Record_Id     = GetGadgetItemText(#Gadget_PiccyDb_Category, LoopCounter.i, #CategoryRecordColumn)
      
    Next LoopCounter 
    
    ;----------------------------------------------------------------------------------------------
    ; Sort the Array in ascending order
    ;----------------------------------------------------------------------------------------------
    
    SortStructuredList(Categories(), #PB_Sort_Ascending, OffsetOf(CategoryData\Category), #PB_String, 7, ListIndex(Categories()))
    
    ;----------------------------------------------------------------------------------------------
    ; Now replace ListIcon Items from the sorted Array
    ;----------------------------------------------------------------------------------------------
    
    ForEach Categories()
      
      SetGadgetItemText(#Gadget_PiccyDb_Category, ListIndex(Categories()), Categories()\Category,     #CategoryTitleColumn)
      
      SetGadgetItemText(#Gadget_PiccyDb_Category, ListIndex(Categories()), Categories()\ItemCount,    #CategoryItemsColumn)
      
      SetGadgetItemText(#Gadget_PiccyDb_Category, ListIndex(Categories()), Categories()\Record_Id,    #CategoryRecordColumn)
      
      If HighlightString.s = Categories()\Category
        
        LineToHighLight.i  = ListIndex(Categories())
        
      EndIf
      
    Next Categories()
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    ClearList(Categories())
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    SetGadgetState(#Gadget_PiccyDb_Category, LineToHighLight.i)
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure

; IDE Options = PureBasic 5.31 (Windows - x86)
; CursorPosition = 89
; FirstLine = 42
; Folding = -
; EnableXP
; HideErrorLog