﻿;==============================================================================================================================================================================
; Update the category itemcount field each time we add, change or delete addresses or categories
;==============================================================================================================================================================================

Procedure UpdateCategoryItemCount(CategoryName.s)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  CategoryName.s  = RepQuote(CategoryName.s)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  DatabaseQuery.s = "SELECT COUNT(Category) "
  
  DatabaseQuery.s + "AS totalrecs FROM PictureInfo "
  
  DatabaseQuery.s + "WHERE Category = '"  + CategoryName.s + "'"
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  If DatabaseQuery(Program\DatabaseHandle, DatabaseQuery.s) <> #DatabaseQueryFail
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    While NextDatabaseRow(Program\DatabaseHandle) <> #NoItems
      
      CategoryCount.s = GetDatabaseString(Program\DatabaseHandle,  0)
      
    Wend
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    FinishDatabaseQuery(Program\DatabaseHandle)
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    DatabaseUpdate.s  = "UPDATE Categories "
    
    DatabaseUpdate.s  + "SET Itemcount = '"   + CategoryCount.s   + "' "
    
    DatabaseUpdate.s  + "WHERE Category = '"  + CategoryName.s    + "'"
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    If DatabaseUpdate(Program\DatabaseHandle, DatabaseUpdate.s) <> #DatabaseUpdateFail
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      CategoryListCount.i = CountGadgetItems(#Gadget_PiccyDb_Category)
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      If CategoryListCount.i <> #NoItems
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        For FindCategoryInList.i = 0 To CategoryListCount.i -1
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
          CategoryInList.s  = GetGadgetItemText(#Gadget_PiccyDb_Category, FindCategoryInList.i, #CategoryTitleColumn)
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
          If FindString(CategoryInList.s, "(", 1) <> #NothingFound
            
            CategoryInList.s = Trim(StringField(CategoryInList.s, 1, "("))
            
            If CategoryInList.s = CategoryName.s
              
              SetGadgetItemText(#Gadget_PiccyDb_Category, FindCategoryInList.i, CategoryInList.s  + " (" + CategoryCount.s + ")", #CategoryTitleColumn)
              
              SetGadgetItemText(#Gadget_PiccyDb_Category, FindCategoryInList.i, CategoryCount.s,                                  #CategoryItemsColumn)
              
            EndIf
            
          Else
            
            If CategoryInList.s = CategoryName.s
              
              SetGadgetItemText(#Gadget_PiccyDb_Category, FindCategoryInList.i, CategoryInList.s  + " (" + CategoryCount.s + ")", #CategoryTitleColumn)
              
              SetGadgetItemText(#Gadget_PiccyDb_Category, FindCategoryInList.i, CategoryCount.s,                                  #CategoryItemsColumn)
              
            EndIf
            
          EndIf
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
        Next FindCategoryInList.i
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
      EndIf
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
    Else
      
      SetInfoBarArea("Headings", "Error", "Could not update the category itemcount", "UpdateCategoryItemCount")
      
    EndIf
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
  Else
    
    SetInfoBarArea("Headings", "Error", "Could not get a count of the categories for the category string", "UpdateCategoryItemCount")
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure


; IDE Options = PureBasic 5.31 (Windows - x86)
; CursorPosition = 106
; FirstLine = 57
; Folding = -
; EnableAsm
; EnableUnicode
; EnableXP