﻿;==============================================================================================================================================================================
; Fade the window out gently, close it and reset the mutex
;==============================================================================================================================================================================

Procedure CloseMyWindow(Window.i)
  
  ;------------------------------------------------------------------------------------------------
  ; Get the current line number
  ;------------------------------------------------------------------------------------------------
  
  If Program\CurrentLine <> #NothingSelected
    
    FocusLine.i = Program\CurrentLine
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; Remove hover events for windows
  ;------------------------------------------------------------------------------------------------
  
  Select Window.i
      
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    Case #Window_PiccyDb
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      RemoveHoverGadget(#Gadget_PiccyDb_AddCategory)
      
      RemoveHoverGadget(#Gadget_PiccyDb_CopyCategory)
      
      RemoveHoverGadget(#Gadget_PiccyDb_DeleteCategory)
      
      RemoveHoverGadget(#Gadget_PiccyDb_EditCategory)
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      RemoveHoverGadget(#Gadget_PiccyDb_Add)
      
      RemoveHoverGadget(#Gadget_PiccyDb_Copy)
      
      RemoveHoverGadget(#Gadget_PiccyDb_Delete)
      
      RemoveHoverGadget(#Gadget_PiccyDb_Edit)
      
      RemoveHoverGadget(#Gadget_PiccyDb_Export)
      
      RemoveHoverGadget(#Gadget_PiccyDb_Import)
      
      RemoveHoverGadget(#Gadget_PiccyDb_Favourite)
      
      RemoveHoverGadget(#Gadget_PiccyDb_Kill)
      
      RemoveHoverGadget(#Gadget_PiccyDb_Lock)
      
      RemoveHoverGadget(#Gadget_PiccyDb_Save)
      
      RemoveHoverGadget(#Gadget_PiccyDb_Help)
      
      RemoveHoverGadget(#Gadget_PiccyDb_Exit)
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
    Case #Window_PiccyData
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      RemoveHoverGadget(#Gadget_PiccyData_Save)
      
      RemoveHoverGadget(#Gadget_PiccyData_Load)
      
      RemoveHoverGadget(#Gadget_PiccyData_Exit)
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
    Case #Window_PiccyViewer
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
  EndSelect
  
  ;------------------------------------------------------------------------------------------------
  ; Close the form window if it is not the master window
  ;------------------------------------------------------------------------------------------------
  
  CloseWindow(Window.i)
  
  ;------------------------------------------------------------------------------------------------
  ; Tell the user what just happened
  ;------------------------------------------------------------------------------------------------
  
  SetInfoBarArea("Headings",  "Info", "Window" + " (" + Program\LastWindow + ") was closed")
  
  ;------------------------------------------------------------------------------------------------
  ; Zero certain variables not from the main window when they are closed
  ;------------------------------------------------------------------------------------------------
  
  If Window.i <> #Window_PiccyDb
    
    ;----------------------------------------------------------------------------------------------
    ; Clear necessary variables
    ;----------------------------------------------------------------------------------------------
    
    Program\WindowMutex     = #False                                                              ; Make sure other windows can open now  
    
    Program\CurrentLine     = #NothingSelected                                                    ; Make sure no line can be selected accidentally
    
    Program\CurrentRecord   = #EmptyString                                                        ; Nullify the current record number to avoid mistakes
    
    Program\LastWindow      = #EmptyString                                                        ; Clear last used windows state
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; Refocus on main window and current record when data window is closed
  ;------------------------------------------------------------------------------------------------
  
  If Window.i <> #Window_PiccyDb
    
    DisableWindow(#Window_PiccyDb, #False)
    
    SetActiveWindow(#Window_PiccyDb)
    
    SetActiveGadget(#Gadget_PiccyDb_Titles)
    
    SetGadgetState(#Gadget_PiccyDb_Titles, FocusLine.i)
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure


; IDE Options = PureBasic 5.31 (Windows - x86)
; CursorPosition = 154
; FirstLine = 98
; Folding = -
; EnableXP