﻿;==============================================================================================================================================================================
; Read the program toggles and search options from the database
;==============================================================================================================================================================================

Procedure ReadProgramOptions()
  
  ;------------------------------------------------------------------------------------------------
  ;
  ;------------------------------------------------------------------------------------------------
  
  QueryString.s = "SELECT * FROM Options WHERE Record_Id = '1'"
  
  ;------------------------------------------------------------------------------------------------
  ;
  ;------------------------------------------------------------------------------------------------
  
  If DatabaseQuery(Program\DatabaseHandle, QueryString.s)
    
    ;----------------------------------------------------------------------------------------------
    ;
    ;----------------------------------------------------------------------------------------------
    
    While NextDatabaseRow(Program\DatabaseHandle)
      
      ;--------------------------------------------------------------------------------------------
      ; Toggle-enabled options
      ;--------------------------------------------------------------------------------------------
      
      Setup\TitleClock      =       Val(GetDatabaseString(Program\DatabaseHandle,  0))  ; 1 or 0
      
      Setup\StickyWindow    =       Val(GetDatabaseString(Program\DatabaseHandle,  1))  ; 1 or 0
      
      Setup\ScreenSnap      =       Val(GetDatabaseString(Program\DatabaseHandle,  2))  ; 1 or 0
      
      ;--------------------------------------------------------------------------------------------
      ; Standard options
      ;--------------------------------------------------------------------------------------------
      
      Setup\LastSearch      = KillQuote(GetDatabaseString(Program\DatabaseHandle,  3))  ; 'Doctor' etc
      
      ;--------------------------------------------------------------------------------------------
      ;
      ;--------------------------------------------------------------------------------------------
      
    Wend
    
    ;----------------------------------------------------------------------------------------------
    ;
    ;----------------------------------------------------------------------------------------------
    
    FinishDatabaseQuery(Program\DatabaseHandle)
    
    ;----------------------------------------------------------------------------------------------
    ;
    ;----------------------------------------------------------------------------------------------
    
  Else
    
    SetInfoBarArea("Headings",  "Error",  "Failed to read program options:  " + DatabaseError(), "ReadProgramOptions")
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ;
  ;------------------------------------------------------------------------------------------------
  
EndProcedure

; IDE Options = PureBasic 5.31 (Windows - x86)
; CursorPosition = 2
; FirstLine = 11
; Folding = -
; EnableXP