﻿;==============================================================================================================================================================================
; Send messages and error reports to the fake status bar area
;==============================================================================================================================================================================

Procedure SetInfoBarArea(FieldName.s, FieldStatus.s, MessageContent.s = "0", ModuleName.s = #EmptyString)
  
  ;------------------------------------------------------------------------------------------------
  ; Select the name of the field to put our heading string
  ;------------------------------------------------------------------------------------------------
  
  Select FieldName.s
      
    ;----------------------------------------------------------------------------------------------
    ; Select the correct heading by the status field
    ;----------------------------------------------------------------------------------------------
    
    Case "Headings"
    
      ;--------------------------------------------------------------------------------------------
      ; This is the field status heading and message
      ;--------------------------------------------------------------------------------------------
      
      Select FieldStatus.s
          
        Case "Welcome"
          
          MessageHeader.s = "Welcome"
          
          Colour.i        = $DB3D24
          
        Case "Info"
          
          MessageHeader.s = "Information"
          
          Colour.i        = $DB3D24
          
        Case "Tool"
          
          MessageHeader.s = "ToolTip"
          
          Colour.i        = $DB3D24
          
        Case "Document"
          
          MessageHeader.s = "Document"
          
          Colour.i        = $573D6A
          
        Case "Warn"
          
          MessageHeader.s = "Warning"
          
          Colour.i        = $7D1F82
          
        Case "Error"
          
          MessageHeader.s = "Error"
          
          Colour.i        = $0402FB
          
      EndSelect
      
      ;--------------------------------------------------------------------------------------------
      ; Send all the strings to the fake status bar area
      ;--------------------------------------------------------------------------------------------
      
      SetGadgetText(#Gadget_PiccyDb_Status,       MessageHeader.s)
      
      SetGadgetColor(#Gadget_PiccyDb_Status,      #PB_Gadget_FrontColor, Colour.i)
      
      SetGadgetText(#Gadget_PiccyDb_Messages,     MessageContent.s)
      
      SetGadgetColor(#Gadget_PiccyDb_Messages,    #PB_Gadget_FrontColor, Colour.i)
      
      ;--------------------------------------------------------------------------------------------
      ; This is the current record number field
      ;--------------------------------------------------------------------------------------------
      
    Case "Number"
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      SetGadgetText(#Gadget_PiccyDb_Number, "Record " + MessageContent.s)
      
      ;--------------------------------------------------------------------------------------------
      ; This is the number of displayed records field
      ;--------------------------------------------------------------------------------------------
      
    Case "Records"
      
      ;--------------------------------------------------------------------------------------------
      ; Figure out the correct spelling for the record field for singles or multiples
      ;--------------------------------------------------------------------------------------------
      
      If Val(MessageContent.s) = 0
        
        RecordHeader.s = "Items"
        
      ElseIf Val(MessageContent.s)  = 1
        
        RecordHeader.s = "Item"
        
      ElseIf Val(MessageContent.s) >= 2
        
        RecordHeader.s = "Items"
        
      EndIf
      
      ;--------------------------------------------------------------------------------------------
      ; Set the record number details in the fake status bar area
      ;--------------------------------------------------------------------------------------------
      
      SetGadgetText(#Gadget_PiccyDb_Records, MessageContent.s + " " + RecordHeader.s)
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
  EndSelect
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure


; IDE Options = PureBasic 5.31 (Windows - x86)
; CursorPosition = 4
; FirstLine = 72
; Folding = -
; EnableXP