﻿;==============================================================================================================================================================================
; 
;==============================================================================================================================================================================

Procedure WindowCallback(WindowID.i, Message.i, wParam.i, lParam.i)
  
  ;------------------------------------------------------------------------------------------------
  ; Netmaestro's windowsnap code
  ;------------------------------------------------------------------------------------------------

  Static Snapped1.i, Snapped2.i, Snapped3.i, Snapped4.i

  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  ReturnValue.i = #PB_ProcessPureBasicEvents
  
  ;------------------------------------------------------------------------------------------------
  ; Netmaestro's windowsnap code
  ;------------------------------------------------------------------------------------------------
  
  If Setup\ScreenSnap = #True
    
    If Message.i = #WM_MOVING                                                             ; Netmaestro's windowsnap code
  
      *view.RECT = lparam
  
      curwidth  = *view\right - *view\left
  
      curheight = *view\bottom - *view\top
  
      If AutoSnap                                                                         ; AutoSnap Section
  
        If *view\left < SnapD
  
          If Not Snapped1
  
            *view\left = 0
  
            *view\right = curwidth
  
            snapped1 = #True
  
            ReturnValue = #True
  
          EndIf
  
        Else
  
          snapped1 = #False
  
        EndIf
  
        If *view\top < SnapD
  
          If Not Snapped2
  
            *view\top = 0
  
            *view\bottom = curheight
  
            snapped2 = #True
  
            ReturnValue = #True
  
          EndIf
  
        Else
  
          snapped2 = #False
  
        EndIf
  
        If *view\right > screenw - SnapD
  
          If Not Snapped3
  
            *view\left  = ScreenW - curwidth
  
            *view\right = screenW
  
            snapped3 = #True
  
            ReturnValue = #True
  
          EndIf
  
        Else
  
          snapped3 = #False
  
        EndIf     
  
        If *view\bottom > screenH - SnapD
  
          If Not Snapped4
  
            *view\top = screenH - curheight
  
            *view\bottom = screenH
  
            snapped4 = #True
  
            ReturnValue = #True
  
          EndIf
  
        Else
  
          snapped4 = #False
  
        EndIf     
  
      EndIf
  
      If *view\top < 0                                                                    ;  Inside Desktop Section
  
        *view\top = 0
  
        *view\bottom = curheight
  
      EndIf
  
      If *view\left < 0 
  
        *view\left = 0
  
        *view\right = curwidth
  
      EndIf
  
      If *view\right > screenW
  
        *view\right = screenW
  
        *view\left = *view\right - curwidth
  
      EndIf
  
      If *view\bottom > screenH
  
        *view\bottom = screenH
  
        *view\top = *view\bottom - curheight
  
      EndIf
  
      MoveWindow_(WindowID, *view\left, *view\top, *view\right - *view\left, *view\bottom - *view\top, #True)
  
      ReturnValue = #True
  
    EndIf
    
  EndIf

  ;------------------------------------------------------------------------------------------------
  ;
  ;------------------------------------------------------------------------------------------------
  
  If Message.i =  #WM_NOTIFY
    
    *nmhdr.NMHDR = lParam
    
    *lvCD.NMLVCUSTOMDRAW = lParam
    
    If *lvCD\nmcd\hdr\hwndFrom = GadgetID(#Gadget_PiccyDb_Titles) And *lvCD\nmcd\hdr\code = #NM_CUSTOMDRAW
      
      Select *lvCD\nmcd\dwDrawStage
          
        Case #CDDS_PREPAINT
          
          ReturnValue.i = #CDRF_NOTIFYITEMDRAW
          
        Case #CDDS_ITEMPREPAINT
          
          ReturnValue.i = #CDRF_NOTIFYSUBITEMDRAW;
          
        Case #CDDS_ITEMPREPAINT | #CDDS_SUBITEM
          
          thisRow = *lvCD\nmcd\dwItemSpec
          
          thisCol = *lvCD\iSubItem
          
          on_off = GetGadgetItemData(#Gadget_PiccyDb_Titles, thisRow)
          
          ;         If thisCol =  0 And on_off   ; Specifically for column 0. You can change this to any
          
          ;         or just use on_off to set all columns
          
          If on_off
            
            SelectObject_(*lvCD\nmcd\hdc, FontID(#FontStrikeoutYes))
            
            ReturnValue.i = #CDRF_NEWFONT; | #CDRF_DODEFAULT
            
          Else
            
            SelectObject_(*lvCD\nmcd\hdc, FontID(#FontStrikeoutNo))
            
            ReturnValue.i = #CDRF_NEWFONT   
            
          EndIf
          
      EndSelect
      
    EndIf
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  ProcedureReturn ReturnValue.i
  
  ;------------------------------------------------------------------------------------------------
  ;
  ;------------------------------------------------------------------------------------------------
  
EndProcedure
  

; IDE Options = PureBasic 5.31 (Windows - x86)
; CursorPosition = 222
; FirstLine = 164
; Folding = -
; EnableXP
; HideErrorLog