﻿;==============================================================================================================================================================================
; Add an entire folder of pictures
;==============================================================================================================================================================================

Procedure   AddPictureFolder()
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  PicturesToLoad.s = OpenFileRequester("Select picture", #EmptyString, "Jpeg (*.jpg *.jpeg *.jfif)|*.jpg;*.jpeg;*.jfif|Bitmap (*.bmp)|*.bmp|Targa (*.tga)|*.tga|Tiff (*.tif)|*.tif|Png (*.png)|*.png|Icon (*.ico)|*.ico|All files (*.*)|*.*", 0, #PB_Requester_MultiSelection)
  
  ;------------------------------------------------------------------------------------------------
  ; Tell our database we want to create a mass import for speed
  ;------------------------------------------------------------------------------------------------
  
  DatabaseUpdate(Program\DatabaseHandle, "Begin Transaction")
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  While PicturesToLoad.s  <> #EmptyString
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    ImageNumber.i = LoadImage(#PB_Any, PicturesToLoad.s)
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    If ImageNumber.i
      
      ;--------------------------------------------------------------------------------------------
      ;
      ;--------------------------------------------------------------------------------------------
      
      TitleString.s     = RepQuote(GetFilePart(PicturesToLoad.s))
      
      ExtensionString.s = RepQuote(GetExtensionPart(PicturesToLoad.s))
      
      ExtensionLength.i = Len(ExtensionString.s)
      
      If ExtensionLength.i <> 0
        
        TitleString.s = Left(TitleString.s, Len(TitleString.s) - ExtensionLength.i - 1)
        
      EndIf
      
      
      ;--------------------------------------------------------------------------------------------
      ;
      ;--------------------------------------------------------------------------------------------
      
      Picture\Title           = TitleString.s
      
      Picture\Artist          = #EmptyString
      
      Picture\Copyright       = #EmptyString
      
      Picture\Homepage        = #EmptyString
      
      Picture\Category        = #EmptyString
      
      Picture\Subcategory     = #EmptyString
      
      Picture\Comment         = "Mass imported picture"
      
      Picture\Directory       = RepQuote(GetPathPart(PicturesToLoad.s))
      
      Picture\FileName        = RepQuote(GetFilePart(PicturesToLoad.s))
      
      Picture\Md5Fingerprint  = MD5FileFingerprint(PicturesToLoad.s)
      
      Picture\Created         = IsoDate(FormatDate("%dd/%mm/%yyyy", GetFileDate(PicturesToLoad.s, #PB_Date_Created)),   "IsoDate")
      
      Picture\Modified        = IsoDate(FormatDate("%dd/%mm/%yyyy", GetFileDate(PicturesToLoad.s, #PB_Date_Accessed)),  "IsoDate")
      
      Picture\Accessed        = IsoDate(FormatDate("%dd/%mm/%yyyy", GetFileDate(PicturesToLoad.s, #PB_Date_Modified)),  "IsoDate")
      
      Picture\Archived        = IsoDate(FormatDate("%dd/%mm/%yyyy", Date()), "IsoDate")
      
      Picture\Horizontal      = Str(ImageWidth(ImageNumber.i))
      
      Picture\Vertical        = Str(ImageHeight(ImageNumber.i))
      
      Picture\Depth           = Str(ImageDepth(ImageNumber.i))
      
      Picture\Favourite       = "0"
      
      Picture\Locked          = "0"
      
      Picture\Deleted         = "0"
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      FreeImage(ImageNumber.i)
      
      ;--------------------------------------------------------------------------------------------
      ;
      ;--------------------------------------------------------------------------------------------
      
      DatabaseUpdate.s  = "INSERT INTO PictureInfo("
      
      DatabaseUpdate.s  + "Title, Artist, Copyright, Homepage, Category, Subcategory, Comment, "
      
      DatabaseUpdate.s  + "Directory, Filename, MD5Fingerprint, Created, Modified, Accessed, "
      
      DatabaseUpdate.s  + "Archived, Horizontal, Vertical, Depth, Favourite, Locked, Deleted) "
      
      DatabaseUpdate.s  + "VALUES("
      
      DatabaseUpdate.s  + "'"   +   Picture\Title           + "',"
      
      DatabaseUpdate.s  + "'"   +   Picture\Artist          + "',"
      
      DatabaseUpdate.s  + "'"   +   Picture\Copyright       + "',"
      
      DatabaseUpdate.s  + "'"   +   Picture\Homepage        + "',"
      
      DatabaseUpdate.s  + "'"   +   Picture\Category        + "',"
      
      DatabaseUpdate.s  + "'"   +   Picture\Subcategory     + "',"
      
      DatabaseUpdate.s  + "'"   +   Picture\Comment         + "',"
      
      DatabaseUpdate.s  + "'"   +   Picture\Directory       + "',"
      
      DatabaseUpdate.s  + "'"   +   Picture\FileName        + "',"
      
      DatabaseUpdate.s  + "'"   +   Picture\Md5Fingerprint  + "',"
      
      DatabaseUpdate.s  + "'"   +   Picture\Created         + "',"
      
      DatabaseUpdate.s  + "'"   +   Picture\Modified        + "',"
      
      DatabaseUpdate.s  + "'"   +   Picture\Accessed        + "',"
      
      DatabaseUpdate.s  + "'"   +   Picture\Archived        + "',"
      
      DatabaseUpdate.s  + "'"   +   Picture\Horizontal      + "',"
      
      DatabaseUpdate.s  + "'"   +   Picture\Vertical        + "',"
      
      DatabaseUpdate.s  + "'"   +   Picture\Depth           + "',"
      
      DatabaseUpdate.s  + "'"   +   Picture\Favourite       + "',"
      
      DatabaseUpdate.s  + "'"   +   Picture\Locked          + "',"
      
      DatabaseUpdate.s  + "'"   +   Picture\Deleted         + "'"
      
      DatabaseUpdate.s  + ")"
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      If DatabaseUpdate(Program\DatabaseHandle, DatabaseUpdate.s) <> #DatabaseUpdateFail
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        Picture\RecordId = DatabaseLastInsertRowId()
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        If Picture\RecordId <> #EmptyString
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
          If PicturesToLoad.s  <> #EmptyString
            
            ;--------------------------------------------------------------------------------------
            ; 
            ;--------------------------------------------------------------------------------------
            
            FileIn.i = ReadFile(#PB_Any, PicturesToLoad.s)
            
            ;--------------------------------------------------------------------------------------
            ; 
            ;--------------------------------------------------------------------------------------
            
            If FileIn.i
              
              ;------------------------------------------------------------------------------------
              ; 
              ;------------------------------------------------------------------------------------
              
              FileInSize.i = Lof(FileIn.i)
              
              ;------------------------------------------------------------------------------------
              ; 
              ;------------------------------------------------------------------------------------
              
              *Buffer = AllocateMemory(FileInSize.i)
              
              ;------------------------------------------------------------------------------------
              ; 
              ;------------------------------------------------------------------------------------
              
              If *Buffer
                
                ;----------------------------------------------------------------------------------
                ; 
                ;----------------------------------------------------------------------------------
                
                If ReadData(FileIn.i, *Buffer, FileInSize.i) = FileInSize.i
                  
                  ;--------------------------------------------------------------------------------
                  ; 
                  ;--------------------------------------------------------------------------------
                  
                  SetDatabaseBlob(Program\DatabaseHandle, 0, *Buffer, FileInSize.i)
                  
                  ;--------------------------------------------------------------------------------
                  ; 
                  ;--------------------------------------------------------------------------------
                  
                  DatabaseUpdate.s = "INSERT INTO PictureData ("
                  
                  DatabaseUpdate.s + "Picture, Record_Id) "
                  
                  DatabaseUpdate.s + "VALUES (?, '" + Picture\RecordId + "')"
                  
                  ;--------------------------------------------------------------------------------
                  ; 
                  ;--------------------------------------------------------------------------------
                  
                  If DatabaseUpdate(Program\DatabaseHandle, DatabaseUpdate.s) <> #DatabaseUpdateFail
                    
                    ;------------------------------------------------------------------------------
                    ; 
                    ;------------------------------------------------------------------------------
                    
                    NewRecord.s = DatabaseLastInsertRowId()
                    
                    ;------------------------------------------------------------------------------
                    ; 
                    ;------------------------------------------------------------------------------
                    
                    If NewRecord.s <> #EmptyString
                      
                      NewNumberOfItems.i = CountGadgetItems(#Gadget_PiccyDb_Titles)
                      
                      DisplayTitleString("AddMode", NewNumberOfItems.i)
                      
                      LastLine(#Gadget_PiccyDb_Titles, NewNumberOfItems.i)
                      
                      Program\CurrentLine = NewNumberOfItems.i
                      
                      ; Let user know that the actual picture data was saved
                      
                    Else
                      
                      SetInfoBarArea("Headings", "Error", "Could not get a new record number for picture data", "SavePictureData()")
                      
                    EndIf
                    
                    ;------------------------------------------------------------------------------
                    ; 
                    ;------------------------------------------------------------------------------
                    
                  Else
                    
                    SetInfoBarArea("Headings", "Error", "Could not save the picture data into the database", "SavePictureData()")
                    
                  EndIf
                  
                  ;--------------------------------------------------------------------------------
                  ; 
                  ;--------------------------------------------------------------------------------
                  
                Else
                  
                  SetInfoBarArea("Headings", "Error", "Could not read the picture data into the buffer", "SavePictureData()")
                  
                EndIf
                
                ;----------------------------------------------------------------------------------
                ; 
                ;----------------------------------------------------------------------------------
                
                FreeMemory(*Buffer)
                
                ;----------------------------------------------------------------------------------
                ; 
                ;----------------------------------------------------------------------------------
                
              Else
                
                SetInfoBarArea("Headings", "Error", "Could not allocate a buffer for the picture data", "SavePictureData()")
                
              EndIf
              
              ;------------------------------------------------------------------------------------
              ; 
              ;------------------------------------------------------------------------------------
              
              CloseFile(FileIn.i)
              
              ;------------------------------------------------------------------------------------
              ; 
              ;------------------------------------------------------------------------------------
              
            Else
              
              SetInfoBarArea("Headings", "Error", "Could not open the designated file to read from", "SavePictureData()")
              
            EndIf
            
            ;--------------------------------------------------------------------------------------
            ; 
            ;--------------------------------------------------------------------------------------
            
          Else
            
            SetInfoBarArea("Headings", "Error", "Picture filename is empty, nothing to save", "SavePictureData()")
            
          EndIf
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
        Else
          
          SetInfoBarArea("Headings",  "Error",  "No record number created " + DatabaseError(), "SaveCurrentPicture")
          
        EndIf
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
      Else
        
        SetInfoBarArea("Headings", "Error", "Database table failed to be updated " + DatabaseError(), "SaveCurrentPicture")
        
      EndIf
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      PicturesToLoad.s = NextSelectedFileName() 
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
    Else
      
      SetInfoBarArea("Headings", "Error", "Could not read image dimensions from loaded image", "SaveCurrentPicture")
      
    EndIf
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
  Wend 
  
  ;------------------------------------------------------------------------------------------------
  ; Commit all your database updates at this point
  ;------------------------------------------------------------------------------------------------
  
  DatabaseUpdate(Program\DatabaseHandle, "Commit")
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure

;   PictureToLoad.s = OpenFileRequester("Select picture", #EmptyString, "Jpeg (*.jpg *.jpeg *.jfif)|*.jpg;*.jpeg;*.jfif|Bitmap (*.bmp)|*.bmp|Targa (*.tga)|*.tga|Tiff (*.tif)|*.tif|Png (*.png)|*.png|Icon (*.ico)|*.ico|All files (*.*)|*.*", 0)
;   If PictureToLoad.s
;     ImageNumber.i = LoadImage(#PB_Any, PictureToLoad.s)
;     If ImageNumber.i
;       ; 
;       Select ImageFormat(ImageNumber.i)
;         Case #PB_ImagePlugin_JPEG     : ImageFormatType.s = "Joint photographics experts group"
;         Case #PB_ImagePlugin_JPEG2000 : ImageFormatType.s = "Jpeg 2000"
;         Case #PB_ImagePlugin_PNG      : ImageFormatType.s = "Portable network graphic"
;         Case #PB_ImagePlugin_TGA      : ImageFormatType.s = "Targa"
;         Case #PB_ImagePlugin_TIFF     : ImageFormatType.s = "Tagged image file format"
;         Case #PB_ImagePlugin_BMP      : ImageFormatType.s = "Bitmap"
;         Case #PB_ImagePlugin_ICON     : ImageFormatType.s = "Windows icon"
;       EndSelect
;       ;
;       Debug "File path:       "   + GetPathPart(PictureToLoad.s))
;       Debug "File name:       "   + GetFilePart(PictureToLoad.s))
;       Debug "Created on:      "   + FormatDate("%dd/%mm/%yyyy", GetFileDate(PictureToLoad.s, #PB_Date_Created))
;       Debug "Last accessed:   "   + FormatDate("%dd/%mm/%yyyy", GetFileDate(PictureToLoad.s, #PB_Date_Accessed))
;       Debug "Last modified:   "   + FormatDate("%dd/%mm/%yyyy", GetFileDate(PictureToLoad.s, #PB_Date_Modified))
;       Debug "Stored on:       "   + FormatDate("%dd/%mm/%yyyy", Date()))
;       Debug "Width:           "   + Str(ImageWidth(ImageNumber.i))
;       Debug "Height:          "   + Str(ImageHeight(ImageNumber.i))
;       Debug "Depth:           "   + Str(ImageDepth(ImageNumber.i))
;       Debug "Graphic type:    "   + ImageFormatType.s
;       Debug "MD5 Fingerprint: "   + MD5FileFingerprint(PictureToLoad.s)
;       Debug "Category:        "   + "Unknown"
;       Debug "Coment:          "   + "Mass imported"
;     EndIf
;   EndIf

; IDE Options = PureBasic 5.31 (Windows - x86)
; CursorPosition = 415
; FirstLine = 370
; Folding = -
; EnableAsm
; EnableUnicode
; EnableXP