﻿;==============================================================================================================================================================================
; Attach a new picture to the record editor form
;==============================================================================================================================================================================

Procedure AttachPicture()
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  PictureToLoad.s = OpenFileRequester("Select picture", "", "Jpeg (*.jpg *.jpeg *.jfif)|*.jpg;*.jpeg;*.jfif|Bitmap (*.bmp)|*.bmp|Targa (*.tga)|*.tga|Tiff (*.tif)|*.tif|Png (*.png)|*.png|Icon (*.ico)|*.ico|All files (*.*)|*.*", 0)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  If PictureToLoad.s  <> #EmptyString
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    ImageNumber.i = LoadImage(#PB_Any, PictureToLoad.s)
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    OriginalWidth.s   = Str(ImageWidth(ImageNumber.i))
    
    OriginalHeight.s  = Str(ImageHeight(ImageNumber.i))
    
    OriginalDepth.s   = Str(ImageDepth(ImageNumber.i))
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    If ImageNumber.i <> #NoPictureHandle
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      ResizeImage(ImageNumber.i, #DataPictureWidth, #DataPictureHeight, #PB_Image_Smooth)
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      SetGadgetState(#Gadget_PiccyData_picture, ImageID(ImageNumber.i))
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      Program\NewPictureName = PictureToLoad.s
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      SetGadgetText(#Gadget_PiccyData_Directory,      GetPathPart(PictureToLoad.s))        
      
      SetGadgetText(#Gadget_PiccyData_Filename,       GetFilePart(PictureToLoad.s))
      
      SetGadgetText(#Gadget_PiccyData_created,        FormatDate("%dd/%mm/%yyyy", GetFileDate(PictureToLoad.s, #PB_Date_Created)))
      
      SetGadgetText(#Gadget_PiccyData_modified,       FormatDate("%dd/%mm/%yyyy", GetFileDate(PictureToLoad.s, #PB_Date_Accessed)))
      
      SetGadgetText(#Gadget_PiccyData_accessed,       FormatDate("%dd/%mm/%yyyy", GetFileDate(PictureToLoad.s, #PB_Date_Modified)))
      
      SetGadgetText(#Gadget_PiccyData_archivedOn,     FormatDate("%dd/%mm/%yyyy", Date()))
      
      SetGadgetText(#Gadget_PiccyData_Horizontal,     OriginalWidth.s)
      
      SetGadgetText(#Gadget_PiccyData_Vertical,       OriginalHeight.s)
      
      SetGadgetText(#Gadget_PiccyData_Depth,          OriginalDepth.s)
      
      SetGadgetText(#Gadget_PiccyData_MD5Fingerprint, MD5FileFingerprint(PictureToLoad.s))
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
    Else
      
      SetInfoBarArea("Headings", "Warn", "Could not get the image handle, nothing loaded")
      
      Program\NewPictureName = #EmptyString
      
    EndIf
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
  Else
    
    SetInfoBarArea("Headings", "Warn", "Nothing to load, user cancelled the process")
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure

; IDE Options = PureBasic 5.31 (Windows - x86)
; FirstLine = 18
; Folding = -
; EnableXP