﻿;==========================================================================================================================================================
; Edit the currently selected picture
;==========================================================================================================================================================

Procedure EditCurrentPicture()
  
  ;------------------------------------------------------------------------------------------------
  ; Check if you can get a currently selected line
  ;------------------------------------------------------------------------------------------------
  
  Program\CurrentLine = GetGadgetState(#Gadget_PiccyDb_Titles)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  If Program\CurrentLine <> #NothingSelected
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    Program\CurrentRecord = GetGadgetItemText(#Gadget_PiccyDb_Titles, Program\CurrentLine, #RecordColumn)
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    If Program\CurrentRecord <> #EmptyString
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      DeletedState.s   =  GetGadgetItemText(#Gadget_PiccyDb_Titles, Program\CurrentLine, #DeletedColumn)
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      If DeletedState.s <> "1"
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        LockedState.s   =  GetGadgetItemText(#Gadget_PiccyDb_Titles, Program\CurrentLine, #LockedColumn)
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        If LockedState.s <> "1"
          
          ;----------------------------------------------------------------------------------------
          ; Check if an existing window is opened
          ;----------------------------------------------------------------------------------------
          
          If Program\WindowMutex <> #True
            
            ;--------------------------------------------------------------------------------------
            ; Try to open the data form window
            ;--------------------------------------------------------------------------------------
            
            If Window_PiccyData()
              
              ;------------------------------------------------------------------------------------
              ; Window was opened so set mutex to prevent other windows from opening
              ;------------------------------------------------------------------------------------
              
              Program\WindowMutex = #True
              
              ;------------------------------------------------------------------------------------
              ; Prevent user input on the main window
              ;------------------------------------------------------------------------------------
              
              DisableWindow(#Window_PiccyDb, #True)
              
              ;------------------------------------------------------------------------------------
              ; Setup the common add window message
              ;------------------------------------------------------------------------------------
              
              Message.s = "Edit An Old Picture"
              
              ;------------------------------------------------------------------------------------
              ; Set the last window message for the closure routine later
              ;------------------------------------------------------------------------------------
              
              Program\LastWindow = Message.s
              
              ;------------------------------------------------------------------------------------
              ; Show new record number and status in the data window
              ;------------------------------------------------------------------------------------
              
              SetWindowTitle(#Window_PiccyData, Message.s)
              
              ;------------------------------------------------------------------------------------
              ; Add this forms' hover gadgets
              ;------------------------------------------------------------------------------------
              
              AddHoverGadget(GadgetID(#Gadget_PiccyData_Save))
              
              AddHoverGadget(GadgetID(#Gadget_PiccyData_Load))
              
              AddHoverGadget(GadgetID(#Gadget_PiccyData_Exit))
              
              ;------------------------------------------------------------------------------------
              ; Add the fast form close keyboard shortcut
              ;------------------------------------------------------------------------------------
              
              AddKeyboardShortcut(#Window_PiccyData, #PB_Shortcut_Escape,                   #Shortcut_CloseData)
              
              AddKeyboardShortcut(#Window_PiccyData, #PB_Shortcut_Alt    | #PB_Shortcut_S,  #Shortcut_SaveData)
              
              AddKeyboardShortcut(#Window_PiccyData, #PB_Shortcut_Alt    | #PB_Shortcut_X,  #Shortcut_ExitData)
              
              ;------------------------------------------------------------------------------------
              ; Remove borders from various gadgets
              ;------------------------------------------------------------------------------------
              
              RemoveBorders(#Gadget_PiccyData_Comment)

              ;------------------------------------------------------------------------------------
              ; 
              ;------------------------------------------------------------------------------------
              
              FillCombo(#Gadget_PiccyData_Category, "SELECT DISTINCT Category FROM Categories ORDER BY Category",     #Image_Combo_Category)
              
              AddGadgetItem(#Gadget_PiccyData_Category, #FirstItem, #EmptyString, ImageID(#Image_Combo_Empty))
              
              SetGadgetState(#Gadget_PiccyData_Category, #FirstItem)
              
              ;------------------------------------------------------------------------------------
              ; 
              ;------------------------------------------------------------------------------------
              
              ;               If DatabaseQuery(Program\DatabaseHandle, "SELECT DISTINCT Subcategory FROM PictureInfo ORDER BY Subcategory")
              ;                 
              ;                 While NextDatabaseRow(Program\DatabaseHandle)
              ;                   
              ;                   Debug GetDatabaseString(Program\DatabaseHandle, 0)
              ;                   
              ;                 Wend
              ;                 
              ;               EndIf
              
              ;------------------------------------------------------------------------------------
              ; 
              ;------------------------------------------------------------------------------------
              
              FillCombo(#Gadget_PiccyData_Subcategory, "SELECT DISTINCT Subcategory FROM PictureInfo ORDER BY Subcategory",     #Image_Combo_Subcategory)
              
              AddGadgetItem(#Gadget_PiccyData_Subcategory, #FirstItem, #EmptyString, ImageID(#Image_Combo_Empty))
              
              SetGadgetState(#Gadget_PiccyData_Subcategory, #FirstItem)
              
              ;------------------------------------------------------------------------------------
              ; 
              ;------------------------------------------------------------------------------------
              
              FillCombo(#Gadget_PiccyData_Artist, "SELECT DISTINCT Artist FROM PictureInfo ORDER BY Artist",          #Image_Combo_Artist)
              
              AddGadgetItem(#Gadget_PiccyData_Artist, #FirstItem, #EmptyString, ImageID(#Image_Combo_Empty))
              
              SetGadgetState(#Gadget_PiccyData_Artist, #FirstItem)
              
              ;------------------------------------------------------------------------------------
              ; 
              ;------------------------------------------------------------------------------------
              
              FillCombo(#Gadget_PiccyData_Copyright, "SELECT DISTINCT Copyright FROM PictureInfo ORDER BY Copyright", #Image_Combo_Copyright)
              
              AddGadgetItem(#Gadget_PiccyData_Copyright, #FirstItem, #EmptyString, ImageID(#Image_Combo_Empty))

              SetGadgetState(#Gadget_PiccyData_Copyright, #FirstItem)
              
              ;------------------------------------------------------------------------------------
              ; 
              ;------------------------------------------------------------------------------------
              
              FillCombo(#Gadget_PiccyData_Homepage, "SELECT DISTINCT Homepage FROM PictureInfo ORDER BY Homepage",    #Image_Combo_Homepage)
              
              AddGadgetItem(#Gadget_PiccyData_Homepage, #FirstItem, #EmptyString, ImageID(#Image_Combo_Empty))
              
              SetGadgetState(#Gadget_PiccyData_Homepage, #FirstItem)
              
              ;------------------------------------------------------------------------------------
              ; 
              ;------------------------------------------------------------------------------------
              
              QueryString.s = "SELECT m.*, n.Picture "
              
              QueryString.s + "FROM PictureInfo AS m, PictureData AS n "
              
              QueryString.s + "WHERE n.Record_Id = m.Record_Id "      
              
              QueryString.s + "AND m.Record_Id = '" + Program\CurrentRecord + "'"
              
              ;------------------------------------------------------------------------------------
              ; 
              ;------------------------------------------------------------------------------------
              
              If DatabaseQuery(Program\DatabaseHandle, QueryString.s) <> #DatabaseQueryFail
                
                While NextDatabaseRow(Program\DatabaseHandle)
                  
                  Picture\Title           = KillQuote(GetDatabaseString(Program\DatabaseHandle,  0))
                  
                  Picture\Artist          = KillQuote(GetDatabaseString(Program\DatabaseHandle,  1))
                  
                  Picture\Copyright       = KillQuote(GetDatabaseString(Program\DatabaseHandle,  2))
                  
                  Picture\Homepage        = KillQuote(GetDatabaseString(Program\DatabaseHandle,  3))
                  
                  Picture\Category        = KillQuote(GetDatabaseString(Program\DatabaseHandle,  4))
                  
                  Picture\Subcategory     = KillQuote(GetDatabaseString(Program\DatabaseHandle,  5))
                  
                  Picture\Comment         = KillQuote(GetDatabaseString(Program\DatabaseHandle,  6))
                  
                  Picture\Directory       = KillQuote(GetDatabaseString(Program\DatabaseHandle,  7))
                  
                  Picture\Filename        = KillQuote(GetDatabaseString(Program\DatabaseHandle,  8))
                  
                  Picture\MD5Fingerprint  =           GetDatabaseString(Program\DatabaseHandle,  9)
                  
                  Picture\Created         =           GetDatabaseString(Program\DatabaseHandle, 10)
                  
                  Picture\Modified        =           GetDatabaseString(Program\DatabaseHandle, 11)
                  
                  Picture\Accessed        =           GetDatabaseString(Program\DatabaseHandle, 12)
                  
                  Picture\Archived        =           GetDatabaseString(Program\DatabaseHandle, 13)
                  
                  Picture\Horizontal      =           GetDatabaseString(Program\DatabaseHandle, 14)
                  
                  Picture\Vertical        =           GetDatabaseString(Program\DatabaseHandle, 15)
                  
                  Picture\Depth           =           GetDatabaseString(Program\DatabaseHandle, 16)
                  
                  Picture\Favourite       =           GetDatabaseString(Program\DatabaseHandle, 17) 
                  
                  Picture\Locked          =           GetDatabaseString(Program\DatabaseHandle, 18) 
                  
                  Picture\Deleted         =           GetDatabaseString(Program\DatabaseHandle, 19) 
                  
                  Picture\RecordId        =           GetDatabaseString(Program\DatabaseHandle, 20)
                  
                  ;--------------------------------------------------------------------------------
                  ; 
                  ;--------------------------------------------------------------------------------
                  
                  Picture_Length.i        =           DatabaseColumnSize(Program\DatabaseHandle,  21)
                  
                  If Picture_Length.i <> #NoDataFound
                    
                    *PhotoBlobBuffer      =           AllocateMemory(Picture_Length.i)
                    
                    BlobResult.i          =           GetDatabaseBlob(Program\DatabaseHandle, 21, *PhotoBlobBuffer, Picture_Length.i)
                    
                  EndIf
                  
                  ;--------------------------------------------------------------------------------
                  ; 
                  ;--------------------------------------------------------------------------------
                  
                Wend
                
                ;----------------------------------------------------------------------------------
                ; 
                ;----------------------------------------------------------------------------------
                
                FinishDatabaseQuery(Program\DatabaseHandle)
                
                ;----------------------------------------------------------------------------------
                ;
                ;----------------------------------------------------------------------------------
                
                If BlobResult.i <> #NoBlobFound
                  
                  PictureHandle.i = CatchImage(#PB_Any, *PhotoBlobBuffer)
                  
                  If PictureHandle.i  <> #NoPictureHandle
                    
                    ResizeImage(PictureHandle.i, #DataPictureWidth, #DataPictureHeight, #PB_Image_Smooth)
                    
                    SetGadgetState(#Gadget_PiccyData_picture, ImageID(PictureHandle.i))
                    
                  EndIf
                  
                EndIf
                
                ;----------------------------------------------------------------------------------
                ;
                ;----------------------------------------------------------------------------------
                
                SetGadgetText(#Gadget_PiccyData_Directory,              Picture\Directory)
                
                SetGadgetText(#Gadget_PiccyData_Filename,               Picture\FileName)
                
                SetGadgetText(#Gadget_PiccyData_Title,                  Picture\Title)
                
                SetGadgetText(#Gadget_PiccyData_Category,               Picture\Category)
                
                SetGadgetText(#Gadget_PiccyData_Artist,                 Picture\Artist)
                
                SetGadgetText(#Gadget_PiccyData_Copyright,              Picture\Copyright)
                
                SetGadgetText(#Gadget_PiccyData_Homepage,               Picture\Homepage)
                
                SetGadgetText(#Gadget_PiccyData_Comment,                Picture\Comment)
                
                SetGadgetText(#Gadget_PiccyData_created,        IsoDate(Picture\Created,  "NormalDate"))
                
                SetGadgetText(#Gadget_PiccyData_modified,       IsoDate(Picture\Modified, "NormalDate"))
                
                SetGadgetText(#Gadget_PiccyData_accessed,       IsoDate(Picture\Accessed, "NormalDate"))
                
                SetGadgetText(#Gadget_PiccyData_archivedOn,     IsoDate(Picture\Archived, "NormalDate"))
                
                SetGadgetText(#Gadget_PiccyData_Horizontal,             Picture\Horizontal)
                
                SetGadgetText(#Gadget_PiccyData_Vertical,               Picture\Vertical)
                
                SetGadgetText(#Gadget_PiccyData_Depth,                  Picture\Depth)
                
                SetGadgetText(#Gadget_PiccyData_MD5Fingerprint,         Picture\Md5Fingerprint)
                
               ;SetGadgetText(#Gadget_PiccyData_Favourite,              Picture\Favourite)

               ;SetGadgetText(#Gadget_PiccyData_Locked,                 Picture\Locked)

               ;SetGadgetText(#Gadget_PiccyData_Deleted,                Picture\Deleted)
                
                SetGadgetText(#Gadget_PiccyData_Record_Id,              Picture\RecordId)
                
                ;----------------------------------------------------------------------------------
                ; 
                ;----------------------------------------------------------------------------------
                
              Else
                
                SetInfoBarArea("Headings", "Error", "The database query failed to return any data.", "EditCurrentPicture()")
                
              EndIf
              
              ;------------------------------------------------------------------------------------
              ; Show new record number and status in the main window
              ;------------------------------------------------------------------------------------
              
              SetInfoBarArea("Headings", "Info", Message.s)
              
              ;------------------------------------------------------------------------------------
              ; Make sure the data form window is topmost
              ;------------------------------------------------------------------------------------
              
              SetActiveWindow(#Window_PiccyData)
              
              ;------------------------------------------------------------------------------------
              ; Make sure the version field is selected
              ;------------------------------------------------------------------------------------
              
              SetActiveGadget(#Gadget_PiccyData_Title)
              
              ;------------------------------------------------------------------------------------
              ; 
              ;------------------------------------------------------------------------------------
              
            Else
              
              SetInfoBarArea("Headings", "Error", "The program window could not be opened.", "EditCurrentPicture()")
              
            EndIf
            
            ;--------------------------------------------------------------------------------------
            ; 
            ;--------------------------------------------------------------------------------------
            
          Else
            
            SetInfoBarArea("Headings", "Warn", "Another program window is still open, close that one first.", "EditCurrentPicture()")
            
          EndIf
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
        Else
          
          SetInfoBarArea("Headings", "Error", " is locked and cannot be edited.", "EditCurrentPicture()")  
          
        EndIf
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
      Else
        
        SetInfoBarArea("Headings", "Error", " is deleted and must be recovered first.", "EditCurrentPicture()")
        
      EndIf
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
    Else
      
      SetInfoBarArea("Headings", "Error", "There is no current record on the selected line.", "EditCurrentPicture()")
      
    EndIf
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
  Else
    
    SetInfoBarArea("Headings", "Error", "There is no current line selected.", "EditCurrentPicture()")
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure



; IDE Options = PureBasic 5.31 (Windows - x86)
; CursorPosition = 145
; FirstLine = 124
; Folding = -
; EnableXP
; HideErrorLog