﻿;==========================================================================================================================================================
; Mark an item in the list as a favourite item
;==========================================================================================================================================================

Procedure FavouriteCurrentPicture()
  
  ;------------------------------------------------------------------------------------------------
  ; Get the currently highlighted line
  ;------------------------------------------------------------------------------------------------
  
  CurrentLine.i = GetGadgetState(#Gadget_PiccyDb_Titles)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  CurrentCategory.s = GetGadgetText(#Gadget_PiccyDb_Category)

  ;------------------------------------------------------------------------------------------------
  ; Only continue if a line was selected
  ;------------------------------------------------------------------------------------------------
  
  If CurrentLine.i <> #NothingSelected
    
    ;----------------------------------------------------------------------------------------------
    ; Get the current deleted state
    ;----------------------------------------------------------------------------------------------
    
    FavouriteState.s       = GetGadgetItemText(#Gadget_PiccyDb_Titles, CurrentLine.i, #FavouriteColumn)
    
    LockedState.s          = GetGadgetItemText(#Gadget_PiccyDb_Titles, CurrentLine.i, #LockedColumn)
    
    DeletedState.s         = GetGadgetItemText(#Gadget_PiccyDb_Titles, CurrentLine.i, #DeletedColumn)
    
    PicRecord.s            = GetGadgetItemText(#Gadget_PiccyDb_Titles, CurrentLine.i, #RecordColumn)
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    If LockedState.s <> "1"
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      If DeletedState <> "1"
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        If  FavouriteState.s = "0"
          
          FavouriteState.s = "1"
          
        ElseIf  FavouriteState.s = "1"
          
          FavouriteState.s = "0"
          
        EndIf
        
        ;------------------------------------------------------------------------------------------
        ; Proceed if we got a record number
        ;------------------------------------------------------------------------------------------
        
        If PicRecord.s <> ""
          
          ;----------------------------------------------------------------------------------------
          ; Try to delete the selected record from the database
          ;----------------------------------------------------------------------------------------
          
          QueryString.s = "UPDATE PictureInfo "
          
          QueryString.s + "SET Favourite  = '"    + FavouriteState.s + "' "
          
          QueryString.s + "WHERE Record_Id = '"   + PicRecord.s      + "'"
          
          ;----------------------------------------------------------------------------------------
          ; Try to mark the selected record as a favourite
          ;----------------------------------------------------------------------------------------
          
          If DatabaseUpdate(Program\DatabaseHandle, QueryString.s)
            
            ;--------------------------------------------------------------------------------------
            ; 
            ;--------------------------------------------------------------------------------------
            
            If FavouriteState.s = "1"
              
              SetGadgetItemImage(#Gadget_PiccyDb_Titles, CurrentLine.i, ImageID(#Image_List_Favourite))
              
              If CurrentCategory.s <> "All pictures" And CurrentCategory.s <> "Favourites"
                  
                RemoveGadgetItem(#Gadget_PiccyDb_Titles, CurrentLine.i)
                
              EndIf
              
            ElseIf Favourite.s <> "1"
              
              SetGadgetItemImage(#Gadget_PiccyDb_Titles, CurrentLine.i, ImageID(#Image_List_Normal))
              
              If CurrentCategory.s = "Favourites"
                  
                RemoveGadgetItem(#Gadget_PiccyDb_Titles, CurrentLine.i)
                
              EndIf
              
            EndIf
            
            ;--------------------------------------------------------------------------------------
            ; Remove the item from the current view if it doesn't match the shown category
            ;--------------------------------------------------------------------------------------
            
            ;             If CurrentCategory.s <> "Favourites" And FavouriteState.s = "1"
            ;               RemoveGadgetItem(#Gadget_PiccyDb_Titles, CurrentLine.i)
            ;             ElseIf  CurrentCategory.s = "Favourites" And FavouriteState.s = "0"
            ;               RemoveGadgetItem(#Gadget_PiccyDb_Titles, CurrentLine.i)
            ;             EndIf
          
            ;--------------------------------------------------------------------------------------
            ; 
            ;--------------------------------------------------------------------------------------
            
            SetGadgetItemText(#Gadget_PiccyDb_Titles,  CurrentLine.i, FavouriteState.s, #FavouriteColumn)
            
            ;--------------------------------------------------------------------------------------
            ; 
            ;--------------------------------------------------------------------------------------
            
          Else
            
            SetInfoBarArea("Headings", "Error", "The database query failed or was empty. " + DatabaseError(), "FavouritePicture")
            
          EndIf
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
        Else
          
          SetInfoBarArea("Headings", "Warn", "No record number found for line " + Str(CurrentLine.i), "FavouritePicture")
          
        EndIf
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
      Else
        
        SetInfoBarArea("Headings", "Warn", "Cannot mark a deleted item as a favourite.", "FavouritePicture")
        
      EndIf
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
    Else
      
      SetInfoBarArea("Headings", "Warn", "Cannot mark a locked record as a favourite.", "FavouritePicture")
      
    EndIf
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
  Else
    
    SetInfoBarArea("Headings", "Warn", "There is no current line selected.", "FavouritePicture")
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure

; IDE Options = PureBasic 5.31 (Windows - x86)
; CursorPosition = 181
; FirstLine = 135
; Folding = -
; EnableXP