﻿;==========================================================================================================================================================
; Process the current picture node data
;==========================================================================================================================================================

Procedure ImportPictures()
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  ImportFile.s = OpenFileRequester("Import file from", Program\TemporaryDirectory, "XML file (*.xml)|*.xml", 0)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  If ImportFile.s
    
    ;----------------------------------------------------------------------------------------------
    ; Did we get a file handle?
    ;----------------------------------------------------------------------------------------------
    
    ImportFileId.i = LoadXML(#PB_Any, ImportFile.s)
    
    ;----------------------------------------------------------------------------------------------
    ; Did we get a file handle?
    ;----------------------------------------------------------------------------------------------
    
    If ImportFileId.i
      
      ;--------------------------------------------------------------------------------------------
      ; Start the SQL command transactions to speed up additions to the database
      ;--------------------------------------------------------------------------------------------
      
      DatabaseUpdate(Program\DatabaseHandle, "Begin Transaction")
      
      ;--------------------------------------------------------------------------------------------
      ; Get the main node of the XML document
      ;--------------------------------------------------------------------------------------------
      
      *MainNode = MainXMLNode(ImportFileId.i)
      
      ;--------------------------------------------------------------------------------------------
      ; Parse the XML file
      ;--------------------------------------------------------------------------------------------
      
      ProcessPictureNode(*MainNode, CurrentSublevel.i)
      
      ;--------------------------------------------------------------------------------------------
      ; Commit All the SQL transactions to the database
      ;--------------------------------------------------------------------------------------------
      
      DatabaseUpdate(Program\DatabaseHandle, "Commit")
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      SetInfoBarArea("Headings",  "Info",  "Finished importing from: " + ImportFile.s, "ImportPictures()")
      
      ;--------------------------------------------------------------------------------------------
      ; Show the appointment names for the selected option set of dates by triggering a change event on it.
      ;--------------------------------------------------------------------------------------------
      
      SetGadgetState(#Gadget_PiccyDb_Titles, #FirstItem)
      
      PostEvent(#PB_Event_Gadget, #Window_PiccyDb, #Gadget_PiccyDb_Titles, #PB_EventType_Change)
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
    Else
      
      SetInfoBarArea("Headings",  "Error",  "Could not import from: " + ImportFile.s, "ImportPictures()")
      
    EndIf
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
  Else
    
    SetInfoBarArea("Headings",  "Info",  "Nothing to do, user cancelled", "ImportPictures()")

  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure
  

; IDE Options = PureBasic 5.31 (Windows - x86)
; CursorPosition = 58
; FirstLine = 51
; Folding = -
; EnableXP