﻿;==========================================================================================================================================================
; Permanently delete the current picture
;==========================================================================================================================================================

Procedure KillCurrentPicture()
  
  ;------------------------------------------------------------------------------------------------
  ; Get the currently highlighted line
  ;------------------------------------------------------------------------------------------------
  
  CurrentLine.i = GetGadgetState(#Gadget_PiccyDb_Titles)
  
  ;------------------------------------------------------------------------------------------------
  ; Only continue if a line was selected
  ;------------------------------------------------------------------------------------------------
  
  If CurrentLine.i <> #NothingSelected
    
    ;----------------------------------------------------------------------------------------------
    ; Get the current deleted state
    ;----------------------------------------------------------------------------------------------
    
    PicTitle.s        = GetGadgetItemText(#Gadget_PiccyDb_Titles, CurrentLine.i, #TitleColumn)
    
    LockedState.s     = GetGadgetItemText(#Gadget_PiccyDb_Titles, CurrentLine.i, #LockedColumn)
    
    PicRecord.s       = GetGadgetItemText(#Gadget_PiccyDb_Titles, CurrentLine.i, #RecordColumn)
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    If LockedState.s <> "1"
      
      ;--------------------------------------------------------------------------------------------
      ; Proceed if we got a record number
      ;--------------------------------------------------------------------------------------------
      
      If PicRecord.s <> #EmptyString
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        If MessageRequester("Permanent removal", "Are you sure you want to permanently remove this picture?.", #PB_MessageRequester_YesNo) = #PB_MessageRequester_Yes
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
          If MessageRequester("Last chance bozo", "If this is an original picture, you are so screwed!.", #PB_MessageRequester_YesNo) = #PB_MessageRequester_Yes
            
            ;--------------------------------------------------------------------------------------
            ; Try to delete the selected record from the database
            ;--------------------------------------------------------------------------------------
            
            UpdateString.s = "DELETE FROM PictureInfo WHERE Record_Id = '" + PicRecord.s + "'"
            
            ;--------------------------------------------------------------------------------------
            ; Try to delete the selected record from the database
            ;--------------------------------------------------------------------------------------
            
            If DatabaseUpdate(Program\DatabaseHandle, UpdateString.s) <> #DatabaseUpdateFail
              
              ;------------------------------------------------------------------------------------
              ; 
              ;------------------------------------------------------------------------------------
              
              UpdateString.s = "DELETE FROM PictureData WHERE Record_Id = '"  + PicRecord.s + "'"
              
              ;------------------------------------------------------------------------------------
              ; 
              ;------------------------------------------------------------------------------------
              
              If DatabaseUpdate(Program\DatabaseHandle, UpdateString.s) <> #DatabaseUpdateFail
                
                RemoveGadgetItem(#Gadget_PiccyDb_Titles, CurrentLine.i)
                
                ResizeImage(#Image_PiccyData_picture, #MainPictureWidth, #MainPictureHeight, #PB_Image_Smooth)

                SetGadgetState(#Gadget_PiccyDb_picture,     ImageID(#Image_PiccyData_picture))
                
                SetGadgetText(#Gadget_PiccyDb_sCategory,    #EmptyString)
                
                SetGadgetText(#Gadget_PiccyDb_sSubcategory, #EmptyString)
                
                SetGadgetText(#Gadget_PiccyDb_Artist,       #EmptyString)
                
                SetGadgetText(#Gadget_PiccyDb_Copyright,    #EmptyString)
                
                SetGadgetText(#Gadget_PiccyDb_Homepage,     #EmptyString)
                
                SetGadgetText(#Gadget_PiccyDb_Comment,      #EmptyString)
                
                SetGadgetText(#Gadget_PiccyDb_created,      #EmptyString)
                
                SetGadgetText(#Gadget_PiccyDb_modified,     #EmptyString)
                
                SetGadgetText(#Gadget_PiccyDb_accessed,     #EmptyString)
                
                SetGadgetText(#Gadget_PiccyDb_archivedOn,   #EmptyString)
                
                SetGadgetText(#Gadget_PiccyDb_Horizontal,   #EmptyString)
                
                SetGadgetText(#Gadget_PiccyDb_Vertical,     #EmptyString)
                
                SetGadgetText(#Gadget_PiccyDb_Depth,        #EmptyString)
                
                SetInfoBarArea("Headings", "Info", "Permanently removed " + PicTitle.s, "KillCurrentPicture")
                
              Else
                
                SetInfoBarArea("Headings", "Error", "The database update failed. " + DatabaseError(), "KillCurrentPicture")
                
              EndIf
              
              ;------------------------------------------------------------------------------------
              ; 
              ;------------------------------------------------------------------------------------
              
            Else
              
              SetInfoBarArea("Headings", "Error", "The database update failed. " + DatabaseError(), "KillCurrentPicture")
              
            EndIf
            
            ;--------------------------------------------------------------------------------------
            ; 
            ;--------------------------------------------------------------------------------------
            
          Else
            
            SetInfoBarArea("Headings", "Error", "Nothing to do, user cancelled the operation", "KillCurrentPicture")
            
          EndIf
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
        Else
          
          SetInfoBarArea("Headings", "Error", "Nothing to do, user cancelled the operation", "KillCurrentPicture")
          
        EndIf
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
      Else
        
        SetInfoBarArea("Headings", "Error", "There is no record number for this picture", "KillCurrentPicture")
        
      EndIf
        
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
    Else
      
      SetInfoBarArea("Headings", "Warn", "Cannot kill a locked picture.", "KillCurrentPicture")
      
    EndIf
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
  Else
    
    SetInfoBarArea("Headings", "Warn", "There is no current line selected.", "KillCurrentPictures")
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure


; IDE Options = PureBasic 5.31 (Windows - x86)
; CursorPosition = 179
; FirstLine = 135
; Folding = -
; EnableXP
; HideErrorLog