﻿;==========================================================================================================================================================
; Load all the picture titles into the title list
;==========================================================================================================================================================

Procedure LoadPictures()
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  DatabaseQuery.s = "SELECT * FROM PictureInfo "
  
  DatabaseQuery.s + "ORDER BY Title ASC "
  
  DatabaseQuery.s + "LIMIT 20"
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  ItemCounter.i = 0
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  If DatabaseQuery(Program\DatabaseHandle,  DatabaseQuery.s) <> #DatabaseQueryFail
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    While NextDatabaseRow(Program\DatabaseHandle) <> #NoItems
      
      Picture\Title           = KillQuote(GetDatabaseString(Program\DatabaseHandle,  0))
      
      Picture\Artist          = KillQuote(GetDatabaseString(Program\DatabaseHandle,  1))
      
      Picture\Copyright       = KillQuote(GetDatabaseString(Program\DatabaseHandle,  2))
      
      Picture\Homepage        = KillQuote(GetDatabaseString(Program\DatabaseHandle,  3))
      
      Picture\Category        = KillQuote(GetDatabaseString(Program\DatabaseHandle,  4))
      
      Picture\Subcategory     = KillQuote(GetDatabaseString(Program\DatabaseHandle,  5))
      
      Picture\Comment         = KillQuote(GetDatabaseString(Program\DatabaseHandle,  6))
      
      Picture\Directory       = KillQuote(GetDatabaseString(Program\DatabaseHandle,  7))
      
      Picture\Filename        = KillQuote(GetDatabaseString(Program\DatabaseHandle,  8))
      
      Picture\MD5Fingerprint  =           GetDatabaseString(Program\DatabaseHandle,  9)
      
      Picture\Created         =           GetDatabaseString(Program\DatabaseHandle, 10)
      
      Picture\Modified        =           GetDatabaseString(Program\DatabaseHandle, 11)
      
      Picture\Accessed        =           GetDatabaseString(Program\DatabaseHandle, 12)
      
      Picture\Archived        =           GetDatabaseString(Program\DatabaseHandle, 13)
      
      Picture\Horizontal      =           GetDatabaseString(Program\DatabaseHandle, 14)
      
      Picture\Vertical        =           GetDatabaseString(Program\DatabaseHandle, 15)
      
      Picture\Depth           =           GetDatabaseString(Program\DatabaseHandle, 16)
      
      Picture\Favourite       =           GetDatabaseString(Program\DatabaseHandle, 17) 
      
      Picture\Locked          =           GetDatabaseString(Program\DatabaseHandle, 18) 
      
      Picture\Deleted         =           GetDatabaseString(Program\DatabaseHandle, 19) 
      
      Picture\RecordId        =           GetDatabaseString(Program\DatabaseHandle, 20)
      
      DisplayTitleString("AddMode", ItemCounter.i)
      
      ItemCounter.i + 1
      
    Wend
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    FinishDatabaseQuery(Program\DatabaseHandle)
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    If CountGadgetItems(#Gadget_PiccyDb_Titles) <> #NoItems
      
      SetActiveGadget(#Gadget_PiccyDb_Titles)
      
      SetGadgetState(#Gadget_PiccyDb_Titles, #FirstItem)
      
      SetGadgetItemState(#Gadget_PiccyDb_Titles, #FirstItem, #PB_ListIcon_Selected)
      
      PostEvent(#PB_Event_Gadget, #Window_PiccyDb, #Gadget_PiccyDb_Titles, #PB_EventType_Change)
      
    EndIf
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
  Else
    
    SetInfoBarArea("Headings", "Error", "Could not retrieve picture titles from database. " + DatabaseError())
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure

; IDE Options = PureBasic 5.31 (Windows - x86)
; CursorPosition = 74
; FirstLine = 15
; Folding = -
; EnableXP