﻿;==========================================================================================================================================================
; Mark an item in the list as a favourite item
;==========================================================================================================================================================

Procedure LockCurrentPicture()
  
  ;------------------------------------------------------------------------------------------------
  ; Get the currently highlighted line
  ;------------------------------------------------------------------------------------------------
  
  CurrentLine.i = GetGadgetState(#Gadget_PiccyDb_Titles)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  CurrentCategory.s = GetGadgetText(#Gadget_PiccyDb_Category)

  ;------------------------------------------------------------------------------------------------
  ; Only continue if a line was selected
  ;------------------------------------------------------------------------------------------------
  
  If CurrentLine.i <> #NothingSelected
    
    ;----------------------------------------------------------------------------------------------
    ; Get the current deleted state
    ;----------------------------------------------------------------------------------------------
    
    FavouriteState.s       = GetGadgetItemText(#Gadget_PiccyDb_Titles, CurrentLine.i, #FavouriteColumn)
    
    LockedState.s          = GetGadgetItemText(#Gadget_PiccyDb_Titles, CurrentLine.i, #LockedColumn)
    
    DeletedState.s         = GetGadgetItemText(#Gadget_PiccyDb_Titles, CurrentLine.i, #DeletedColumn)
    
    PicRecord.s            = GetGadgetItemText(#Gadget_PiccyDb_Titles, CurrentLine.i, #RecordColumn)
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    If DeletedState <> "1"
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      If  LockedState.s = "0"
        
        LockedState.s = "1"
        
      ElseIf  LockedState.s = "1"
        
        LockedState.s = "0"
        
      EndIf
      
      ;--------------------------------------------------------------------------------------------
      ; Proceed if we got a record number
      ;--------------------------------------------------------------------------------------------
      
      If PicRecord.s <> #EmptyString
        
        ;------------------------------------------------------------------------------------------
        ; Try to delete the selected record from the database
        ;------------------------------------------------------------------------------------------
        
        UpdateString.s = "UPDATE PictureInfo "
        
        UpdateString.s + "SET Locked  = '"       + LockedState.s + "' "
        
        UpdateString.s + "WHERE Record_Id = '"   + PicRecord.s + "'"
        
        ;------------------------------------------------------------------------------------------
        ; Try to delete the selected record from the database
        ;------------------------------------------------------------------------------------------
        
        If DatabaseUpdate(Program\DatabaseHandle, UpdateString.s) <> #DatabaseUpdateFail
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
          If LockedState.s = "1"
            
            SetGadgetItemImage(#Gadget_PiccyDb_Titles, CurrentLine.i, ImageID(#Image_List_Locked))
            
            SetGadgetItemText(#Gadget_PiccyDb_Titles,  CurrentLine.i, LockedState.s, #LockedColumn)
            
            If CurrentCategory.s <> "Locked pictures"
              
              RemoveGadgetItem(#Gadget_PiccyDb_Titles, CurrentLine.i)
            
            EndIf
            
          ElseIf  LockedState.s <> "1"
            
            SetGadgetItemText(#Gadget_PiccyDb_Titles,  CurrentLine.i, LockedState.s, #LockedColumn)
            
            If FavouriteState.s = "1"
              
              SetGadgetItemImage(#Gadget_PiccyDb_Titles, CurrentLine.i, ImageID(#Image_List_Favourite))
              
            ElseIf Favourite.s <> "1"
              
              SetGadgetItemImage(#Gadget_PiccyDb_Titles, CurrentLine.i, ImageID(#Image_List_Normal))
              
            EndIf
            
            If CurrentCategory.s = "Locked pictures"
              
              RemoveGadgetItem(#Gadget_PiccyDb_Titles, CurrentLine.i)
            
            EndIf

          EndIf
          
          ;----------------------------------------------------------------------------------------
          ; Remove the item from the current view if it doesn't match the shown category
          ;----------------------------------------------------------------------------------------
          
          ;           If CurrentCategory.s <> "Locked pictures" And LockedState.s = "1"
          ;             RemoveGadgetItem(#Gadget_PiccyDb_Titles, CurrentLine.i)
          ;           ElseIf  CurrentCategory.s = "Locked pictures" And LockedState.s = "0"
          ;             RemoveGadgetItem(#Gadget_PiccyDb_Titles, CurrentLine.i)
          ;           EndIf

          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
          SetGadgetItemText(#Gadget_PiccyDb_Titles,  CurrentLine.i, LockedState.s, #LockedColumn)
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
        Else
          
          SetInfoBarArea("Headings", "Error", "The database query failed. " + DatabaseError(), "LockCurrentPicture")
          
        EndIf
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
      Else
        
        SetInfoBarArea("Headings", "Warn", "No record number found for line " + Str(CurrentLine.i), "LockCurrentPicture")
        
      EndIf
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
    Else
      
      SetInfoBarArea("Headings", "Warn", "Cannot mark a deleted item as a favourite.", "LockCurrentPicture")
      
    EndIf
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
  Else
    
    SetInfoBarArea("Headings", "Warn", "There is no current line selected.", "LockCurrentPictures")
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure

; IDE Options = PureBasic 5.31 (Windows - x86)
; CursorPosition = 177
; FirstLine = 131
; Folding = -
; EnableXP