﻿;==========================================================================================================================================================
; Import an XML file of picture entries
;==========================================================================================================================================================

Procedure ProcessPictureNode(*CurrentNode, CurrentSublevel.i)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  If XMLNodeType(*CurrentNode) = #PB_XML_Normal
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------

    *ChildNode = ChildXMLNode(*CurrentNode)
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------

    While *ChildNode <> 0
      
      ;--------------------------------------------------------------------------------------------
      ; Returns the tagname of the given XML node
      ;--------------------------------------------------------------------------------------------
      
      NodeName.s =  GetXMLNodeName(*ChildNode)
      
      ;--------------------------------------------------------------------------------------------
      ; Returns the text inside the given XML node.
      ;--------------------------------------------------------------------------------------------
      
      If NodeName.s <> "Picture"
        
        NodeText.s = Trim(RepQuote(XMLToText(GetXMLNodeText(*ChildNode))))
        
      Else
        
        NodeText.s = GetXMLNodeText(*ChildNode)
        
      EndIf
      
      ;--------------------------------------------------------------------------------------------
      ;
      ;--------------------------------------------------------------------------------------------
      
      Select NodeName.s
          
        Case "Title"          : Picture\Title           = NodeText.s  : ;Debug "Node name: " + NodeName.s  + "  --  "  + NodeText.s 
          
        Case "Artist"         : Picture\Artist          = NodeText.s  : ;Debug "Node name: " + NodeName.s  + "  --  "  + NodeText.s 
          
        Case "Copyright"      : Picture\Copyright       = NodeText.s  : ;Debug "Node name: " + NodeName.s  + "  --  "  + NodeText.s 
          
        Case "Homepage"       : Picture\Homepage        = NodeText.s  : ;Debug "Node name: " + NodeName.s  + "  --  "  + NodeText.s 
          
        Case "Category"       : Picture\Category        = NodeText.s  : ;Debug "Node name: " + NodeName.s  + "  --  "  + NodeText.s 
          
        Case "Subcategory"    : Picture\Subcategory     = NodeText.s  : ;Debug "Node name: " + NodeName.s  + "  --  "  + NodeText.s 
          
        Case "Comment"        : Picture\Comment         = NodeText.s  : ;Debug "Node name: " + NodeName.s  + "  --  "  + NodeText.s 
          
        Case "Directory"      : Picture\Directory       = NodeText.s  : ;Debug "Node name: " + NodeName.s  + "  --  "  + NodeText.s 
          
        Case "Filename"       : Picture\Filename        = NodeText.s  : ;Debug "Node name: " + NodeName.s  + "  --  "  + NodeText.s 
          
        Case "MD5Fingerprint" : Picture\MD5Fingerprint  = NodeText.s  : ;Debug "Node name: " + NodeName.s  + "  --  "  + NodeText.s 
          
        Case "Created"        : Picture\Created         = NodeText.s  : ;Debug "Node name: " + NodeName.s  + "  --  "  + NodeText.s 
          
        Case "Modified"       : Picture\Modified        = NodeText.s  : ;Debug "Node name: " + NodeName.s  + "  --  "  + NodeText.s 
          
        Case "Accessed"       : Picture\Accessed        = NodeText.s  : ;Debug "Node name: " + NodeName.s  + "  --  "  + NodeText.s 
          
        Case "Archived"       : Picture\Archived        = NodeText.s  : ;Debug "Node name: " + NodeName.s  + "  --  "  + NodeText.s 
          
        Case "Horizontal"     : Picture\Horizontal      = NodeText.s  : ;Debug "Node name: " + NodeName.s  + "  --  "  + NodeText.s 
          
        Case "Vertical"       : Picture\Vertical        = NodeText.s  : ;Debug "Node name: " + NodeName.s  + "  --  "  + NodeText.s 
          
        Case "Depth"          : Picture\Depth           = NodeText.s  : ;Debug "Node name: " + NodeName.s  + "  --  "  + NodeText.s 
          
        Case "Favourite"      : Picture\Favourite       = NodeText.s  : ;Debug "Node name: " + NodeName.s  + "  --  "  + NodeText.s 
          
        Case "Locked"         : Picture\Locked          = NodeText.s  : ;Debug "Node name: " + NodeName.s  + "  --  "  + NodeText.s 
          
        Case "Deleted"        : Picture\Deleted         = NodeText.s  : ;Debug "Node name: " + NodeName.s  + "  --  "  + NodeText.s 
          
        Case "Picture"        : PictureName.s           = NodeText.s  : ;Debug "Node name: " + NodeName.s  + "  --  "  + NodeText.s 
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
          Picture\Favourite       = "0"
          
          Picture\Locked          = "0"
          
          Picture\Deleted         = "0"
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------

          DatabaseUpdate.s  = "INSERT INTO PictureInfo("
          
          DatabaseUpdate.s  + "Title, Artist, Copyright, Homepage, Category, Subcategory, Comment, "
          
          DatabaseUpdate.s  + "Directory, Filename, MD5Fingerprint, Created, Modified, Accessed, "
          
          DatabaseUpdate.s  + "Archived, Horizontal, Vertical, Depth, Favourite, Locked, Deleted) "
          
          DatabaseUpdate.s  + "VALUES("
          
          DatabaseUpdate.s  + "'"   +   Picture\Title           + "',"
          
          DatabaseUpdate.s  + "'"   +   Picture\Artist          + "',"
          
          DatabaseUpdate.s  + "'"   +   Picture\Copyright       + "',"
          
          DatabaseUpdate.s  + "'"   +   Picture\Homepage        + "',"
          
          DatabaseUpdate.s  + "'"   +   Picture\Category        + "',"
          
          DatabaseUpdate.s  + "'"   +   Picture\Subcategory     + "',"
          
          DatabaseUpdate.s  + "'"   +   Picture\Comment         + "',"
          
          DatabaseUpdate.s  + "'"   +   Picture\Directory       + "',"
          
          DatabaseUpdate.s  + "'"   +   Picture\FileName        + "',"
          
          DatabaseUpdate.s  + "'"   +   Picture\Md5Fingerprint  + "',"
          
          DatabaseUpdate.s  + "'"   +   Picture\Created         + "',"
          
          DatabaseUpdate.s  + "'"   +   Picture\Modified        + "',"
          
          DatabaseUpdate.s  + "'"   +   Picture\Accessed        + "',"
          
          DatabaseUpdate.s  + "'"   +   Picture\Archived        + "',"
          
          DatabaseUpdate.s  + "'"   +   Picture\Horizontal      + "',"
          
          DatabaseUpdate.s  + "'"   +   Picture\Vertical        + "',"
          
          DatabaseUpdate.s  + "'"   +   Picture\Depth           + "',"
          
          DatabaseUpdate.s  + "'"   +   Picture\Favourite       + "',"
          
          DatabaseUpdate.s  + "'"   +   Picture\Locked          + "',"
          
          DatabaseUpdate.s  + "'"   +   Picture\Deleted         + "'"
          
;         DatabaseUpdate.s  + "'"   +   Picture\RecordId        + "'"
          
          DatabaseUpdate.s  + ")"
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
          If DatabaseUpdate(Program\DatabaseHandle, DatabaseUpdate.s)
            
            ;--------------------------------------------------------------------------------------
            ; 
            ;--------------------------------------------------------------------------------------
            
            Picture\RecordId = DatabaseLastInsertRowId()
            
            ;--------------------------------------------------------------------------------------
            ; 
            ;--------------------------------------------------------------------------------------
            
            If Picture\RecordId <> #EmptyString
              
              ;------------------------------------------------------------------------------------
              ; 
              ;------------------------------------------------------------------------------------
              
              NewNumberOfItems.i = CountGadgetItems(#Gadget_PiccyDb_Titles)
              
              ;------------------------------------------------------------------------------------
              ; 
              ;------------------------------------------------------------------------------------
              
              If PictureName.s <> #EmptyString
                
                ;----------------------------------------------------------------------------------
                ; 
                ;----------------------------------------------------------------------------------
                
                ActualLen.i   = StringByteLength(PictureName.s, #PB_Ascii)
                
                ;----------------------------------------------------------------------------------
                ; 
                ;----------------------------------------------------------------------------------
                
                *DecodeBuffer = AllocateMemory(ActualLen.i)
                
                *OutputBuffer = AllocateMemory(ActualLen.i)
                
                ;----------------------------------------------------------------------------------
                ; 
                ;----------------------------------------------------------------------------------
                
                If PokeS(*DecodeBuffer, PictureName.s, ActualLen.i, #PB_Ascii | #PB_String_NoZero) <> #NoBufferDataFound
                  
                  ;--------------------------------------------------------------------------------
                  ; 
                  ;--------------------------------------------------------------------------------
                  
                  ActualBytes.i = Base64Decoder(*DecodeBuffer, ActualLen.i, *OutputBuffer, ActualLen.i)
                  
                  ;--------------------------------------------------------------------------------
                  ; 
                  ;--------------------------------------------------------------------------------
                  
                  If ActualBytes.i  <> #NothingDecoded
                    
                    ;------------------------------------------------------------------------------
                    ; 
                    ;------------------------------------------------------------------------------
                    
                    SetDatabaseBlob(Program\DatabaseHandle, 0, *OutputBuffer, ActualBytes.i)
                    
                    ;------------------------------------------------------------------------------
                    ; 
                    ;------------------------------------------------------------------------------
                    
                    DatabaseUpdate.s = "INSERT INTO PictureData("
                    
                    DatabaseUpdate.s + "Picture, Record_Id) "
                    
                    DatabaseUpdate.s + "VALUES (?, " + Picture\RecordId + ")"
                    
                    ;------------------------------------------------------------------------------
                    ; 
                    ;------------------------------------------------------------------------------
                    
                    If DatabaseUpdate(Program\DatabaseHandle, DatabaseUpdate.s) <> #DatabaseUpdateFail
                      
                      ;----------------------------------------------------------------------------
                      ; 
                      ;----------------------------------------------------------------------------
                      
                      NewRecord.s = DatabaseLastInsertRowId()
                      
                      ;----------------------------------------------------------------------------
                      ; 
                      ;----------------------------------------------------------------------------
                      
                      If NewRecord.s  <> #EmptyString
                        
                        DisplayTitleString("AddMode", -1)
                        
                        SetInfoBarArea("Headings",  "Info",  "Saved " + Picture\Title + " to the database", "ProcessPictureNode()")
                        
                      Else
                        
                        SetInfoBarArea("Headings",  "Error",  "Could not get a new record number for picture data", "ProcessPictureNode()")
                        
                      EndIf
                      
                      ;----------------------------------------------------------------------------
                      ; 
                      ;----------------------------------------------------------------------------
                      
                    Else
                      
                      SetInfoBarArea("Headings",  "Error",  "Could not save the picture data into the database", "ProcessPictureNode()")
                      
                    EndIf
                    
                    ;------------------------------------------------------------------------------
                    ; 
                    ;------------------------------------------------------------------------------
                    
                  Else
                    
                    SetInfoBarArea("Headings",  "Error",  "No picture data was Base64Encoded from the temporary buffer", "ProcessPictureNode()")
                    
                  EndIf
                  
                  ;--------------------------------------------------------------------------------
                  ; 
                  ;--------------------------------------------------------------------------------
                  
                Else
                  
                  SetInfoBarArea("Headings",  "Error",  "No data was poked into the temporary buffer", "ProcessPictureNode()")
                  
                EndIf
                
                ;----------------------------------------------------------------------------------
                ; 
                ;----------------------------------------------------------------------------------
                
              Else
                
                SetInfoBarArea("Headings",  "Error",  "No picture exists for this record", "ProcessPictureNode()")
                
              EndIf
              
              ;------------------------------------------------------------------------------------
              ; 
              ;------------------------------------------------------------------------------------
              
              LastLine(#Gadget_PiccyDb_Titles, NewNumberOfItems.i - 1)
              
              Program\CurrentLine = NewNumberOfItems.i - 1
              
              ;------------------------------------------------------------------------------------
              ; 
              ;------------------------------------------------------------------------------------
              
            Else
              
              SetInfoBarArea("Headings",  "Error",  "No record number created " + DatabaseError(), "ProcessPictureNode()")
              
            EndIf
            
            ;--------------------------------------------------------------------------------------
            ; 
            ;--------------------------------------------------------------------------------------
            
          Else
            
            SetInfoBarArea("Headings",  "Error",  "Database table failed to be updated " + DatabaseError(), "ProcessPictureNode()")
            
          EndIf
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
      EndSelect
      
      ;--------------------------------------------------------------------------------------------
      ;
      ;--------------------------------------------------------------------------------------------
      
      ProcessPictureNode(*ChildNode, CurrentSublevel.i + 1)
      
      ;--------------------------------------------------------------------------------------------
      ;
      ;--------------------------------------------------------------------------------------------
      
      *ChildNode = NextXMLNode(*ChildNode)
      
      ;--------------------------------------------------------------------------------------------
      ;
      ;--------------------------------------------------------------------------------------------
      
    Wend
    
    ;----------------------------------------------------------------------------------------------
    ;
    ;----------------------------------------------------------------------------------------------
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ;
  ;------------------------------------------------------------------------------------------------
  
EndProcedure 


; IDE Options = PureBasic 5.31 (Windows - x86)
; CursorPosition = 317
; FirstLine = 271
; Folding = -
; EnableXP
; CompileSourceDirectory