﻿;==============================================================================================================================================================================
; Save selected pictures to disk
;==============================================================================================================================================================================

Procedure SaveCategoryPicturesToDisk()
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  ; CurrentCategory.s = RepQuote(Trim(StringField(GetGadgetItemText(#Gadget_PiccyDb_Category, Program\CurrentLine, #CategoryTitleColumn), 1, "(")))
  
  CurrentCategory.s = RepQuote(Trim(StringField(GetGadgetText(#Gadget_PiccyDb_Category), 1, "(")))
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  If CurrentCategory.s <> #EmptyString
    
    ;----------------------------------------------------------------------------------------------
    ; Process the current table name
    ;----------------------------------------------------------------------------------------------
    
    DatabaseQuery.s = "SELECT m.Filename, m.Category, m.Subcategory, n.Picture "
    
    DatabaseQuery.s + "FROM PictureInfo AS m, PictureData AS n "
    
    DatabaseQuery.s + "WHERE n.Record_Id = m.Record_Id "
    
    DatabaseQuery.s + "AND m.Category = '"  + CurrentCategory.s  + "'"
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    If DatabaseQuery(Program\DatabaseHandle, DatabaseQuery.s) <> #DatabaseQueryFail
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      While NextDatabaseRow(Program\DatabaseHandle)
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        PictureFilename.s       = KillQuote(GetDatabaseString(Program\DatabaseHandle,  0))  ; : Debug PictureFilename.s
        
        PictureCategory.s       = KillQuote(GetDatabaseString(Program\DatabaseHandle,  1))  ; : Debug PictureCategory.s
        
        PictureSubcategory.s    = KillQuote(GetDatabaseString(Program\DatabaseHandle,  2))  ; : Debug PictureSubcategory.s
        
        Picture_Length.i        =           DatabaseColumnSize(Program\DatabaseHandle, 3)   ; : Debug Picture_Length.i
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        If Picture_Length.i
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
          *PhotoBlobBuffer      =           AllocateMemory(Picture_Length.i)
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
          BlobResult.i          =           GetDatabaseBlob(Program\DatabaseHandle, 3, *PhotoBlobBuffer, Picture_Length.i)
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
          If BlobResult.i <> 0
            
            ;--------------------------------------------------------------------------------------
            ; 
            ;--------------------------------------------------------------------------------------
            
            If PictureCategory.s <> #EmptyString And PictureSubcategory.s <> #EmptyString
              
              NewDirectory.s = Program\TemporaryDirectory + "PiccyDb\" + PictureCategory.s + "\" + PictureSubcategory.s  + "\"
              
            ElseIf PictureCategory.s <> #EmptyString And PictureSubcategory.s = #EmptyString
              
              NewDirectory.s = Program\TemporaryDirectory + "PiccyDb\"  + PictureCategory.s + "\"
              
            ElseIf PictureCategory.s = #EmptyString
              
              NewDirectory.s = Program\TemporaryDirectory + "PiccyDb\"
              
            EndIf
            
            ;--------------------------------------------------------------------------------------
            ; 
            ;--------------------------------------------------------------------------------------
            
            ResultCode.s = MakeSureDirectoryPathExists(NewDirectory.s)
            
            ;--------------------------------------------------------------------------------------
            ; 
            ;--------------------------------------------------------------------------------------
            
            If ResultCode.s = "Okay" Or ResultCode.s = "Directory already exists"
              
              ;------------------------------------------------------------------------------------
              ; 
              ;------------------------------------------------------------------------------------
              
              SaveFileHandle.i = CreateFile(#PB_Any, NewDirectory.s + GetFilePart(PictureFilename.s))
              
              ;------------------------------------------------------------------------------------
              ; 
              ;------------------------------------------------------------------------------------
              
              ;Debug Program\TemporaryDirectory + GetFilePart(PictureFilename.s) + "  --  "  + Str(SaveFileHandle.i)
              
              ;------------------------------------------------------------------------------------
              ; 
              ;------------------------------------------------------------------------------------
              
              If SaveFileHandle.i <> 0
                
                WriteData(SaveFileHandle.i, *PhotoBlobBuffer, Picture_Length.i)
                
                CloseFile(SaveFileHandle.i)
                
                SetInfoBarArea("Headings", "Info", "Saved: " + NewDirectory.s + PictureFilename.s)
                
              Else
                
                SetInfoBarArea("Headings", "Error", "Could not create a handle for the picture file to save", "SaveCategoryPicturesToDisk")
                
              EndIf
              
              ;------------------------------------------------------------------------------------
              ; 
              ;------------------------------------------------------------------------------------
              
            Else
              
              SetInfoBarArea("Headings", "Error", "Could not create the category based picture directory", "SaveCategoryPicturesToDisk")
              
            EndIf
            
            ;--------------------------------------------------------------------------------------
            ; 
            ;--------------------------------------------------------------------------------------
            
          Else
            
            SetInfoBarArea("Headings", "Error", "Could not get the blob data back from the database", "SaveCategoryPicturesToDisk")
            
          EndIf
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
          FreeMemory(*PhotoBlobBuffer)
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
        Else
          
          SetInfoBarArea("Headings", "Error", "There was no data in that blob field", "SaveCategoryPicturesToDisk")
          
        EndIf
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
      Wend
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      FinishDatabaseQuery(Program\DatabaseHandle)
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
    Else
      
      SetInfoBarArea("Headings", "Error", "The query failed or returned no data"  + DatabaseError(), "SaveCategoryPicturesToDisk")
      
    EndIf
  
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
  Else
    
    SetInfoBarArea("Headings", "Error", "No record number found for this picture???", "SaveCategoryPicturesToDisk")
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure

; IDE Options = PureBasic 5.31 (Windows - x86)
; CursorPosition = 12
; Folding = -
; EnableAsm
; EnableUnicode
; EnableXP