﻿;==========================================================================================================================================================
; Save the current picture to disk
;==========================================================================================================================================================

Procedure SaveCurrentPicture()
  
  ;------------------------------------------------------------------------------------------------
  ; Check if you can get a currently selected line
  ;------------------------------------------------------------------------------------------------
  
  Program\CurrentLine = GetGadgetState(#Gadget_PiccyDb_Titles)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  If Program\CurrentLine <> #NothingSelected
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    Program\CurrentRecord = GetGadgetItemText(#Gadget_PiccyDb_Titles, Program\CurrentLine, #RecordColumn)
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    If Program\CurrentRecord <> #EmptyString
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      DeletedState.s   =  GetGadgetItemText(#Gadget_PiccyDb_Titles, Program\CurrentLine, #DeletedColumn)
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      If DeletedState.s <> "1"
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        LockedState.s   =  GetGadgetItemText(#Gadget_PiccyDb_Titles, Program\CurrentLine, #LockedColumn)
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        If LockedState.s <> "1"
          
          ;----------------------------------------------------------------------------------------
          ; Process the current table name
          ;----------------------------------------------------------------------------------------
          
          DatabaseQuery.s = "SELECT m.Filename, n.Picture "
          
          DatabaseQuery.s + "FROM PictureInfo AS m, PictureData AS n "
          
          DatabaseQuery.s + "WHERE n.Record_Id = m.Record_Id "      
          
          DatabaseQuery.s + "AND m.Record_Id = '" + Program\CurrentRecord + "'"
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
          If DatabaseQuery(Program\DatabaseHandle, DatabaseQuery.s) <> 0
            
            While NextDatabaseRow(Program\DatabaseHandle)
              
              PictureFilename.s       = KillQuote(GetDatabaseString(Program\DatabaseHandle,  0))
              
              Picture_Length.i        =           DatabaseColumnSize(Program\DatabaseHandle, 1)
              
              If Picture_Length.i
                
                *PhotoBlobBuffer      =           AllocateMemory(Picture_Length.i)
                
                BlobResult.i          =           GetDatabaseBlob(Program\DatabaseHandle, 1, *PhotoBlobBuffer, Picture_Length.i)
                
                If BlobResult.i <> 0
                  
                  SaveFileHandle.i = CreateFile(#PB_Any, Program\TemporaryDirectory + PictureFilename.s)
                  
                  If SaveFileHandle.i <> 0
                    
                    WriteData(SaveFileHandle.i, *PhotoBlobBuffer, Picture_Length.i)
                    
                    CloseFile(SaveFileHandle.i)
                    
                    SetInfoBarArea("Headings", "Info", "Saved: " + Program\TemporaryDirectory + PictureFilename.s)
                    
                  Else
                    
                    SetInfoBarArea("Headings", "Error", "Could not get a handle to the save file")
                    
                  EndIf
                  
                Else
                  
                  SetInfoBarArea("Headings", "Error", "Could not get the blob data back from the database")
                  
                EndIf
                
                FreeMemory(*PhotoBlobBuffer)
                
              Else
                
                SetInfoBarArea("Headings", "Error", "There was no data in that blob field")
                
              EndIf
              
            Wend
            
            FinishDatabaseQuery(Program\DatabaseHandle)
            
          Else
            
            SetInfoBarArea("Headings", "Error", "The query failed or returned no data"  + DatabaseError())
            
          EndIf
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
        Else
          
          SetInfoBarArea("Headings", "Error", "Record is locked and cannot be edited.")  
          
        EndIf
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
      Else
        
        SetInfoBarArea("Headings", "Error", "Record is deleted and must be recovered first.")
        
      EndIf
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
    Else
      
      SetInfoBarArea("Headings", "Error", "There is no current record on the selected line.")
      
    EndIf
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
  Else
    
    SetInfoBarArea("Headings", "Error", "There is no current line selected.")
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure

; IDE Options = PureBasic 5.31 (Windows - x86)
; CursorPosition = 70
; FirstLine = 43
; Folding = -
; EnableXP