﻿;==========================================================================================================================================================
; Save the current picture to disk
;==========================================================================================================================================================

Procedure SavePictureData()
  
  ;------------------------------------------------------------------------------------------------
  ;
  ;------------------------------------------------------------------------------------------------
  
  Picture\Title           =  RepQuote(GetGadgetText(#Gadget_PiccyData_Title))     ; ReqQuote converts single
  
  Picture\Artist          =  RepQuote(GetGadgetText(#Gadget_PiccyData_Artist))    ; quote to double quote
  
  Picture\Copyright       =  RepQuote(GetGadgetText(#Gadget_PiccyData_Copyright)) ; for database escape needs 
  
  Picture\Homepage        =  RepQuote(GetGadgetText(#Gadget_PiccyData_Homepage))
  
  Picture\Category        =  RepQuote(GetGadgetText(#Gadget_PiccyData_Category))
  
  Picture\Subcategory     =  RepQuote(GetGadgetText(#Gadget_PiccyData_Subcategory))
  
  Picture\Comment         =  RepQuote(GetGadgetText(#Gadget_PiccyData_Comment))
  
  Picture\Directory       =  RepQuote(GetGadgetText(#Gadget_PiccyData_Directory))
  
  Picture\FileName        =  RepQuote(GetGadgetText(#Gadget_PiccyData_Filename))
  
  Picture\Md5Fingerprint  =           GetGadgetText(#Gadget_PiccyData_MD5Fingerprint)
  
  Picture\Created         =   IsoDate(GetGadgetText(#Gadget_PiccyData_created),     "IsoDate")
  
  Picture\Modified        =   IsoDate(GetGadgetText(#Gadget_PiccyData_modified),    "IsoDate")
  
  Picture\Accessed        =   IsoDate(GetGadgetText(#Gadget_PiccyData_accessed),    "IsoDate")
  
  Picture\Archived        =   IsoDate(GetGadgetText(#Gadget_PiccyData_archivedOn),  "IsoDate")
  
  Picture\Horizontal      =           GetGadgetText(#Gadget_PiccyData_Horizontal)
  
  Picture\Vertical        =           GetGadgetText(#Gadget_PiccyData_Vertical)
  
  Picture\Depth           =           GetGadgetText(#Gadget_PiccyData_Depth)
  
; Picture\Favourite       =           GetGadgetText(#Gadget_PiccyData_Favourite)

; Picture\Locked          =           GetGadgetText(#Gadget_PiccyData_Locked)

; Picture\Deleted         =           GetGadgetText(#Gadget_PiccyData_Deleted)

; Picture\RecordId        =           GetGadgetText(#Gadget_PiccyData_Record_Id)
  
  ;------------------------------------------------------------------------------------------------
  ;
  ;------------------------------------------------------------------------------------------------
  
  If Picture\Title <> #EmptyString
    
    ;----------------------------------------------------------------------------------------------
    ;
    ;----------------------------------------------------------------------------------------------
    
    Select Program\LastWindow
        
      ;--------------------------------------------------------------------------------------------
      ;
      ;--------------------------------------------------------------------------------------------
        
      Case  "Add A New Picture"
        
        ;------------------------------------------------------------------------------------------
        ;
        ;------------------------------------------------------------------------------------------
        
        Picture\Favourite       = "0"
        
        Picture\Locked          = "0"
        
        Picture\Deleted         = "0"
        
        ;------------------------------------------------------------------------------------------
        ;
        ;------------------------------------------------------------------------------------------
        
        DatabaseUpdate.s  = "INSERT INTO PictureInfo("
        
        DatabaseUpdate.s  + "Title, Artist, Copyright, Homepage, Category, Subcategory, Comment, "
        
        DatabaseUpdate.s  + "Directory, Filename, MD5Fingerprint, Created, Modified, Accessed, "
        
        DatabaseUpdate.s  + "Archived, Horizontal, Vertical, Depth, Favourite, Locked, Deleted) "
        
        DatabaseUpdate.s  + "VALUES("
        
        DatabaseUpdate.s  + "'"   +   Picture\Title           + "',"
        
        DatabaseUpdate.s  + "'"   +   Picture\Artist          + "',"
        
        DatabaseUpdate.s  + "'"   +   Picture\Copyright       + "',"
        
        DatabaseUpdate.s  + "'"   +   Picture\Homepage        + "',"
        
        DatabaseUpdate.s  + "'"   +   Picture\Category        + "',"
        
        DatabaseUpdate.s  + "'"   +   Picture\Subcategory     + "',"
        
        DatabaseUpdate.s  + "'"   +   Picture\Comment         + "',"
        
        DatabaseUpdate.s  + "'"   +   Picture\Directory       + "',"
        
        DatabaseUpdate.s  + "'"   +   Picture\FileName        + "',"
        
        DatabaseUpdate.s  + "'"   +   Picture\Md5Fingerprint  + "',"
        
        DatabaseUpdate.s  + "'"   +   Picture\Created         + "',"
        
        DatabaseUpdate.s  + "'"   +   Picture\Modified        + "',"
        
        DatabaseUpdate.s  + "'"   +   Picture\Accessed        + "',"
        
        DatabaseUpdate.s  + "'"   +   Picture\Archived        + "',"
        
        DatabaseUpdate.s  + "'"   +   Picture\Horizontal      + "',"
        
        DatabaseUpdate.s  + "'"   +   Picture\Vertical        + "',"
        
        DatabaseUpdate.s  + "'"   +   Picture\Depth           + "',"
        
        DatabaseUpdate.s  + "'"   +   Picture\Favourite       + "',"
        
        DatabaseUpdate.s  + "'"   +   Picture\Locked          + "',"
        
        DatabaseUpdate.s  + "'"   +   Picture\Deleted         + "'"
        
;       DatabaseUpdate.s  + "'"   +   Picture\Record_Id       + "'"
        
        DatabaseUpdate.s  + ")"
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        If DatabaseUpdate(Program\DatabaseHandle, DatabaseUpdate.s) <> #DatabaseUpdateFail
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
          Picture\RecordId = DatabaseLastInsertRowId()
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
          If Picture\RecordId <> #EmptyString
            
            ;--------------------------------------------------------------------------------------
            ; 
            ;--------------------------------------------------------------------------------------
            
            If Picture\Directory +  Picture\FileName  <> #EmptyString
              
              ;------------------------------------------------------------------------------------
              ; 
              ;------------------------------------------------------------------------------------
              
              FileIn.i = ReadFile(#PB_Any, Picture\Directory +  Picture\FileName)
              
              ;------------------------------------------------------------------------------------
              ; 
              ;------------------------------------------------------------------------------------
              
              If FileIn.i
                
                ;----------------------------------------------------------------------------------
                ; 
                ;----------------------------------------------------------------------------------
                
                FileInSize.i = Lof(FileIn.i)
                
                ;----------------------------------------------------------------------------------
                ; 
                ;----------------------------------------------------------------------------------
                
                *Buffer = AllocateMemory(FileInSize.i)
                
                ;----------------------------------------------------------------------------------
                ; 
                ;----------------------------------------------------------------------------------
                
                If *Buffer
                  
                  ;--------------------------------------------------------------------------------
                  ; 
                  ;--------------------------------------------------------------------------------
                  
                  If ReadData(FileIn.i, *Buffer, FileInSize.i) = FileInSize.i
                    
                    ;------------------------------------------------------------------------------
                    ; 
                    ;------------------------------------------------------------------------------
                    
                    SetDatabaseBlob(Program\DatabaseHandle, 0, *Buffer, FileInSize.i)
                    
                    ;------------------------------------------------------------------------------
                    ; 
                    ;------------------------------------------------------------------------------
                    
                    DatabaseUpdate.s = "INSERT INTO PictureData ("
                    
                    DatabaseUpdate.s + "Picture, Record_Id) "
                    
                    DatabaseUpdate.s + "VALUES (?, '" + Picture\RecordId + "')"
                    
                    ;------------------------------------------------------------------------------
                    ; 
                    ;------------------------------------------------------------------------------
                    
                    If DatabaseUpdate(Program\DatabaseHandle, DatabaseUpdate.s) <> #DatabaseUpdateFail
                      
                      ;----------------------------------------------------------------------------
                      ; 
                      ;----------------------------------------------------------------------------
                      
                      NewRecord.s = DatabaseLastInsertRowId()
                      
                      ;----------------------------------------------------------------------------
                      ; 
                      ;----------------------------------------------------------------------------
                      
                      If NewRecord.s <> #EmptyString
            
                        NewNumberOfItems.i = CountGadgetItems(#Gadget_PiccyDb_Titles)
            
                        DisplayTitleString("AddMode", NewNumberOfItems.i)
            
                        LastLine(#Gadget_PiccyDb_Titles, NewNumberOfItems.i)
            
                        Program\CurrentLine = NewNumberOfItems.i
                        
                      Else
                        
                        SetInfoBarArea("Headings", "Error", "Could not get a new record number for picture data", "SavePictureData()")
                        
                      EndIf
                      
                      ;----------------------------------------------------------------------------
                      ; 
                      ;----------------------------------------------------------------------------
                      
                    Else
                      
                      SetInfoBarArea("Headings", "Error", "Could not save the picture data into the database", "SavePictureData()")
                      
                    EndIf
                    
                    ;------------------------------------------------------------------------------
                    ; 
                    ;------------------------------------------------------------------------------
                    
                  Else
                    
                    SetInfoBarArea("Headings", "Error", "Could not read the picture data into the buffer", "SavePictureData()")
                    
                  EndIf
                  
                  ;--------------------------------------------------------------------------------
                  ; 
                  ;--------------------------------------------------------------------------------
                  
                  FreeMemory(*Buffer)
                  
                  ;--------------------------------------------------------------------------------
                  ; 
                  ;--------------------------------------------------------------------------------
                  
                Else
                  
                  SetInfoBarArea("Headings", "Error", "Could not allocate a buffer for the picture data", "SavePictureData()")
                  
                EndIf
                
                ;----------------------------------------------------------------------------------
                ; 
                ;----------------------------------------------------------------------------------
                
                CloseFile(FileIn.i)
                
                ;----------------------------------------------------------------------------------
                ; 
                ;----------------------------------------------------------------------------------
                
              Else
                
                SetInfoBarArea("Headings", "Error", "Could not open the designated file to read from", "SavePictureData()")
                
              EndIf
              
              ;------------------------------------------------------------------------------------
              ; 
              ;------------------------------------------------------------------------------------
              
            Else
              
              SetInfoBarArea("Headings", "Error", "Picture filename is empty, nothing to save", "SavePictureData()")
              
            EndIf
            
            ;--------------------------------------------------------------------------------------
            ; 
            ;--------------------------------------------------------------------------------------
            
          Else
            
            SetInfoBarArea("Headings",  "Error",  "No record number created " + DatabaseError(), "SaveCurrentPicture")
            
          EndIf
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
        Else
          
          SetInfoBarArea("Headings", "Error", "Database table failed to be updated " + DatabaseError(), "SaveCurrentPicture")
          
        EndIf
        
        ;------------------------------------------------------------------------------------------
        ;
        ;------------------------------------------------------------------------------------------
        
      Case  "Edit An Old Picture"
        
        ;------------------------------------------------------------------------------------------
        ;
        ;------------------------------------------------------------------------------------------
        
        DatabaseUpdate.s = "UPDATE PictureInfo SET "
        
        DatabaseUpdate.s + "Title = '"            + Picture\Title           + "', "
        
        DatabaseUpdate.s + "Artist = '"           + Picture\Artist          + "', "
        
        DatabaseUpdate.s + "Copyright = '"        + Picture\Copyright       + "', "
        
        DatabaseUpdate.s + "Homepage = '"         + Picture\Homepage        + "', "
        
        DatabaseUpdate.s + "Category = '"         + Picture\Category        + "', "
        
        DatabaseUpdate.s + "Subcategory = '"      + Picture\Subcategory     + "', "
        
        DatabaseUpdate.s + "Comment = '"          + Picture\Comment         + "', "
        
        DatabaseUpdate.s + "Directory = '"        + Picture\Directory       + "', "
        
        DatabaseUpdate.s + "Filename = '"         + Picture\Filename        + "' "
        
        ;       DatabaseUpdate.s + "MD5Fingerprint = '"   + Picture\MD5Fingerprint  + "', "
        
        ;       DatabaseUpdate.s + "Created = '"          + Picture\Created         + "', "
        
        ;       DatabaseUpdate.s + "Modified = '"         + Picture\Modified        + "', "
        
        ;       DatabaseUpdate.s + "Accessed = '"         + Picture\Accessed        + "', "
        
        ;       DatabaseUpdate.s + "Accessed = '"         + Picture\Accessed        + "', "
        
        ;       DatabaseUpdate.s + "Horizontal = '"       + Picture\Horizontal      + "', "
        
        ;       DatabaseUpdate.s + "Vertical = '"         + Picture\Vertical        + "', "
        
        ;       DatabaseUpdate.s + "Depth = '"            + Picture\Depth           + "', "
        
        ;       DatabaseUpdate.s + "Favourite = '"        + Picture\Favourite       + "', "
        
        ;       DatabaseUpdate.s + "Locked = '"           + Picture\Locked          + "', "
        
        ;       DatabaseUpdate.s + "Deleted = '"          + Picture\Deleted         + "', "
        
        ;       DatabaseUpdate.s + "RecordId       = '"   + Picture\RecordId        + " "
        
        DatabaseUpdate.s + "WHERE Record_Id = '"  + Program\CurrentRecord   + "'"
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        If DatabaseUpdate(Program\DatabaseHandle, DatabaseUpdate.s) <> #DatabaseUpdateFail
          
          DisplayTitleString("EditMode", Program\CurrentLine)
          
        Else
          
          SetInfoBarArea("Headings", "Error", "Database table failed to be updated " + DatabaseError(), "SaveCurrentPicture")
          
        EndIf
        
        ;------------------------------------------------------------------------------------------
        ;
        ;------------------------------------------------------------------------------------------
        
    EndSelect
    
    ;----------------------------------------------------------------------------------------------
    ;
    ;----------------------------------------------------------------------------------------------
    
    SetGadgetState(#Gadget_PiccyDb_Titles, Program\CurrentLine)
    
    PostEvent(#PB_Event_Gadget, #Window_PiccyDb, #Gadget_PiccyDb_Titles, #PB_EventType_Change)
    
    ;----------------------------------------------------------------------------------------------
    ;
    ;----------------------------------------------------------------------------------------------
    
    CloseMyWindow(#Window_PiccyData)
    
    ;----------------------------------------------------------------------------------------------
    ;
    ;----------------------------------------------------------------------------------------------
    
    UpdateCategoryItemCount(Picture\Category)
    
    ;----------------------------------------------------------------------------------------------
    ;
    ;----------------------------------------------------------------------------------------------
    
    ClearStructure(@Picture, PictureData)
    
    ;----------------------------------------------------------------------------------------------
    ;
    ;----------------------------------------------------------------------------------------------
    
  Else
    
    SetInfoBarArea("Headings", "Error", "Title field must not be empty", "SavePictureData()")
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ;
  ;------------------------------------------------------------------------------------------------
  
EndProcedure

; IDE Options = PureBasic 5.31 (Windows - x86)
; CursorPosition = 56
; FirstLine = 332
; Folding = -
; EnableXP
; HideErrorLog