﻿;==============================================================================================================================================================================
; Save selected pictures to disk
;==============================================================================================================================================================================

Procedure SaveSelectedPicturesToDisk()
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------

  NumberOfPicturesToSave.i = CountGadgetItems(#Gadget_PiccyDb_Titles)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  If NumberOfPicturesToSave.i <> #NoItems
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    For PictureSaveLoop.i = 0 To NumberOfPicturesToSave.i -1
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      CurrentRecord.s = GetGadgetItemText(#Gadget_PiccyDb_Titles, PictureSaveLoop.i, #RecordColumn): Debug CurrentRecord.s
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      If CurrentRecord.s <> #EmptyString
        
        ;------------------------------------------------------------------------------------------
        ; Process the current table name
        ;------------------------------------------------------------------------------------------
        
        DatabaseQuery.s = "SELECT m.Filename, m.Category, m.Subcategory, n.Picture "
        
        DatabaseQuery.s + "FROM PictureInfo AS m, PictureData AS n "
        
        DatabaseQuery.s + "WHERE n.Record_Id = m.Record_Id "
        
        DatabaseQuery.s + "AND m.Record_Id = '"  + CurrentRecord.s  + "'"
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        If DatabaseQuery(Program\DatabaseHandle, DatabaseQuery.s) <> #DatabaseQueryFail
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
          While NextDatabaseRow(Program\DatabaseHandle)
            
            ;--------------------------------------------------------------------------------------
            ; 
            ;--------------------------------------------------------------------------------------
            
            PictureFilename.s       = KillQuote(GetDatabaseString(Program\DatabaseHandle,  0))  ; : Debug PictureFilename.s
            
            PictureCategory.s       = KillQuote(GetDatabaseString(Program\DatabaseHandle,  1))  ; : Debug PictureCategory.s
            
            PictureSubcategory.s    = KillQuote(GetDatabaseString(Program\DatabaseHandle,  2))  ; : Debug PictureSubcategory.s
            
            Picture_Length.i        =           DatabaseColumnSize(Program\DatabaseHandle, 3)   ; : Debug Picture_Length.i
            
            ;--------------------------------------------------------------------------------------
            ; 
            ;--------------------------------------------------------------------------------------
            
            If Picture_Length.i
              
              ;------------------------------------------------------------------------------------
              ; 
              ;------------------------------------------------------------------------------------
              
              *PhotoBlobBuffer      =           AllocateMemory(Picture_Length.i)
              
              ;------------------------------------------------------------------------------------
              ; 
              ;------------------------------------------------------------------------------------
              
              BlobResult.i          =           GetDatabaseBlob(Program\DatabaseHandle, 3, *PhotoBlobBuffer, Picture_Length.i)
              
              ;------------------------------------------------------------------------------------
              ; 
              ;------------------------------------------------------------------------------------
              
              If BlobResult.i <> 0
                
                ;----------------------------------------------------------------------------------
                ; 
                ;----------------------------------------------------------------------------------
                
                If PictureCategory.s <> #EmptyString And PictureSubcategory.s <> #EmptyString
                  
                  NewDirectory.s = Program\TemporaryDirectory + "PiccyDb\" + PictureCategory.s + "\" + PictureSubcategory.s  + "\"
                  
                ElseIf PictureCategory.s <> #EmptyString And PictureSubcategory.s = #EmptyString
                  
                  NewDirectory.s = Program\TemporaryDirectory + "PiccyDb\"  + PictureCategory.s + "\"
                  
                ElseIf PictureCategory.s = #EmptyString
                  
                  NewDirectory.s = Program\TemporaryDirectory + "PiccyDb\"
                  
                EndIf
                
                ;----------------------------------------------------------------------------------
                ; 
                ;----------------------------------------------------------------------------------
                
                ResultCode.s = MakeSureDirectoryPathExists(NewDirectory.s)
                
                ;----------------------------------------------------------------------------------
                ; 
                ;----------------------------------------------------------------------------------
                
                If ResultCode.s = "Okay" Or ResultCode.s = "Directory already exists"
                  
                  ;--------------------------------------------------------------------------------
                  ; 
                  ;--------------------------------------------------------------------------------
                  
                  SaveFileHandle.i = CreateFile(#PB_Any, NewDirectory.s + GetFilePart(PictureFilename.s))
                  
                  ;--------------------------------------------------------------------------------
                  ; 
                  ;--------------------------------------------------------------------------------
                  
                  ;Debug Program\TemporaryDirectory + GetFilePart(PictureFilename.s) + "  --  "  + Str(SaveFileHandle.i)
                  
                  ;--------------------------------------------------------------------------------
                  ; 
                  ;--------------------------------------------------------------------------------
                  
                  If SaveFileHandle.i <> 0
                    
                    WriteData(SaveFileHandle.i, *PhotoBlobBuffer, Picture_Length.i)
                    
                    CloseFile(SaveFileHandle.i)
                    
                    SetInfoBarArea("Headings", "Info", "Saved: " + NewDirectory.s + PictureFilename.s)
                    
                  Else
                    
                    SetInfoBarArea("Headings", "Error", "Could not create a handle for the picture file to save", "SaveSelectedPicturesToDisk")
                    
                  EndIf
                  
                  ;--------------------------------------------------------------------------------
                  ; 
                  ;--------------------------------------------------------------------------------
                  
                Else
                  
                  SetInfoBarArea("Headings", "Error", "Could not create the category based picture directory", "SaveSelectedPicturesToDisk")
                  
                EndIf
                
                ;----------------------------------------------------------------------------------
                ; 
                ;----------------------------------------------------------------------------------
                
              Else
                
                SetInfoBarArea("Headings", "Error", "Could not get the blob data back from the database", "SaveSelectedPicturesToDisk")
                
              EndIf
              
              ;------------------------------------------------------------------------------------
              ; 
              ;------------------------------------------------------------------------------------
              
              FreeMemory(*PhotoBlobBuffer)
              
              ;------------------------------------------------------------------------------------
              ; 
              ;------------------------------------------------------------------------------------
              
            Else
              
              SetInfoBarArea("Headings", "Error", "There was no data in that blob field", "SaveSelectedPicturesToDisk")
              
            EndIf
            
            ;--------------------------------------------------------------------------------------
            ; 
            ;--------------------------------------------------------------------------------------
            
          Wend
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
          FinishDatabaseQuery(Program\DatabaseHandle)
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
        Else
          
          SetInfoBarArea("Headings", "Error", "The query failed or returned no data"  + DatabaseError(), "SaveSelectedPicturesToDisk")
          
        EndIf
      
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
      Else
        
        SetInfoBarArea("Headings", "Error", "No record number found for this picture???", "SaveSelectedPicturesToDisk")
        
      EndIf
        
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
    Next  PictureSaveLoop.i
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
  
  Else
    
    SetInfoBarArea("Headings", "Info", "No pictures selected in the list to save", "SaveSelectedPicturesToDisk")
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure

; IDE Options = PureBasic 5.31 (Windows - x86)
; CursorPosition = 217
; FirstLine = 179
; Folding = -
; EnableAsm
; EnableUnicode
; EnableXP