﻿;==============================================================================================================================================================================
; Show the currently selected picture details
;==============================================================================================================================================================================

Procedure ShowCurrentPicture()
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  Program\CurrentLine = GetGadgetState(#Gadget_PiccyDb_Titles)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------

  If Program\CurrentLine  <> #NothingSelected
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    ; Debug "Current line is: " + Str(Program\CurrentLine)
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    Program\CurrentRecord = GetGadgetItemText(#Gadget_PiccyDb_Titles, Program\CurrentLine,  #RecordColumn)
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
    ; Debug "Current record is: " + Program\CurrentRecord
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------

    If Program\CurrentRecord  <> #EmptyString
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      QueryString.s = "SELECT m.*, n.Picture "
      
      QueryString.s + "FROM PictureInfo AS m, PictureData AS n "
      
      QueryString.s + "WHERE n.Record_Id = m.Record_Id "      
      
      QueryString.s + "AND m.Record_Id = '" + Program\CurrentRecord + "'"
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      If DatabaseQuery(Program\DatabaseHandle, QueryString.s) <> #DatabaseQueryFail
        
        While NextDatabaseRow(Program\DatabaseHandle)
          
          Picture\Title           = KillQuote(GetDatabaseString(Program\DatabaseHandle,   0))
          
          Picture\Artist          = KillQuote(GetDatabaseString(Program\DatabaseHandle,   1))
          
          Picture\Copyright       = KillQuote(GetDatabaseString(Program\DatabaseHandle,   2))
          
          Picture\Homepage        = KillQuote(GetDatabaseString(Program\DatabaseHandle,   3))
          
          Picture\Category        = KillQuote(GetDatabaseString(Program\DatabaseHandle,   4))
          
          Picture\Subcategory     = KillQuote(GetDatabaseString(Program\DatabaseHandle,   5))
          
          Picture\Comment         = KillQuote(GetDatabaseString(Program\DatabaseHandle,   6))
          
          Picture\Directory       = KillQuote(GetDatabaseString(Program\DatabaseHandle,   7))
          
          Picture\Filename        = KillQuote(GetDatabaseString(Program\DatabaseHandle,   8))
          
          Picture\MD5Fingerprint  =           GetDatabaseString(Program\DatabaseHandle,   9)
          
          Picture\Created         =           GetDatabaseString(Program\DatabaseHandle,   10)
          
          Picture\Modified        =           GetDatabaseString(Program\DatabaseHandle,   11)
          
          Picture\Accessed        =           GetDatabaseString(Program\DatabaseHandle,   12)
          
          Picture\Archived        =           GetDatabaseString(Program\DatabaseHandle,   13)
          
          Picture\Horizontal      =           GetDatabaseString(Program\DatabaseHandle,   14)
          
          Picture\Vertical        =           GetDatabaseString(Program\DatabaseHandle,   15)
          
          Picture\Depth           =           GetDatabaseString(Program\DatabaseHandle,   16)
          
          Picture\Favourite       =           GetDatabaseString(Program\DatabaseHandle,   17) 
          
          Picture\Locked          =           GetDatabaseString(Program\DatabaseHandle,   18) 
          
          Picture\Deleted         =           GetDatabaseString(Program\DatabaseHandle,   19) 
          
          Picture\RecordId        =           GetDatabaseString(Program\DatabaseHandle,   20)
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
          Picture_Length.i        =           DatabaseColumnSize(Program\DatabaseHandle,  21)
          
          If Picture_Length.i <> #NoDataFound
            
            *PhotoBlobBuffer      =           AllocateMemory(Picture_Length.i)
            
            BlobResult.i          =           GetDatabaseBlob(Program\DatabaseHandle, 21, *PhotoBlobBuffer, Picture_Length.i)
            
          EndIf
          
          ;----------------------------------------------------------------------------------------
          ; 
          ;----------------------------------------------------------------------------------------
          
        Wend
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------

        FinishDatabaseQuery(Program\DatabaseHandle)
        
        ;------------------------------------------------------------------------------------------
        ;
        ;------------------------------------------------------------------------------------------
        
        If BlobResult.i <> #NoBlobFound
          
          PictureHandle.i = CatchImage(#PB_Any, *PhotoBlobBuffer)
          
          If PictureHandle.i  <> #NoPictureHandle
            
            ResizeImage(PictureHandle.i, #MainPictureWidth, #MainPictureHeight, #PB_Image_Smooth)
            
            SetGadgetState(#Gadget_PiccyDb_picture, ImageID(PictureHandle.i))
            
          EndIf
          
        Else
          
          ResizeImage(#Image_PiccyData_picture, #MainPictureWidth, #MainPictureHeight, #PB_Image_Smooth)
          
          SetGadgetState(#Gadget_PiccyDb_picture,     ImageID(#Image_PiccyData_picture))
          
        EndIf
        
        ;------------------------------------------------------------------------------------------
        ;
        ;------------------------------------------------------------------------------------------
        
       ;SetGadgetText(#Gadget_PiccyDb_Directory,              Picture\Directory)

       ;SetGadgetText(#Gadget_PiccyDb_Filename,               Picture\FileName)

       ;SetGadgetText(#Gadget_PiccyDb_Title,                  Picture\Title)
        
        SetGadgetText(#Gadget_PiccyDb_sCategory,              Picture\Category)
        
        SetGadgetText(#Gadget_PiccyDb_sSubcategory,           Picture\Subcategory)
        
        SetGadgetText(#Gadget_PiccyDb_Artist,                 Picture\Artist)
        
        SetGadgetText(#Gadget_PiccyDb_Copyright,              Picture\Copyright)
        
        SetGadgetText(#Gadget_PiccyDb_Homepage,               Picture\Homepage)
        
        SetGadgetText(#Gadget_PiccyDb_Comment,                Picture\Comment)
        
        SetGadgetText(#Gadget_PiccyDb_created,        IsoDate(Picture\Created,  "NormalDate"))
        
        SetGadgetText(#Gadget_PiccyDb_modified,       IsoDate(Picture\Modified, "NormalDate"))
        
        SetGadgetText(#Gadget_PiccyDb_accessed,       IsoDate(Picture\Accessed, "NormalDate"))
        
        SetGadgetText(#Gadget_PiccyDb_archivedOn,     IsoDate(Picture\Archived, "NormalDate"))
        
        SetGadgetText(#Gadget_PiccyDb_Horizontal,             Picture\Horizontal)
        
        SetGadgetText(#Gadget_PiccyDb_Vertical,               Picture\Vertical)
        
        SetGadgetText(#Gadget_PiccyDb_Depth,                  Picture\Depth)
        
;       SetGadgetText(#Gadget_PiccyDb_MD5Fingerprint,         Picture\Md5Fingerprint)

;       SetGadgetText(#Gadget_PiccyDb_Favourite,              Picture\Favourite)

;       SetGadgetText(#Gadget_PiccyDb_Locked,                 Picture\Locked)

;       SetGadgetText(#Gadget_PiccyDb_Deleted,                Picture\Deleted)

;       SetGadgetText(#Gadget_PiccyDb_Record_Id,              Picture\RecordId)
        
        If Picture\Title <> #EmptyString
          
          SetGadgetItemText(#Gadget_PiccyDb_Titles, -1, "Title >> " + Picture\Title, 0)
          
          SetInfoBarArea("Headings",  "Info",  "Title >> [" + Picture\Title + "], Category >> [" + Picture\Category + "]")
          
        Else
          
          SetGadgetItemText(#Gadget_PiccyDb_Titles, -1, "Title >> [Empty title]", 0)
          
          SetInfoBarArea("Headings",  "Info",  "Title >> [Empty title], Category >> [" + Picture\Category + "]")
          
        EndIf

        SetInfoBarArea("Number",  #EmptyString, Picture\RecordId)
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------

      Else
        
        SetInfoBarArea("Headings", "Error", "Database query failed or was empty: " + DatabaseError(), "ShowCurrentPicture()")
        
      EndIf
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
    Else
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      ResizeImage(#Image_PiccyData_picture, #MainPictureWidth, #MainPictureHeight, #PB_Image_Smooth)

      SetGadgetState(#Gadget_PiccyDb_picture,     ImageID(#Image_PiccyData_picture))
      
      SetGadgetText(#Gadget_PiccyDb_sCategory,    #EmptyString)
      
      SetGadgetText(#Gadget_PiccyDb_sSubcategory, #EmptyString)

      SetGadgetText(#Gadget_PiccyDb_Artist,       #EmptyString)
      
      SetGadgetText(#Gadget_PiccyDb_Copyright,    #EmptyString)
      
      SetGadgetText(#Gadget_PiccyDb_Homepage,     #EmptyString)
      
      SetGadgetText(#Gadget_PiccyDb_Comment,      #EmptyString)
      
      SetGadgetText(#Gadget_PiccyDb_created,      #EmptyString)
      
      SetGadgetText(#Gadget_PiccyDb_modified,     #EmptyString)
      
      SetGadgetText(#Gadget_PiccyDb_accessed,     #EmptyString)
      
      SetGadgetText(#Gadget_PiccyDb_archivedOn,   #EmptyString)
      
      SetGadgetText(#Gadget_PiccyDb_Horizontal,   #EmptyString)
      
      SetGadgetText(#Gadget_PiccyDb_Vertical,     #EmptyString)
      
      SetGadgetText(#Gadget_PiccyDb_Depth,        #EmptyString)
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      SetInfoBarArea("Headings", "Error", "No record number found on line: " + Str(Program\CurrentLine), "ShowCurrentPicture()")
      
    EndIf
    
    ;----------------------------------------------------------------------------------------------
    ; 
    ;----------------------------------------------------------------------------------------------
    
  Else
    
    SetInfoBarArea("Headings", "Info", "There is no current line selected", "ShowCurrentPicture()")
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------

EndProcedure

; IDE Options = PureBasic 5.31 (Windows - x86)
; CursorPosition = 289
; FirstLine = 244
; Folding = -
; EnableXP