;================================================================================================================================================================================
; Count the number of records in an SQLite database
;================================================================================================================================================================================

Procedure.s CountRecords(TableField.s, TableName.s)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  DatabaseQuery.s + "Select COUNT(" + TableField.s + ") AS totalrecs FROM " + TableName.s + ""
  
  ;------------------------------------------------------------------------------------------------
  ; Get the count of the records in the database
  ;------------------------------------------------------------------------------------------------

  If DatabaseQuery(Program\DatabaseHandle, DatabaseQuery.s)
    
    If FirstDatabaseRow(Program\DatabaseHandle)
        
      NumberOfRecords.s = GetDatabaseString(Program\DatabaseHandle, 0)
      
    EndIf
      
    FinishDatabaseQuery(Program\DatabaseHandle)
  
  Else
    
    NumberOfRecords.s = "0"
    
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  ProcedureReturn NumRecords.s
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------

EndProcedure



; IDE Options = PureBasic 5.31 (Windows - x86)
; CursorPosition = 10
; Folding = -
; DisableDebugger
; HideErrorLog