﻿;==============================================================================================================================================================================
; Remove borders from various gadgets
;==============================================================================================================================================================================

Procedure RemoveBorders(GadgetConstant.i)
  
  ;------------------------------------------------------------------------------------------------
  ; Get the gadget type from the passed gadget constant
  ;------------------------------------------------------------------------------------------------
  
  GadgetType.i = GadgetType(GadgetConstant.i)
  
  ;------------------------------------------------------------------------------------------------
  ; Select the gadget type
  ;------------------------------------------------------------------------------------------------
  
  Select GadgetType.i
      
    ;----------------------------------------------------------------------------------------------
    ; Do the below if it is a ListIconGadget
    ;----------------------------------------------------------------------------------------------
    
    Case  #PB_GadgetType_ListIcon
    
      ;--------------------------------------------------------------------------------------------
      ; Remove borders from ListIconGadgets
      ;--------------------------------------------------------------------------------------------
      
      OldStyle.i = GetWindowLongPtr_(GadgetID(GadgetConstant.i), #GWL_EXSTYLE)
      
      NewStyle .i= OldStyle.i & ( ~ #WS_EX_CLIENTEDGE)
      
      SetWindowLongPtr_(GadgetID(GadgetConstant.i), #GWL_EXSTYLE, GadgetConstant.i)
      
      SetWindowPos_(GadgetID(GadgetConstant.i), 0, 0, 0, 0, 0, #SWP_SHOWWINDOW | #SWP_NOSIZE | #SWP_NOMOVE | #SWP_FRAMECHANGED)
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
    Case  #PB_GadgetType_Option,  #PB_GadgetType_CheckBox
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      SetWindowTheme_(GadgetID(GadgetConstant.i), @null.w, @null.w)
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
    Case #PB_GadgetType_Editor
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
      
      CurrentOSVersion.i = OSVersion()
      
      ;--------------------------------------------------------------------------------------------
      ; Ugly hack to reove theme based on Q/S variances
      ;--------------------------------------------------------------------------------------------
      
      If CurrentOSVersion.i  >= #PB_OS_Windows_XP And CurrentOSVersion.i <= #PB_OS_Windows_7

        ;------------------------------------------------------------------------------------------
        ; Remove border from editorgadget (comment) field. Stiil leaves a 1 pixel border but that looks good here
        ;------------------------------------------------------------------------------------------
        
        SetWindowLongPtr_(GadgetID(GadgetConstant.i), #GWL_EXSTYLE, GetWindowLongPtr_(GadgetID(GadgetConstant.i), #GWL_EXSTYLE) & (~#WS_EX_CLIENTEDGE))
        
        SetWindowPos_(GadgetID(GadgetConstant.i), 0, 0, 0, 0, 0, #SWP_SHOWWINDOW | #SWP_NOSIZE | #SWP_NOMOVE | #SWP_FRAMECHANGED)
      
      ElseIf CurrentOSVersion.i >= #PB_OS_Windows_8
      
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
        SetWindowTheme_(GadgetID(GadgetConstant.i), @null.w, @null.w)
        
        ;------------------------------------------------------------------------------------------
        ; 
        ;------------------------------------------------------------------------------------------
        
      EndIf
      
      ;--------------------------------------------------------------------------------------------
      ; 
      ;--------------------------------------------------------------------------------------------
    
  EndSelect
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
EndProcedure

; IDE Options = PureBasic 5.31 (Windows - x86)
; CursorPosition = 65
; FirstLine = 43
; Folding = -
; EnableXP