﻿;==============================================================================================================================================================================
; Author: Fangbeast (MGB Technical Solutions) 2015
; 
; License: Do whatever you want with it except claim that it is yours. You may never, ever sell it.
; 
; Credits; Bernd Krüger-Knauber (InfraTec) for fixing a lot of my blob, import mistakes and just about ever other program that I had issues with.
; People underestimate his knowledge and help, he is a top bloke.
; 
; NetMaestro. His MouseHover library has been shoehorned into just about every program I make now. But he's helped with a lot of things by proxy,
; if not directly.
;==============================================================================================================================================================================
; 
;==============================================================================================================================================================================

UseJPEG2000ImageDecoder()                                                                             ; PureBasic native image decoder
UseJPEGImageDecoder()                                                                                 ; PureBasic native image decoder
;UsePNGImageDecoder()                   ; Defined in Piccy_Constants.pb                               ; PureBasic native image decoder
UseTGAImageDecoder()                                                                                  ; PureBasic native image decoder
UseTIFFImageDecoder()                                                                                 ; PureBasic native image decoder

;==============================================================================================================================================================================
; Set the system to use SQLite database handling
;==============================================================================================================================================================================

UseSQLiteDatabase()                                                                                   ; Use the SQLite database backend

;==============================================================================================================================================================================
; Bernd's macro to convert md5 cipher between compiler versions
;==============================================================================================================================================================================

CompilerIf #PB_Compiler_Version > 531
  UseMD5Fingerprint()
  Macro MD5Fingerprint(Line, StringByteLength)
    Fingerprint(Line, StringByteLength, #PB_Cipher_MD5)
  EndMacro
  Macro MD5FileFingerprint(Filename, Offset = -1, Length = -1)
    FileFingerprint(Filename, #PB_Cipher_MD5, 0, Offset, Length)
  EndMacro
CompilerEndIf

;==============================================================================================================================================================================
; Main program bits
;==============================================================================================================================================================================

XIncludeFile "Piccy_Constants.pb"                                                                   ; Visual designer created constants
XIncludeFile "Piccy_Windows.pb"                                                                     ; Visual designer created window code
XIncludeFile "Piccy_MyDeclarations.pb"                                                              ; My procedural declarations
XIncludeFile "Piccy_MyConstants.pb"                                                                 ; My personal constants

;==============================================================================================================================================================================
; NetMaestro's mouse hover events code
;==============================================================================================================================================================================

XIncludeFile "Modules\ThirdParty\_NM_Hover.pbi"                                                     ; NetMaestro's Hover library

;==============================================================================================================================================================================
; Generic modules used by all programs
;==============================================================================================================================================================================

XIncludeFile "Modules\Generic\_FormatMenu.pbi"                                                      ; Format menu text and shortcut strings to nice length
XIncludeFile "Modules\Generic\_GetShortcutText.pbi"                                                 ; Get the text of the associated shortcut constant
XIncludeFile "Modules\Generic\_GetWindowTitleBarDetails.pbi"                                        ; Get the current windows title bar height
XIncludeFile "Modules\Generic\_KillQuote.pbi"                                                       ; Kill double quotes in strings for display purposes
XIncludeFile "Modules\Generic\_LastLine.pbi"                                                        ; Go to the last line of a ListIconGadget
XIncludeFile "Modules\Generic\_MakeSureDirectoryPathExists.pbi"                                     ; Need a unicode aware version of the API directory creator
XIncludeFile "Modules\Generic\_MixedComboCaseEx.pbi"                      ; TODO                    ; First letter uppercase in a combo box. srod!.
XIncludeFile "Modules\Generic\_MixedStringCase.pbi"                                                 ; First letter uppercase in a string box. srod!
XIncludeFile "Modules\Generic\_ProperCaseString.pbi"                                                ; Flip a mixed string into all proper case
XIncludeFile "Modules\Generic\_RemoveBorders.pbi"                                                   ; Remove borders from various gadgets
XIncludeFile "Modules\Generic\_RepQuote.pbi"                                                        ; Uncle Berikco's routine to properly replace single quotes with double for SQL passing
XIncludeFile "Modules\Generic\_StringFirstUpper.pbi"                                                ; Convert the first character of a string to uppercase
XIncludeFile "Modules\Generic\_TextToXML.pbi"                                                       ; Replace bad characters with XML compatible ones. Thorsten Hoeppner
XIncludeFile "Modules\Generic\_XMLToText.pbi"                                                       ; Strip illegal characters from text strings

;==============================================================================================================================================================================
; Form and list handling
;==============================================================================================================================================================================

XIncludeFile "Modules\Forms\_SetHoverIcons.pbi"                                                     ; Set the correct icons to the selected hoverable gadget

;==============================================================================================================================================================================
; Custom include files
;==============================================================================================================================================================================

XIncludeFile "Modules\Custom\_CheckEnterGadget.pbi"                                                 ; Check which gadget had the focus at the time ENTER was pressed
XIncludeFile "Modules\Custom\_CloseMyWindow.pbi"                                                    ; Fade the window out gently, close it and reset the mutex
XIncludeFile "Modules\Custom\_IsoDate.pbi"                                                          ; Convert an ISO format date to Australian and back
XIncludeFile "Modules\Custom\_ReadProgramOptions.pbi"                                               ; Read the program toggles from the database
XIncludeFile "Modules\Custom\_SaveProgramOptions.pbi"                                               ; Save all the program options whenever you need to
XIncludeFile "Modules\Custom\_SetInfoBarArea.pbi"                                                   ; Send messages and error reports to the fake status bar area
XIncludeFile "Modules\Custom\_StatusBarTip.pbi"                                                     ; Custom statusbar tooltip messages
XIncludeFile "Modules\Custom\_TitleBarClock.pbi"                                                    ; Run an asynchronous clock in the window title bar
XIncludeFile "Modules\Custom\_WindowCallback.pbi"                                                   ; Custom module for colours, deletions etc

;==============================================================================================================================================================================
; Various program toggles
;==============================================================================================================================================================================

XIncludeFile "Modules\Toggles\_ToggleStickyWindow.pbi"                                              ; Change the desktop from on top to under others
XIncludeFile "Modules\Toggles\_ToggleTitleClock.pbi"                                                ; Turn the titlebar clock on or off
XIncludeFile "Modules\Toggles\_ToggleScreenSnap.pbi"                                                ; Turn snapping to screen borders on and off

;==============================================================================================================================================================================
; Minimising and maximising the program window
;==============================================================================================================================================================================

XIncludeFile "Modules\Windows\_HideProgramWindow.pbi"                                               ; Hide the program window
XIncludeFile "Modules\Windows\_ShowProgramWindow.pbi"                                               ; Show the program window

;==============================================================================================================================================================================
; Database functions
;==============================================================================================================================================================================

XIncludeFile "Modules\Database\_BackupDatabase.pbi"                                                 ; Backup the current database to a named day of the week
XIncludeFile "Modules\Database\_CountRecords.pbi"                                                   ; Count the number of records in an SQLite database
XIncludeFile "Modules\Database\_DatabaseLastInsertRowId.pbi"                                        ; Get the ID of the last inserted record
XIncludeFile "Modules\Database\_FillCombo.pbi"                                                      ; Fill a combobox gadget from a linked list, SQLite version
XIncludeFile "Modules\Database\_LastRecord.pbi"                                                     ; Find the last record number in the database, not necessarily the last record though due to deletions (fang)
XIncludeFile "Modules\Database\_OpenSystemDatabase.pbi"                                             ; Open or create the system database and create any needed tables
XIncludeFile "Modules\Database\_SetSearchQuery.pbi"                                                 ; Alias the search type text to SQLite operators
XIncludeFile "Modules\Database\_VacuumDatabase.pbi"                                                 ; Clean all deleted items from the database immediately

;==============================================================================================================================================================================
; Categories management
;==============================================================================================================================================================================

XIncludeFile "Modules\Category\_LoadCategories.pbi"                ; Fixed                          ; Load all the categories into the category bar
XIncludeFile "Modules\Category\_ShowCategory.pbi"                                                   ; Show the items that belong to a particular category
XIncludeFile "Modules\Category\_SortCategoryEntries.pbi"                                            ; Sort the category list after an add or edit

XIncludeFile "Modules\Category\_ChangeCategory.pbi"                                                 ; Change the category of a title by dragging and dropping it onto the category bar
XIncludeFile "Modules\Category\_DragToCategory.pbi"                                                 ; Change the category of a title by dragging and dropping it onto the category bar

XIncludeFile "Modules\Category\_AddCategory.pbi"                   ; *** Window ***                 ; Add a new category to the database
XIncludeFile "Modules\Category\_CopyCategory.pbi"                                                   ; Copy the current category to the clipboard
XIncludeFile "Modules\Category\_DeleteCategory.pbi"                                                 ; Delete the selected category
XIncludeFile "Modules\Category\_EditCategory.pbi"                  ; *** Window ***                 ; Edit the selected category
XIncludeFile "Modules\Category\_ExportCategories.pbi"                                               ; Import a list of categories from a text file
XIncludeFile "Modules\Category\_ImportCategories.pbi"                                               ; Export the list of categories to disk
XIncludeFile "Modules\Category\_SaveCategory.pbi"                                                   ; Save the changed category data to the database
XIncludeFile "Modules\Category\_UpdateCategoryItemCount.pbi"                                        ; Update the category itemcount field each time we add, change or delete addresses or categories

;==============================================================================================================================================================================
; All data handling routines
;==============================================================================================================================================================================

XIncludeFile "Modules\Data\_AttachPicture.pbi"                                                      ; Attach a new picture to the record editor form
XIncludeFile "Modules\Data\_DisplayTitleString.pbi"                                                 ; Display the added or edited title string
XIncludeFile "Modules\Data\_LoadPictures.pbi"                                                       ; Load all pictures at startup

XIncludeFile "Modules\Data\_AddNewPicture.pbi"                     ; *** Window ***                 ; Add a new picture and details to the database
XIncludeFile "Modules\Data\_AddPictureFolder.pbi"                                                   ; Add an entire folder of pictures
XIncludeFile "Modules\Data\_CopyCurrentPicture.pbi"                                                 ; Copy the currently selected picture to the system clipboard
XIncludeFile "Modules\Data\_DeleteCurrentPicture.pbi"                                               ; Delete the currently selected picture
XIncludeFile "Modules\Data\_EditCurrentPicture.pbi"                ; *** Window ***                 ; Edit the currently selected picture
XIncludeFile "Modules\Data\_ExportPictures.pbi"                                                     ; Export all pictures to disk as an XML file
XIncludeFile "Modules\Data\_FavouriteCurrentPicture.pbi"                                            ; Mark the current picture as a favourite
XIncludeFile "Modules\Data\_ImportPictures.pbi"                                                     ; Import pictures from disk
XIncludeFile "Modules\Data\_KillCurrentPicture.pbi"                                                 ; Permanently delete the current picture
XIncludeFile "Modules\Data\_LockCurrentPicture.pbi"                                                 ; Lock the current picture against editing
XIncludeFile "Modules\Data\_ProcessPictureNode.pbi"                                                 ; Process the current picture node data
XIncludeFile "Modules\Data\_SavePictureData.pbi"                                                    ; Save the new or edited picture data
XIncludeFile "Modules\Data\_SaveCurrentPictureToDisk.pbi"                                           ; Save the current picture to disk
XIncludeFile "Modules\Data\_SaveSelectedPicturesToDisk.pbi"                                         ; Save all selected pictures to disk  
XIncludeFile "Modules\Data\_SaveCategoryPicturesToDisk.pbi"                                         ; Save pictures in the current category to disk
XIncludeFile "Modules\Data\_SaveAllPicturesToDisk.pbi"             ; Modified with subdirs          ; Save all pictures to disk
XIncludeFile "Modules\Data\_SearchPictures.pbi"                                                     ; Show all the pictures in the database
XIncludeFile "Modules\Data\_ShowCurrentPicture.pbi"                                                 ; Show the currently selected picture details
XIncludeFile "Modules\Data\_ViewCurrentPicture.pbi"                                                 ; Show a bigger version of the stored picture

;==============================================================================================================================================================================
; 
;==============================================================================================================================================================================

XIncludeFile "Modules\Data\_AboutProgram.pbi"                                                       ; Show an 'about' program window
XIncludeFile "Modules\Data\_ShowProgramHelp.pbi"                                                    ; Show available program help

;==============================================================================================================================================================================
; Open the master database, create tables and default values
;==============================================================================================================================================================================

OpenSystemDatabase()                                                                                 ; Open system database

;==============================================================================================================================================================================
; 
;==============================================================================================================================================================================

If Window_PiccyDb()
  
  ;------------------------------------------------------------------------------------------------
  ; One time category update for upgrading users without the category counter in the category bar
  ;------------------------------------------------------------------------------------------------
  ;   NewList CategoryName.s()
  ;   DatabaseQuery.s = "SELECT Category FROM Categories"
  ;   If DatabaseQuery(Program\DatabaseHandle, DatabaseQuery.s) <> #DatabaseQueryFail
  ;     While NextDatabaseRow(Program\DatabaseHandle) <> #NoItems
  ;       AddElement(CategoryName.s())
  ;       CategoryName.s()  = KillQuote(GetDatabaseString(Program\DatabaseHandle,  0))
  ;     Wend
  ;     FinishDatabaseQuery(Program\DatabaseHandle)
  ;     ForEach CategoryName.s()
  ;       DatabaseQuery.s = "SELECT COUNT(Category) "
  ;       DatabaseQuery.s + "AS totalrecs FROM PictureInfo "
  ;       DatabaseQuery.s + "WHERE Category = '" + RepQuote(CategoryName.s()) + "'"
  ;       If DatabaseQuery(Program\DatabaseHandle, DatabaseQuery.s) <> #DatabaseQueryFail
  ;         While NextDatabaseRow(Program\DatabaseHandle) <> #NoItems
  ;           ItemInCategoryCount.s = GetDatabaseString(Program\DatabaseHandle,  0)
  ;         Wend
  ;         FinishDatabaseQuery(Program\DatabaseHandle)
  ;         If ItemInCategoryCount.s <> "0"
  ;           DatabaseUpdate.s  = "UPDATE Categories "
  ;           DatabaseUpdate.s  + "SET ItemCount = '" + ItemInCategoryCount.s + "' "
  ;           DatabaseUpdate.s  + "WHERE Category = '"  + RepQuote(CategoryName.s())  + "'"
  ;           If DatabaseUpdate(Program\DatabaseHandle, DatabaseUpdate.s) <> #DatabaseUpdateFail
  ;             ; Update the category item count
  ;           EndIf
  ;         EndIf
  ;       EndIf
  ;     Next  CategoryName.s()
  ;   EndIf

  ;------------------------------------------------------------------------------------------------
  ; Create the main window menu
  ;------------------------------------------------------------------------------------------------
  
  If CreateImageMenu(#MenuBar_PiccyDb, WindowID(#Window_PiccyDb)) <> #NoMenuCreated
    MenuTitle("File menu")
    MenuItem(#MenuBar_PiccyDb_BackupDatabase,       FormatMenu(#Text_BackupDatabase,    GetShortcutText(#Keys_BackupDatabase),  36),  ImageID(#MenuBarIcon_PiccyDb_BackupDatabase))
    MenuItem(#MenuBar_PiccyDb_VacuumDatabase,       FormatMenu(#Text_VacuumDatabase,    GetShortcutText(#Keys_VacuumDatabase),  36),  ImageID(#MenuBarIcon_PiccyDb_VacuumDatabase))
    MenuBar()
    MenuItem(#MenuBar_PiccyDb_ExitProgram,          FormatMenu(#Text_ExitProgram,       GetShortcutText(#Keys_Exit),            36),  ImageID(#MenuBarIcon_PiccyDb_ExitProgram))
    MenuTitle("Category menu")
    MenuItem(#MenuBar_PiccyDb_AddCategory,          FormatMenu(#Text_AddCategory,       GetShortcutText(#Keys_AddCategory),     36),  ImageID(#MenuBarIcon_PiccyDb_AddCategory))
    MenuItem(#MenuBar_PiccyDb_CopyCategory,         FormatMenu(#Text_CopyCategory,      GetShortcutText(#Keys_CopyCategory),    36),  ImageID(#MenuBarIcon_PiccyDb_CopyCategory))
    MenuItem(#MenuBar_PiccyDb_DeleteCategory,       FormatMenu(#Text_DeleteCategory,    GetShortcutText(#Keys_DeleteCategory),  36),  ImageID(#MenuBarIcon_PiccyDb_DeleteCategory))
    MenuItem(#MenuBar_PiccyDb_EditCategory,         FormatMenu(#Text_EditCategory,      GetShortcutText(#Keys_EditCategory),    36),  ImageID(#MenuBarIcon_PiccyDb_EditCategory))
    MenuBar()
    MenuItem(#MenuBar_PiccyDb_ExportCategory,       FormatMenu(#Text_ExportCategory,    GetShortcutText(#Keys_ExportCategory),  36),  ImageID(#MenuBarIcon_PiccyDb_ExportCategory))
    MenuItem(#MenuBar_PiccyDb_ImportCategory,       FormatMenu(#Text_ImportCategory,    GetShortcutText(#Keys_ImportCategory),  36),  ImageID(#MenuBarIcon_PiccyDb_ImportCategory))
    MenuTitle("Picture menu")
    MenuItem(#MenuBar_PiccyDb_AddPicture,           FormatMenu(#Text_AddPicture,        GetShortcutText(#Keys_Add),             36),  ImageID(#MenuBarIcon_PiccyDb_AddPicture))
    MenuItem(#MenuBar_PiccyDb_AddFolder,            FormatMenu(#Text_AddFolder,         GetShortcutText(#Keys_AddFolder),       36),  ImageID(#MenuBarIcon_PiccyDb_AddFolder))
    MenuItem(#MenuBar_PiccyDb_CopyPicture,          FormatMenu(#Text_CopyPicture,       GetShortcutText(#Keys_Copy),            36),  ImageID(#MenuBarIcon_PiccyDb_CopyPicture))
    MenuItem(#MenuBar_PiccyDb_DeletePicture,        FormatMenu(#Text_DeletePicture,     GetShortcutText(#Keys_Delete),          36),  ImageID(#MenuBarIcon_PiccyDb_DeletePicture))
    MenuItem(#MenuBar_PiccyDb_EditPicture,          FormatMenu(#Text_EditPicture,       GetShortcutText(#Keys_Edit),            36),  ImageID(#MenuBarIcon_PiccyDb_EditPicture))
    MenuBar()
    MenuItem(#MenuBar_PiccyDb_FavouritePicture,     FormatMenu(#Text_FavouritePicture,  GetShortcutText(#Keys_Favourite),       36),  ImageID(#MenuBarIcon_PiccyDb_FavouritePicture))
    MenuItem(#MenuBar_PiccyDb_KillPicture,          FormatMenu(#Text_KillPicture,       GetShortcutText(#Keys_Kill),            36),  ImageID(#MenuBarIcon_PiccyDb_KillPicture))
    MenuItem(#MenuBar_PiccyDb_LockPicture,          FormatMenu(#Text_LockPicture,       GetShortcutText(#Keys_Lock),            36),  ImageID(#MenuBarIcon_PiccyDb_LockPicture))
    MenuBar()
    MenuItem(#MenuBar_PiccyDb_SavePicture,          FormatMenu(#Text_SavePicture,       GetShortcutText(#Keys_Save),            36),  ImageID(#MenuBarIcon_PiccyDb_SavePicture))
    MenuItem(#MenuBar_PiccyDb_SaveAllPictures,      FormatMenu(#Text_SaveAllPictures,   GetShortcutText(#Keys_SaveAll),         36),  ImageID(#MenuBarIcon_PiccyDb_SaveAllPictures))
    MenuItem(#MenuBar_PiccyDb_ViewPicture,          FormatMenu(#Text_ViewPicture,       GetShortcutText(#Keys_View),            36),  ImageID(#MenuBarIcon_PiccyDb_ViewPicture))
    MenuTitle("Utility menu")
    MenuItem(#MenuBar_PiccyDb_ExportPictures,       FormatMenu(#Text_ExportPictures,    GetShortcutText(#Keys_Export),          36),  ImageID(#MenuBarIcon_PiccyDb_ExportPictures))
    MenuItem(#MenuBar_PiccyDb_ImportPictures,       FormatMenu(#Text_ImportPictures,    GetShortcutText(#Keys_Import),          36),  ImageID(#MenuBarIcon_PiccyDb_ImportPictures))
    MenuTitle("Option menu")
    MenuItem(#MenuBar_PiccyDb_ScreenSnap,           FormatMenu(#Text_ScreenSnap,        GetShortcutText(#Keys_ScreenSnap),      36))
    MenuItem(#MenuBar_PiccyDb_StickyWindow,         FormatMenu(#Text_StickyWindow,      GetShortcutText(#Keys_StickyWindow),    36))
    MenuItem(#MenuBar_PiccyDb_TitleClock,           FormatMenu(#Text_TitleClock,        GetShortcutText(#Keys_TitleClock),      36))
    MenuTitle("Help menu")
    MenuItem(#MenuBar_PiccyDb_AboutProgram,         FormatMenu(#Text_AboutProgram,      GetShortcutText(#Keys_AboutProgram),    36),  ImageID(#MenuBarIcon_PiccyDb_AboutProgram))
    MenuItem(#MenuBar_PiccyDb_ProgramHelp,          FormatMenu(#Text_ProgramHelp,       GetShortcutText(#Keys_Help),            36),  ImageID(#MenuBarIcon_PiccyDb_ProgramHelp))
  Else
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; Create the Category list popup bar
  ;------------------------------------------------------------------------------------------------
    
  If CreatePopupImageMenu(#PopMenuBar_Category, #PB_Menu_ModernLook) <> #NoMenuCreated
    MenuItem(#PopMenuBar_Category_AddCategory,      FormatMenu(#Text_AddCategory,       GetShortcutText(#Keys_AddCategory),     36),  ImageID(#MenuBarIcon_PiccyDb_AddCategory))
    MenuItem(#PopMenuBar_Category_CopyCategory,     FormatMenu(#Text_CopyCategory,      GetShortcutText(#Keys_CopyCategory),    36),  ImageID(#MenuBarIcon_PiccyDb_CopyCategory))
    MenuItem(#PopMenuBar_Category_DeleteCategory,   FormatMenu(#Text_DeleteCategory,    GetShortcutText(#Keys_DeleteCategory),  36),  ImageID(#MenuBarIcon_PiccyDb_DeleteCategory))
    MenuItem(#PopMenuBar_Category_EditCategory,     FormatMenu(#Text_EditCategory,      GetShortcutText(#Keys_EditCategory),    36),  ImageID(#MenuBarIcon_PiccyDb_EditCategory))
    MenuBar()
    MenuItem(#PopMenuBar_Category_ExportCategory,   FormatMenu(#Text_ExportCategory,    GetShortcutText(#Keys_ExportCategory),  36),  ImageID(#MenuBarIcon_PiccyDb_ExportCategory))
    MenuItem(#PopMenuBar_Category_ImportCategory,   FormatMenu(#Text_ImportCategory,    GetShortcutText(#Keys_ImportCategory),  36),  ImageID(#MenuBarIcon_PiccyDb_ImportCategory))
  Else
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; Create the main window titlebar popup menu
  ;------------------------------------------------------------------------------------------------
  
  If CreatePopupImageMenu(#PopMenuBar_PiccyDb, #PB_Menu_ModernLook) <> #NoMenuCreated
    MenuItem(#PopMenuBar_PiccyDb_BackupDatabase,    FormatMenu(#Text_BackupDatabase,    GetShortcutText(#Keys_BackupDatabase),  36),  ImageID(#MenuBarIcon_PiccyDb_BackupDatabase))
    MenuItem(#PopMenuBar_PiccyDb_VacuumDatabase,    FormatMenu(#Text_VacuumDatabase,    GetShortcutText(#Keys_VacuumDatabase),  36),  ImageID(#MenuBarIcon_PiccyDb_VacuumDatabase))
    MenuBar()
    MenuItem(#PopMenuBar_PiccyDb_ExitProgram,       FormatMenu(#Text_ExitProgram,       GetShortcutText(#Keys_Exit),            36),  ImageID(#MenuBarIcon_PiccyDb_ExitProgram))
    MenuBar()
    MenuItem(#PopMenuBar_PiccyDb_AddCategory,       FormatMenu(#Text_AddCategory,       GetShortcutText(#Keys_AddCategory),     36),  ImageID(#MenuBarIcon_PiccyDb_AddCategory))
    MenuItem(#PopMenuBar_PiccyDb_CopyCategory,      FormatMenu(#Text_CopyCategory,      GetShortcutText(#Keys_CopyCategory),    36),  ImageID(#MenuBarIcon_PiccyDb_CopyCategory))
    MenuItem(#PopMenuBar_PiccyDb_DeleteCategory,    FormatMenu(#Text_DeleteCategory,    GetShortcutText(#Keys_DeleteCategory),  36),  ImageID(#MenuBarIcon_PiccyDb_DeleteCategory))
    MenuItem(#PopMenuBar_PiccyDb_EditCategory,      FormatMenu(#Text_EditCategory,      GetShortcutText(#Keys_EditCategory),    36),  ImageID(#MenuBarIcon_PiccyDb_EditCategory))
    MenuBar()
    MenuItem(#PopMenuBar_PiccyDb_ExportCategory,    FormatMenu(#Text_ExportCategory,    GetShortcutText(#Keys_ExportCategory),  36),  ImageID(#MenuBarIcon_PiccyDb_ExportCategory))
    MenuItem(#PopMenuBar_PiccyDb_ImportCategory,    FormatMenu(#Text_ImportCategory,    GetShortcutText(#Keys_ImportCategory),  36),  ImageID(#MenuBarIcon_PiccyDb_ImportCategory))
    MenuBar()
    MenuItem(#PopMenuBar_PiccyDb_AddPicture,        FormatMenu(#Text_AddPicture,        GetShortcutText(#Keys_Add),             36),  ImageID(#MenuBarIcon_PiccyDb_AddPicture))
    MenuItem(#PopMenuBar_PiccyDb_AddFolder,         FormatMenu(#Text_AddFolder,         GetShortcutText(#Keys_AddFolder),       36),  ImageID(#MenuBarIcon_PiccyDb_AddFolder))
    MenuItem(#PopMenuBar_PiccyDb_CopyPicture,       FormatMenu(#Text_CopyPicture,       GetShortcutText(#Keys_Copy),            36),  ImageID(#MenuBarIcon_PiccyDb_CopyPicture))
    MenuItem(#PopMenuBar_PiccyDb_DeletePicture,     FormatMenu(#Text_DeletePicture,     GetShortcutText(#Keys_Delete),          36),  ImageID(#MenuBarIcon_PiccyDb_DeletePicture))
    MenuItem(#PopMenuBar_PiccyDb_EditPicture,       FormatMenu(#Text_EditPicture,       GetShortcutText(#Keys_Edit),            36),  ImageID(#MenuBarIcon_PiccyDb_EditPicture))
    MenuBar()
    MenuItem(#PopMenuBar_PiccyDb_FavouritePicture,  FormatMenu(#Text_FavouritePicture,  GetShortcutText(#Keys_Favourite),       36),  ImageID(#MenuBarIcon_PiccyDb_FavouritePicture))
    MenuItem(#PopMenuBar_PiccyDb_KillPicture,       FormatMenu(#Text_KillPicture,       GetShortcutText(#Keys_Kill),            36),  ImageID(#MenuBarIcon_PiccyDb_KillPicture))
    MenuItem(#PopMenuBar_PiccyDb_LockPicture,       FormatMenu(#Text_LockPicture,       GetShortcutText(#Keys_Lock),            36),  ImageID(#MenuBarIcon_PiccyDb_LockPicture))
    MenuBar()
    MenuItem(#PopMenuBar_PiccyDb_SavePicture,       FormatMenu(#Text_SavePicture,       GetShortcutText(#Keys_Save),            36),  ImageID(#MenuBarIcon_PiccyDb_SavePicture))
    MenuItem(#PopMenuBar_PiccyDb_SaveSelected,      FormatMenu(#Text_SaveSelected,      GetShortcutText(#Keys_SaveSelected),    36),  ImageID(#MenuBarIcon_PiccyDb_SaveSelected))
    MenuItem(#PopMenuBar_PiccyDb_SaveCategory,      FormatMenu(#Text_SaveCategory,      GetShortcutText(#Keys_SaveCategory),    36),  ImageID(#MenuBarIcon_PiccyDb_SaveCategory))
    MenuItem(#PopMenuBar_PiccyDb_SaveAllPictures,   FormatMenu(#Text_SaveAllPictures,   GetShortcutText(#Keys_SaveAll),         36),  ImageID(#MenuBarIcon_PiccyDb_SaveAllPictures))
    MenuItem(#PopMenuBar_PiccyDb_ViewPicture,       FormatMenu(#Text_ViewPicture,       GetShortcutText(#Keys_View),            36),  ImageID(#MenuBarIcon_PiccyDb_ViewPicture))
    MenuBar()
    MenuItem(#PopMenuBar_PiccyDb_ExportPictures,    FormatMenu(#Text_ExportPictures,    GetShortcutText(#Keys_Export),          36),  ImageID(#MenuBarIcon_PiccyDb_ExportPictures))
    MenuItem(#PopMenuBar_PiccyDb_ImportPictures,    FormatMenu(#Text_ImportPictures,    GetShortcutText(#Keys_Import),          36),  ImageID(#MenuBarIcon_PiccyDb_ImportPictures))
    MenuBar()
    MenuItem(#PopMenuBar_PiccyDb_ScreenSnap,        FormatMenu(#Text_ScreenSnap,        GetShortcutText(#Keys_ScreenSnap),      36))
    MenuItem(#PopMenuBar_PiccyDb_StickyWindow,      FormatMenu(#Text_StickyWindow,      GetShortcutText(#Keys_StickyWindow),    36))
    MenuItem(#PopMenuBar_PiccyDb_TitleClock,        FormatMenu(#Text_TitleClock,        GetShortcutText(#Keys_TitleClock),      36))
    MenuBar()
    MenuItem(#PopMenuBar_PiccyDb_AboutProgram,      FormatMenu(#Text_AboutProgram,      GetShortcutText(#Keys_AboutProgram),    36),  ImageID(#MenuBarIcon_PiccyDb_AboutProgram))
    MenuItem(#PopMenuBar_PiccyDb_ProgramHelp,       FormatMenu(#Text_ProgramHelp,       GetShortcutText(#Keys_Help),            36),  ImageID(#MenuBarIcon_PiccyDb_ProgramHelp))
  Else
  EndIf
  
  If CreatePopupImageMenu(#PopMenuBar_Picture, #PB_Menu_ModernLook) <> #NoMenuCreated
    MenuItem(#PopMenuBar_Picture_AddPicture,        FormatMenu(#Text_AddPicture,        GetShortcutText(#Keys_Add),             36),  ImageID(#MenuBarIcon_PiccyDb_AddPicture))
    MenuItem(#PopMenuBar_Picture_AddFolder,         FormatMenu(#Text_AddFolder,         GetShortcutText(#Keys_AddFolder),       36),  ImageID(#MenuBarIcon_PiccyDb_AddFolder))
    MenuItem(#PopMenuBar_Picture_CopyPicture,       FormatMenu(#Text_CopyPicture,       GetShortcutText(#Keys_Copy),            36),  ImageID(#MenuBarIcon_PiccyDb_CopyPicture))
    MenuItem(#PopMenuBar_Picture_DeletePicture,     FormatMenu(#Text_DeletePicture,     GetShortcutText(#Keys_Delete),          36),  ImageID(#MenuBarIcon_PiccyDb_DeletePicture))
    MenuItem(#PopMenuBar_Picture_EditPicture,       FormatMenu(#Text_EditPicture,       GetShortcutText(#Keys_Edit),            36),  ImageID(#MenuBarIcon_PiccyDb_EditPicture))
    MenuBar()
    MenuItem(#PopMenuBar_Picture_FavouritePicture,  FormatMenu(#Text_FavouritePicture,  GetShortcutText(#Keys_Favourite),       36),  ImageID(#MenuBarIcon_PiccyDb_FavouritePicture))
    MenuItem(#PopMenuBar_Picture_KillPicture,       FormatMenu(#Text_KillPicture,       GetShortcutText(#Keys_Kill),            36),  ImageID(#MenuBarIcon_PiccyDb_KillPicture))
    MenuItem(#PopMenuBar_Picture_LockPicture,       FormatMenu(#Text_LockPicture,       GetShortcutText(#Keys_Lock),            36),  ImageID(#MenuBarIcon_PiccyDb_LockPicture))
    MenuBar()
    MenuItem(#PopMenuBar_Picture_SavePicture,       FormatMenu(#Text_SavePicture,       GetShortcutText(#Keys_Save),            36),  ImageID(#MenuBarIcon_PiccyDb_SavePicture))
    MenuItem(#PopMenuBar_Picture_SaveSelected,      FormatMenu(#Text_SaveSelected,      GetShortcutText(#Keys_SaveSelected),    36),  ImageID(#MenuBarIcon_PiccyDb_SaveSelected))
    MenuItem(#PopMenuBar_Picture_SaveCategory,      FormatMenu(#Text_SaveCategory,      GetShortcutText(#Keys_SaveCategory),    36),  ImageID(#MenuBarIcon_PiccyDb_SaveCategory))
    MenuItem(#PopMenuBar_Picture_SaveAllPictures,   FormatMenu(#Text_SaveAllPictures,   GetShortcutText(#Keys_SaveAll),         36),  ImageID(#MenuBarIcon_PiccyDb_SaveAllPictures))
    MenuItem(#PopMenuBar_Picture_ViewPicture,       FormatMenu(#Text_ViewPicture,       GetShortcutText(#Keys_View),            36),  ImageID(#MenuBarIcon_PiccyDb_ViewPicture))
  Else
  EndIf

  ;------------------------------------------------------------------------------------------------
  ; Create the permanent timer
  ;------------------------------------------------------------------------------------------------
    
  SetTimer_(WindowID(#Window_PiccyDb), #TitleBarClockEvent, 1000, @TitleBarClock())    ; 1000 = 1 second

  ;------------------------------------------------------------------------------------------------
  ; Turn on mouse event hover testing, this is NetMaestro's code.
  ;------------------------------------------------------------------------------------------------
  
  InitHoverEvents(#Window_PiccyDb)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  AddHoverGadget(GadgetID(#Gadget_PiccyDb_AddCategory))
  AddHoverGadget(GadgetID(#Gadget_PiccyDb_CopyCategory))
  AddHoverGadget(GadgetID(#Gadget_PiccyDb_DeleteCategory))
  AddHoverGadget(GadgetID(#Gadget_PiccyDb_EditCategory))
  AddHoverGadget(GadgetID(#Gadget_PiccyDb_ExportCategory))
  AddHoverGadget(GadgetID(#Gadget_PiccyDb_ImportCategory))
  
  AddHoverGadget(GadgetID(#Gadget_PiccyDb_Add))
  AddHoverGadget(GadgetID(#Gadget_PiccyDb_Copy))
  AddHoverGadget(GadgetID(#Gadget_PiccyDb_Delete))
  AddHoverGadget(GadgetID(#Gadget_PiccyDb_Edit))
  AddHoverGadget(GadgetID(#Gadget_PiccyDb_Export))
  AddHoverGadget(GadgetID(#Gadget_PiccyDb_Import))
  AddHoverGadget(GadgetID(#Gadget_PiccyDb_Favourite))
  AddHoverGadget(GadgetID(#Gadget_PiccyDb_Kill))
  AddHoverGadget(GadgetID(#Gadget_PiccyDb_Lock))

  AddHoverGadget(GadgetID(#Gadget_PiccyDb_Save))
  AddHoverGadget(GadgetID(#Gadget_PiccyDb_Help))
  AddHoverGadget(GadgetID(#Gadget_PiccyDb_Exit))
  
  ;------------------------------------------------------------------------------------------------
  ; Remove borders from ListIconGadgets
  ;------------------------------------------------------------------------------------------------
  
  RemoveBorders(#Gadget_PiccyDb_Category)
  RemoveBorders(#Gadget_PiccyDb_Titles)
  RemoveBorders(#Gadget_PiccyDb_Comment)
  
  ;------------------------------------------------------------------------------------------------
  ; Load a strikeout font to be used on the item list
  ;------------------------------------------------------------------------------------------------
  
  CurrentFont.i = GetGadgetFont(#Gadget_PiccyDb_Titles)                        ;... Get current font
  GetObject_(CurrentFont.i, SizeOf(LOGFONT), @logf.LOGFONT)
  FontName.s     = PeekS(@logf\lfFacename[0])
  hDEviceContext = CreateDC_(@"DISPLAY", 0, 0, 0)
  LogPixSY       = GetDeviceCaps_(hDEviceContext, #LOGPIXELSY)
  DeleteDC_(hDEviceContext)
  Fontsize.F = - (logf\lfHeight * 72) / LogPixSY
  LoadFont(#FontStrikeoutYes, FontName.s, Fontsize.F, #PB_Font_StrikeOut )  ; Load current font and add strikeout attribute
  LoadFont(#FontStrikeoutNo,  FontName.s, Fontsize.F)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  AddKeyboardShortcut(#Window_PiccyDb, #Keys_SearchPictures,  #Shortcut_SearchPictures)
  
  AddKeyboardShortcut(#Window_PiccyDb, #Keys_BackupDatabase,  #ShortCut_BackupDatabase)
  AddKeyboardShortcut(#Window_PiccyDb, #Keys_VacuumDatabase,  #ShortCut_VacuumDatabase)

  AddKeyboardShortcut(#Window_PiccyDb, #Keys_AddCategory,     #ShortCut_AddCategory)
  AddKeyboardShortcut(#Window_PiccyDb, #Keys_CopyCategory,    #ShortCut_CopyCategory)
  AddKeyboardShortcut(#Window_PiccyDb, #Keys_DeleteCategory,  #ShortCut_DeleteCategory)
  AddKeyboardShortcut(#Window_PiccyDb, #Keys_EditCategory,    #ShortCut_EditCategory)
  AddKeyboardShortcut(#Window_PiccyDb, #Keys_ExportCategory,  #ShortCut_ExportCategory)
  AddKeyboardShortcut(#Window_PiccyDb, #Keys_ImportCategory,  #ShortCut_ImportCategory)
  
  AddKeyboardShortcut(#Window_PiccyDb, #Keys_Add,             #ShortCut_Add)
  AddKeyboardShortcut(#Window_PiccyDb, #Keys_AddFolder,       #ShortCut_AddFolder)
  AddKeyboardShortcut(#Window_PiccyDb, #Keys_Copy,            #ShortCut_Copy)
  AddKeyboardShortcut(#Window_PiccyDb, #Keys_Delete,          #ShortCut_Delete)
  AddKeyboardShortcut(#Window_PiccyDb, #Keys_Edit,            #ShortCut_Edit)
  AddKeyboardShortcut(#Window_PiccyDb, #Keys_Favourite,       #ShortCut_Favourite)
  AddKeyboardShortcut(#Window_PiccyDb, #Keys_Help,            #ShortCut_Help)
  AddKeyboardShortcut(#Window_PiccyDb, #Keys_Import,          #ShortCut_Import)
  AddKeyboardShortcut(#Window_PiccyDb, #Keys_Kill,            #ShortCut_Kill)
  AddKeyboardShortcut(#Window_PiccyDb, #Keys_Lock,            #ShortCut_Lock)
  AddKeyboardShortcut(#Window_PiccyDb, #Keys_Save,            #ShortCut_Save)
  AddKeyboardShortcut(#Window_PiccyDb, #Keys_SaveAll,         #ShortCut_SaveAll)
  AddKeyboardShortcut(#Window_PiccyDb, #Keys_View,            #ShortCut_View)
  AddKeyboardShortcut(#Window_PiccyDb, #Keys_Export,          #ShortCut_Export)
  AddKeyboardShortcut(#Window_PiccyDb, #Keys_Exit,            #ShortCut_Exit)
  
  AddKeyboardShortcut(#Window_PiccyDb, #Keys_ScreenSnap,      #ShortCut_ScreenSnap)
  AddKeyboardShortcut(#Window_PiccyDb, #Keys_StickyWindow,    #ShortCut_StickyWindow)
  AddKeyboardShortcut(#Window_PiccyDb, #Keys_TitleClock,      #ShortCut_TitleClock)

  AddKeyboardShortcut(#Window_PiccyDb, #Keys_AboutProgram,    #ShortCut_About)
  
  ;------------------------------------------------------------------------------------------------
  ; Read and set all program options from the main database's setup table.
  ;------------------------------------------------------------------------------------------------
  
  ReadProgramOptions()

  ;------------------------------------------------------------------------------------------------
  ; Dummy placeholders for setup variables that will be in the database soon
  ;------------------------------------------------------------------------------------------------
  ; Setup\TitleClock    = 0
  ; Setup\StickyWindow  = 0
  ; Setup\ScreenSnap    = 0
  
  ;------------------------------------------------------------------------------------------------
  ; Check if the program timer needs to turn on ; Windows, event number, resolution, procedure'
  ; This value is determined at startup from a setup table value which can then be altered and
  ; saved by the user and reloaded at program start.
  ;------------------------------------------------------------------------------------------------
  
  If Setup\TitleClock = 1
    Setup\TitleClock = 0
  ElseIf Setup\TitleClock = 0
    Setup\TitleClock = 1
  EndIf
  
  ToggleTitleClock()
  
  ;------------------------------------------------------------------------------------------------
  ; Set this window on top of others or alarm window will not show. This value is determined at
  ; startup from a setup table value which can then be altered and saved by the user and reloaded
  ; at program start.
  ;------------------------------------------------------------------------------------------------
  
  If Setup\StickyWindow = 1
    Setup\StickyWindow = 0
  Else
    Setup\StickyWindow = 1
  EndIf
  
  ToggleStickyWindow()
  
  ;------------------------------------------------------------------------------------------------
  ; Turn the balloon tooltips off or on determined by a program setting. This is a toggle function
  ; so if you pass '1' to it, it toggles to '0'
  ;------------------------------------------------------------------------------------------------
  
  If Setup\ScreenSnap = 1
    Setup\ScreenSnap = 0
  ElseIf Setup\ScreenSnap = 0
    Setup\ScreenSnap = 1
  EndIf
  
  ToggleScreenSnap()
  
  ;------------------------------------------------------------------------------------------------
  ; Limit the number of search box characters and set the cue banner text. These variables are set
  ; in the AppointmentMuncher_Myconstants file.
  ;------------------------------------------------------------------------------------------------
  
  SendMessage_(GadgetID(#Gadget_PiccyDb_search), #EM_SETLIMITTEXT, 67, 0)
  SendMessage_(GadgetID(#Gadget_PiccyDb_search), #EM_SETCUEBANNER,  1,  Program\SearchCueText)
  
  ;------------------------------------------------------------------------------------------------
  ; Colours, resizing and more callback
  ;------------------------------------------------------------------------------------------------
  
  SetWindowCallback(@WindowCallback())
  
  ;------------------------------------------------------------------------------------------------
  ; Now display all the categories available
  ;------------------------------------------------------------------------------------------------
  
  LoadCategories()

  ;------------------------------------------------------------------------------------------------
  ; Add the search type operators
  ;------------------------------------------------------------------------------------------------
  
  Restore _SearchTypes_
    While TempString.s <> "_END_"
      Read.s TempString.s
      If TempString.s <> "_END_"
        AddGadgetItem(#Gadget_PiccyDb_searchtype, #AtTheEndOfTheList, TempString.s, ImageID(#Image_Combo_Sql))
      EndIf
    Wend

  TempString.s = "<><>"
  
  SetGadgetState(#Gadget_PiccyDb_searchtype, 0)

  ;------------------------------------------------------------------------------------------------
  ; Set the program quit semaphore
  ;------------------------------------------------------------------------------------------------
  
  Program\QuitValue = 0
  
  ;------------------------------------------------------------------------------------------------
  ; Enable category changing by drag and drop
  ;------------------------------------------------------------------------------------------------
  
  EnableGadgetDrop(#Gadget_PiccyDb_Category, #PB_Drop_Text, #PB_Drag_Copy)
  
  ;------------------------------------------------------------------------------------------------
  ; Set focus to main window
  ;------------------------------------------------------------------------------------------------
  
  SetActiveWindow(#Window_PiccyDb)
  
  ;------------------------------------------------------------------------------------------------
  ; Now that form is filled, show the window. Looks better
  ;------------------------------------------------------------------------------------------------
  
  HideWindow(#Window_PiccyDb, #False)
  
  ;------------------------------------------------------------------------------------------------
  ; Set the fake statusbar heading appropriate for the run time of the program
  ;------------------------------------------------------------------------------------------------
  
  NumberOfItems.i = CountGadgetItems(#Gadget_PiccyDb_Titles)
  
  If NumberOfItems.i = 0
    SetInfoBarArea("Headings",  "Welcome",  "Welcome to " + #Program + ", first time startup, there are no items in the database yet. Have a nice day")
    SetInfoBarArea("Number",    #EmptyString,         "?")
    SetInfoBarArea("Records",   #EmptyString,         "0")
  ElseIf NumberOfItems.i <> 0
    SetGadgetState(#Gadget_PiccyDb_Titles, 0)
    ; PostEvent(#PB_Event_Gadget, #Window_PiccyDb, #Gadget_PiccyDb_Titles, #PB_EventType_Change)
    SetInfoBarArea("Headings",  "Welcome",  "Welcome to " + #Basename)
    SetInfoBarArea("Records",   #EmptyString,         Str(NumberOfItems.i))
  EndIf
  
  ;------------------------------------------------------------------------------------------------
  ; Set focus on the search bar
  ;------------------------------------------------------------------------------------------------
  
  SetActiveGadget(#Gadget_PiccyDb_search)
  
  ;------------------------------------------------------------------------------------------------
  ; 
  ;------------------------------------------------------------------------------------------------
  
  Repeat
    
    EventID  =  WaitWindowEvent()
    MenuID   =  EventMenu()
    GadgetID =  EventGadget()
    WindowID =  EventWindow()

    Select EventID
        
      ;----------------------------------------------
      ; 
      ;----------------------------------------------
        
      Case #PB_Event_CloseWindow
        Select WindowID
          Case #Window_PiccyDb                      : Program\QuitValue = 1
          Case #Window_PiccyCategory                : CloseMyWindow(#Window_PiccyCategory)
          Case #Window_PiccyData                    : CloseMyWindow(#Window_PiccyData)
          Case #Window_PiccyViewer                  : CloseMyWindow(#Window_PiccyViewer)
        EndSelect
        
        ;--------------------------------------------
        ; Minimise the program to the windows tray and set icon and tooltip
        ;--------------------------------------------
        
      Case #PB_Event_MinimizeWindow
        Select EventWindow()
          Case #Window_PiccyDb                      : HideProgramWindow()
        EndSelect
        
        ;--------------------------------------------
        ; 
        ;--------------------------------------------
        
      Case #PB_Event_GadgetDrop
        Select EventDropType()
          Case #PB_Drop_Text
            Select GadgetID
              Case #Gadget_PiccyDb_Category         : ChangeCategory()
            EndSelect
        EndSelect
        
        ;--------------------------------------------
        ; 
        ;--------------------------------------------
        
      Case #PB_Event_Menu
        Select MenuID
            
          ;------------------------------------------
          ; Main program menu bar
          ;------------------------------------------
            
          Case #MenuBar_PiccyDb_BackupDatabase      : BackupDatabase()
          Case #MenuBar_PiccyDb_VacuumDatabase      : VacuumDatabase()
            
          Case #MenuBar_PiccyDb_ExitProgram         : Program\QuitValue = 1
            
          Case #MenuBar_PiccyDb_AddCategory         : AddCategory()
          Case #MenuBar_PiccyDb_CopyCategory        : CopyCategory()
          Case #MenuBar_PiccyDb_DeleteCategory      : DeleteCategory()
          Case #MenuBar_PiccyDb_EditCategory        : EditCategory()
          Case #MenuBar_PiccyDb_ExportCategory      : ExportCategories()
          Case #MenuBar_PiccyDb_ImportCategory      : ImportCategories()
            
          Case #MenuBar_PiccyDb_AddPicture          : AddNewPicture()
          Case #MenuBar_PiccyDb_AddFolder           : AddPictureFolder()
          Case #MenuBar_PiccyDb_CopyPicture         : CopyCurrentPicture()
          Case #MenuBar_PiccyDb_DeletePicture       : DeleteCurrentPicture()
          Case #MenuBar_PiccyDb_EditPicture         : EditCurrentPicture()
          Case #MenuBar_PiccyDb_ExportPictures      : ExportPictures()
          Case #MenuBar_PiccyDb_ImportPictures      : ImportPictures()
          Case #MenuBar_PiccyDb_FavouritePicture    : FavouriteCurrentPicture()
          Case #MenuBar_PiccyDb_KillPicture         : KillCurrentPicture()
          Case #MenuBar_PiccyDb_LockPicture         : LockCurrentPicture()
          Case #MenuBar_PiccyDb_SavePicture         : SaveCurrentPictureToDisk()
          Case #MenuBar_PiccyDb_SaveSelected        : SaveSelectedPicturesToDisk()
          Case #MenuBar_PiccyDb_SaveCategory        : SaveCategoryPicturesToDisk()
          Case #MenuBar_PiccyDb_SaveAllPictures     : SaveAllPicturesToDisk()
          Case #MenuBar_PiccyDb_ViewPicture         : ViewCurrentPicture()
          Case #MenuBar_PiccyDb_ProgramHelp         : ShowProgramHelp()
          Case #MenuBar_PiccyDb_AboutProgram        : AboutProgram()
          Case #MenuBar_PiccyDb_ScreenSnap          : ToggleScreenSnap()
          Case #MenuBar_PiccyDb_StickyWindow        : ToggleStickyWindow()
          Case #MenuBar_PiccyDb_TitleClock          : ToggleTitleClock()
            
          ;------------------------------------------
          ; Category popup menu bar
          ;------------------------------------------
            
          Case #PopMenuBar_Category_AddCategory     : AddCategory()
          Case #PopMenuBar_Category_CopyCategory    : CopyCategory()
          Case #PopMenuBar_Category_DeleteCategory  : DeleteCategory()
          Case #PopMenuBar_Category_EditCategory    : EditCategory()
          Case #PopMenuBar_Category_ExportCategory  : ExportCategories()
          Case #PopMenuBar_Category_ImportCategory  : ImportCategories()

          ;------------------------------------------
          ; Main program popup menu bar
          ;------------------------------------------

          Case #PopMenuBar_PiccyDb_BackupDatabase   : BackupDatabase()
          Case #PopMenuBar_PiccyDb_VacuumDatabase   : VacuumDatabase()

          Case #PopMenuBar_PiccyDb_ExitProgram      : Program\QuitValue = 1

          Case #PopMenuBar_PiccyDb_AddPicture       : AddNewPicture()
          Case #PopMenuBar_PiccyDb_AddFolder        : AddPictureFolder()
          Case #PopMenuBar_PiccyDb_CopyPicture      : CopyCurrentPicture()
          Case #PopMenuBar_PiccyDb_DeletePicture    : DeleteCurrentPicture()
          Case #PopMenuBar_PiccyDb_EditPicture      : EditCurrentPicture()
          Case #PopMenuBar_PiccyDb_ExportPictures   : ExportPictures()
          Case #PopMenuBar_PiccyDb_ImportPictures   : ImportPictures()
          Case #PopMenuBar_PiccyDb_FavouritePicture : FavouriteCurrentPicture()
          Case #PopMenuBar_PiccyDb_KillPicture      : KillCurrentPicture()
          Case #PopMenuBar_PiccyDb_LockPicture      : LockCurrentPicture()
          Case #PopMenuBar_PiccyDb_SavePicture      : SaveCurrentPictureToDisk()
          Case #PopMenuBar_PiccyDb_SaveSelected     : SaveSelectedPicturesToDisk()
          Case #PopMenuBar_PiccyDb_SaveCategory     : SaveCategoryPicturesToDisk()
          Case #PopMenuBar_PiccyDb_SaveAllPictures  : SaveAllPicturesToDisk()
          Case #PopMenuBar_PiccyDb_ViewPicture      : ViewCurrentPicture()
          Case #PopMenuBar_PiccyDb_ProgramHelp      : ShowProgramHelp()
          Case #PopMenuBar_PiccyDb_AboutProgram     : AboutProgram()            
          Case #PopMenuBar_PiccyDb_ScreenSnap       : ToggleScreenSnap()
          Case #PopMenuBar_PiccyDb_StickyWindow     : ToggleStickyWindow()
          Case #PopMenuBar_PiccyDb_TitleClock       : ToggleTitleClock()
            
          ;------------------------------------------
          ; Main picture popup menu bar
          ;------------------------------------------
            
          Case #PopMenuBar_Picture_AddPicture       : AddNewPicture()
          Case #PopMenuBar_Picture_AddFolder        : AddPictureFolder()
          Case #PopMenuBar_Picture_CopyPicture      : CopyCurrentPicture()
          Case #PopMenuBar_Picture_DeletePicture    : DeleteCurrentPicture()
          Case #PopMenuBar_Picture_EditPicture      : EditCurrentPicture()
          Case #PopMenuBar_Picture_FavouritePicture : FavouriteCurrentPicture()
          Case #PopMenuBar_Picture_KillPicture      : KillCurrentPicture()
          Case #PopMenuBar_Picture_LockPicture      : LockCurrentPicture()
          Case #PopMenuBar_Picture_SavePicture      : SaveCurrentPictureToDisk()
          Case #PopMenuBar_Picture_SaveSelected     : SaveSelectedPicturesToDisk()
          Case #PopMenuBar_Picture_SaveCategory     : SaveCategoryPicturesToDisk()
          Case #PopMenuBar_Picture_SaveAllPictures  : SaveAllPicturesToDisk()
          Case #PopMenuBar_Picture_ViewPicture      : ViewCurrentPicture()
            
          ;------------------------------------------
          ; 
          ;------------------------------------------
            
          Case #Shortcut_SearchPictures             : CheckEnterGadget()
            
          Case #ShortCut_BackupDatabase             : BackupDatabase()
          Case #ShortCut_VacuumDatabase             : VacuumDatabase()
            
          Case #ShortCut_AddCategory                : AddCategory()
          Case #ShortCut_CopyCategory               : CopyCategory()
          Case #ShortCut_DeleteCategory             : DeleteCategory()
          Case #ShortCut_EditCategory               : EditCategory()
          Case #Shortcut_ExportCategory             : ExportCategories()
          Case #Shortcut_ImportCategory             : ImportCategories()
            
          Case #ShortCut_Add                        : AddNewPicture()
          Case #ShortCut_AddFolder                  : AddPictureFolder()
          Case #ShortCut_Copy                       : CopyCurrentPicture()
          Case #ShortCut_Delete                     : DeleteCurrentPicture()
          Case #ShortCut_Edit                       : EditCurrentPicture()
          Case #ShortCut_Export                     : ExportPictures()
          Case #ShortCut_Import                     : ImportPictures()
          Case #ShortCut_Favourite                  : FavouriteCurrentPicture()
          Case #ShortCut_Kill                       : KillCurrentPicture()
          Case #ShortCut_Lock                       : LockCurrentPicture()
          Case #ShortCut_Save                       : SaveCurrentPictureToDisk()
          Case #ShortCut_Selected                   : SaveSelectedPicturesToDisk()
          Case #ShortCut_Category                   : SaveCategoryPicturesToDisk()
          Case #Shortcut_SaveAll                    : SaveAllPicturesToDisk()
          Case #Shortcut_View                       : ViewCurrentPicture()
          Case #ShortCut_Help                       : ShowProgramHelp()
          Case #Shortcut_Exit                       : Program\QuitValue = 1
          Case #ShortCut_About                      : AboutProgram() 
            
          Case #ShortCut_ScreenSnap                 : ToggleScreenSnap()
          Case #ShortCut_StickyWindow               : ToggleStickyWindow()
          Case #ShortCut_TitleClock                 : ToggleTitleClock()

          Case #Shortcut_CloseCategory              : CloseMyWindow(#Window_PiccyCategory)
          Case #Shortcut_SaveCategory               : SaveCategory()
          Case #Shortcut_ExitCategory               : CloseMyWindow(#Window_PiccyCategory)
          
          Case #Shortcut_CloseData                  : CloseMyWindow(#Window_PiccyData)
          Case #Shortcut_SaveData                   : SavePictureData()
          Case #Shortcut_ExitData                   : CloseMyWindow(#Window_PiccyData)
            
          Case #Shortcut_CloseViewer                : CloseMyWindow(#Window_PiccyViewer)
          Case #Shortcut_ExitViewer                 : CloseMyWindow(#Window_PiccyViewer)
        EndSelect
        
        ;--------------------------------------------
        ; 
        ;--------------------------------------------
        
      Case #PB_Event_Gadget
        Select GadgetID
            
          ;------------------------------------------
          ; 
          ;------------------------------------------
            
          Case #Gadget_PiccyDb_Category
            Select EventType()
              Case #PB_EventType_LeftDoubleClick    : EditCategory()
              Case #PB_EventType_RightClick         : DisplayPopupMenu(#PopMenuBar_Category, WindowID(#Window_PiccyDb))  
              Case #PB_EventType_RightDoubleClick   : AddCategory()
              Case #PB_EventType_Change             : ShowCategory()
            EndSelect
            
            ;----------------------------------------
            ; 
            ;----------------------------------------
            
          Case #Gadget_PiccyDb_AddCategory
            Select EventType()
              Case #HoverEvent_EnterGadget          : SetHoverIcons(GadgetID, #Image_PiccyDb_AddCategory, "Hovered")           : StatusBarTip(#Window_PiccyDb, "AddCategory")
              Case #PB_EventType_LeftClick          : SetHoverIcons(GadgetID, #Image_PiccyDb_AddCategory, "Pressed")           : AddCategory()
              Case #HoverEvent_LeaveGadget          : SetHoverIcons(GadgetID, #Image_PiccyDb_AddCategory, "Normal")
            EndSelect
            
            ;----------------------------------------
            ; 
            ;----------------------------------------
            
          Case #Gadget_PiccyDb_CopyCategory
            Select EventType()
              Case #HoverEvent_EnterGadget          : SetHoverIcons(GadgetID, #Image_PiccyDb_CopyCategory, "Hovered")          : StatusBarTip(#Window_PiccyDb, "CopyCategory")
              Case #PB_EventType_LeftClick          : SetHoverIcons(GadgetID, #Image_PiccyDb_CopyCategory, "Pressed")          : CopyCategory()
              Case #HoverEvent_LeaveGadget          : SetHoverIcons(GadgetID, #Image_PiccyDb_CopyCategory, "Normal")
            EndSelect
            
            ;----------------------------------------
            ; 
            ;----------------------------------------
            
          Case #Gadget_PiccyDb_DeleteCategory
            Select EventType()
              Case #HoverEvent_EnterGadget          : SetHoverIcons(GadgetID, #Image_PiccyDb_DeleteCategory, "Hovered")        : StatusBarTip(#Window_PiccyDb, "DeleteCategory")
              Case #PB_EventType_LeftClick          : SetHoverIcons(GadgetID, #Image_PiccyDb_DeleteCategory, "Pressed")        : DeleteCategory()
              Case #HoverEvent_LeaveGadget          : SetHoverIcons(GadgetID, #Image_PiccyDb_DeleteCategory, "Normal")
            EndSelect
            
            ;----------------------------------------
            ; 
            ;----------------------------------------
            
          Case #Gadget_PiccyDb_EditCategory
            Select EventType()
              Case #HoverEvent_EnterGadget          : SetHoverIcons(GadgetID, #Image_PiccyDb_EditCategory, "Hovered")          : StatusBarTip(#Window_PiccyDb, "EditCategory")
              Case #PB_EventType_LeftClick          : SetHoverIcons(GadgetID, #Image_PiccyDb_EditCategory, "Pressed")          : EditCategory()
              Case #HoverEvent_LeaveGadget          : SetHoverIcons(GadgetID, #Image_PiccyDb_EditCategory, "Normal")
            EndSelect
            
            ;----------------------------------------
            ; 
            ;----------------------------------------
            
          Case #Gadget_PiccyDb_ExportCategory
            Select EventType()
              Case #HoverEvent_EnterGadget          : SetHoverIcons(GadgetID, #Image_PiccyDb_ExportCategory, "Hovered")        : StatusBarTip(#Window_PiccyDb, "ExportCategory")
              Case #PB_EventType_LeftClick          : SetHoverIcons(GadgetID, #Image_PiccyDb_ExportCategory, "Pressed")        : ExportCategories()
              Case #HoverEvent_LeaveGadget          : SetHoverIcons(GadgetID, #Image_PiccyDb_ExportCategory, "Normal")
            EndSelect
            
            ;----------------------------------------
            ; 
            ;----------------------------------------
            
          Case #Gadget_PiccyDb_ImportCategory
            Select EventType()
              Case #HoverEvent_EnterGadget          : SetHoverIcons(GadgetID, #Image_PiccyDb_ImportCategory, "Hovered")        : StatusBarTip(#Window_PiccyDb, "ImportCategory")
              Case #PB_EventType_LeftClick          : SetHoverIcons(GadgetID, #Image_PiccyDb_ImportCategory, "Pressed")        : ImportCategories()
              Case #HoverEvent_LeaveGadget          : SetHoverIcons(GadgetID, #Image_PiccyDb_ImportCategory, "Normal")
            EndSelect
            
            ;----------------------------------------
            ; Convert first character of category name to uppercase
            ;----------------------------------------
            
          Case #Gadget_PiccyCategory_Category       : MixedStringCase(#Gadget_PiccyCategory_Category)
            
            ;----------------------------------------
            ; 
            ;----------------------------------------
            
          Case #Gadget_PiccyCategory_SaveCategory
            Select EventType()
              Case #HoverEvent_EnterGadget          : SetHoverIcons(GadgetID, #Image_PiccyDb_Save, "Hovered")                  : StatusBarTip(#Window_PiccyCategory, "SaveCategory")
              Case #PB_EventType_LeftClick          : SetHoverIcons(GadgetID, #Image_PiccyDb_Save, "Pressed")                  : SaveCategory()
              Case #HoverEvent_LeaveGadget          : SetHoverIcons(GadgetID, #Image_PiccyDb_Save, "Normal")   
            EndSelect
            
            ;----------------------------------------
            ; 
            ;----------------------------------------
            
          Case #Gadget_PiccyCategory_ExitCategory
            Select EventType()
              Case #HoverEvent_EnterGadget          : SetHoverIcons(GadgetID, #Image_PiccyDb_Exit, "Hovered")                  : StatusBarTip(#Window_PiccyCategory, "ExitCategory")
              Case #PB_EventType_LeftClick          : SetHoverIcons(GadgetID, #Image_PiccyDb_Exit, "Pressed")                  : CloseMyWindow(#Window_PiccyCategory)
              Case #HoverEvent_LeaveGadget          : SetHoverIcons(GadgetID, #Image_PiccyDb_Exit, "Normal")   
            EndSelect
            
            ;----------------------------------------
            ; 
            ;----------------------------------------
            
          Case #Gadget_PiccyDb_Titles
            Select EventType()
              Case #PB_EventType_LeftDoubleClick    : EditCurrentPicture()
              Case #PB_EventType_RightClick         : DisplayPopupMenu(#PopMenuBar_PiccyDb, WindowID(#Window_PiccyDb))  
              Case #PB_EventType_RightDoubleClick   : AddNewPicture()
              Case #PB_EventType_Change             : ShowCurrentPicture()
              Case #PB_EventType_DragStart          : DragToCategory()
            EndSelect
            
            ;----------------------------------------
            ; 
            ;----------------------------------------
            
          Case #Gadget_PiccyDb_Add
            Select EventType()
              Case #HoverEvent_EnterGadget          : SetHoverIcons(GadgetID, #Image_PiccyDb_Add, "Hovered")                   : StatusBarTip(#Window_PiccyDb, "AddPicture")
              Case #PB_EventType_LeftClick          : SetHoverIcons(GadgetID, #Image_PiccyDb_Add, "Pressed")                   : AddNewPicture()
              Case #HoverEvent_LeaveGadget          : SetHoverIcons(GadgetID, #Image_PiccyDb_Add, "Normal")
            EndSelect
            
            ;----------------------------------------
            ; 
            ;----------------------------------------
            
          Case #Gadget_PiccyDb_Copy
            Select EventType()
              Case #HoverEvent_EnterGadget          : SetHoverIcons(GadgetID, #Image_PiccyDb_Copy, "Hovered")                  : StatusBarTip(#Window_PiccyDb, "CopyPicture")
              Case #PB_EventType_LeftClick          : SetHoverIcons(GadgetID, #Image_PiccyDb_Copy, "Pressed")                  : CopyCurrentPicture()
              Case #HoverEvent_LeaveGadget          : SetHoverIcons(GadgetID, #Image_PiccyDb_Copy, "Normal")
            EndSelect
            
            ;----------------------------------------
            ; 
            ;----------------------------------------
            
          Case #Gadget_PiccyDb_Delete
            Select EventType()
              Case #HoverEvent_EnterGadget          : SetHoverIcons(GadgetID, #Image_PiccyDb_Delete, "Hovered")                : StatusBarTip(#Window_PiccyDb, "DeletePicture")
              Case #PB_EventType_LeftClick          : SetHoverIcons(GadgetID, #Image_PiccyDb_Delete, "Pressed")                : DeleteCurrentPicture()
              Case #HoverEvent_LeaveGadget          : SetHoverIcons(GadgetID, #Image_PiccyDb_Delete, "Normal")
            EndSelect
            
            ;----------------------------------------
            ; 
            ;----------------------------------------
            
          Case #Gadget_PiccyDb_Edit
            Select EventType()
              Case #HoverEvent_EnterGadget          : SetHoverIcons(GadgetID, #Image_PiccyDb_Edit, "Hovered")                  : StatusBarTip(#Window_PiccyDb, "EditPicture")
              Case #PB_EventType_LeftClick          : SetHoverIcons(GadgetID, #Image_PiccyDb_Edit, "Pressed")                  : EditCurrentPicture()
              Case #HoverEvent_LeaveGadget          : SetHoverIcons(GadgetID, #Image_PiccyDb_Edit, "Normal")
            EndSelect
            
            ;----------------------------------------
            ; 
            ;----------------------------------------
            
          Case #Gadget_PiccyDb_Favourite
            Select EventType()
              Case #HoverEvent_EnterGadget          : SetHoverIcons(GadgetID, #Image_PiccyDb_Favourite, "Hovered")             : StatusBarTip(#Window_PiccyDb, "FavouritePicture")
              Case #PB_EventType_LeftClick          : SetHoverIcons(GadgetID, #Image_PiccyDb_Favourite, "Pressed")             : FavouriteCurrentPicture()
              Case #HoverEvent_LeaveGadget          : SetHoverIcons(GadgetID, #Image_PiccyDb_Favourite, "Normal")
            EndSelect
            
            ;----------------------------------------
            ; 
            ;----------------------------------------
            
          Case #Gadget_PiccyDb_Kill
            Select EventType()
              Case #HoverEvent_EnterGadget          : SetHoverIcons(GadgetID, #Image_PiccyDb_Kill, "Hovered")                  : StatusBarTip(#Window_PiccyDb, "KillPicture")
              Case #PB_EventType_LeftClick          : SetHoverIcons(GadgetID, #Image_PiccyDb_Kill, "Pressed")                  : KillCurrentPicture()
              Case #HoverEvent_LeaveGadget          : SetHoverIcons(GadgetID, #Image_PiccyDb_Kill, "Normal")
            EndSelect
            
            ;----------------------------------------
            ; 
            ;----------------------------------------
            
          Case #Gadget_PiccyDb_Lock
            Select EventType()
              Case #HoverEvent_EnterGadget          : SetHoverIcons(GadgetID, #Image_PiccyDb_Lock, "Hovered")                  : StatusBarTip(#Window_PiccyDb, "LockPicture")
              Case #PB_EventType_LeftClick          : SetHoverIcons(GadgetID, #Image_PiccyDb_Lock, "Pressed")                  : LockCurrentPicture()
              Case #HoverEvent_LeaveGadget          : SetHoverIcons(GadgetID, #Image_PiccyDb_Lock, "Normal")
            EndSelect
            
            ;----------------------------------------
            ; 
            ;----------------------------------------
            
          Case #Gadget_PiccyDb_Save
            Select EventType()
              Case #HoverEvent_EnterGadget          : SetHoverIcons(GadgetID, #Image_PiccyDb_Save, "Hovered")                  : StatusBarTip(#Window_PiccyDb, "SavePicture")
              Case #PB_EventType_LeftClick          : SetHoverIcons(GadgetID, #Image_PiccyDb_Save, "Pressed")                  : SaveCurrentPictureToDisk()
              Case #HoverEvent_LeaveGadget          : SetHoverIcons(GadgetID, #Image_PiccyDb_Save, "Normal")
            EndSelect
            
            ;----------------------------------------
            ; 
            ;----------------------------------------
            
          Case #Gadget_PiccyDb_Export
            Select EventType()
              Case #HoverEvent_EnterGadget          : SetHoverIcons(GadgetID, #Image_PiccyDb_Export, "Hovered")                : StatusBarTip(#Window_PiccyDb, "ExportPictures")
              Case #PB_EventType_LeftClick          : SetHoverIcons(GadgetID, #Image_PiccyDb_Export, "Pressed")                : ExportPictures()
              Case #HoverEvent_LeaveGadget          : SetHoverIcons(GadgetID, #Image_PiccyDb_Export, "Normal")
            EndSelect
            
            ;----------------------------------------
            ; 
            ;----------------------------------------
            
          Case #Gadget_PiccyDb_Import
            Select EventType()
              Case #HoverEvent_EnterGadget          : SetHoverIcons(GadgetID, #Image_PiccyDb_Import, "Hovered")                : StatusBarTip(#Window_PiccyDb, "ImportPictures")
              Case #PB_EventType_LeftClick          : SetHoverIcons(GadgetID, #Image_PiccyDb_Import, "Pressed")                : ImportPictures()
              Case #HoverEvent_LeaveGadget          : SetHoverIcons(GadgetID, #Image_PiccyDb_Import, "Normal")
            EndSelect
            
            ;----------------------------------------
            ; 
            ;----------------------------------------
            
          Case #Gadget_PiccyDb_Help
            Select EventType()
              Case #HoverEvent_EnterGadget          : SetHoverIcons(GadgetID, #Image_PiccyDb_Help, "Hovered")                  : StatusBarTip(#Window_PiccyDb, "HelpProgram")
              Case #PB_EventType_LeftClick          : SetHoverIcons(GadgetID, #Image_PiccyDb_Help, "Pressed")                  : ShowProgramHelp()
              Case #HoverEvent_LeaveGadget          : SetHoverIcons(GadgetID, #Image_PiccyDb_Help, "Normal")
            EndSelect
            
            ;----------------------------------------
            ; 
            ;----------------------------------------
            
          Case #Gadget_PiccyDb_Exit
            Select EventType()
              Case #HoverEvent_EnterGadget          : SetHoverIcons(GadgetID, #Image_PiccyDb_Exit, "Hovered")                  : StatusBarTip(#Window_PiccyDb, "ExitProgram")
              Case #PB_EventType_LeftClick          : SetHoverIcons(GadgetID, #Image_PiccyDb_Exit, "Pressed")                  : Program\QuitValue = 1
              Case #HoverEvent_LeaveGadget          : SetHoverIcons(GadgetID, #Image_PiccyDb_Exit, "Normal")
            EndSelect
            
            ;----------------------------------------
            ; 
            ;----------------------------------------
            
          Case #Gadget_PiccyDb_picture
            Select EventType()
              Case #PB_EventType_RightClick         : DisplayPopupMenu(#PopMenuBar_Picture, WindowID(#Window_PiccyDb))  
              Case #PB_EventType_LeftDoubleClick    : ViewCurrentPicture()
            EndSelect
            
            ;----------------------------------------
            ; 
            ;----------------------------------------
            
          Case #Gadget_PiccyDb_search 
            If GetGadgetText(#Gadget_PiccyDb_search) = #EmptyString
              SetGadgetFont(#Gadget_PiccyDb_search, FontID(Program\SearchCueFont))
            Else
              SetGadgetFont(#Gadget_PiccyDb_search, FontID(Program\SearchNormalFont))
            EndIf
            
            ;-----------------------------------------
            ; 
            ;-----------------------------------------
            
          Case #Gadget_PiccyData_Title              : StringFirstUpper(#Gadget_PiccyData_Title)
          Case #Gadget_PiccyData_Category           : MixedComboCaseEx(#Gadget_PiccyData_Category)
          Case #Gadget_PiccyData_Subcategory        : MixedComboCaseEx(#Gadget_PiccyData_Subcategory)     ; Added  
          Case #Gadget_PiccyData_Artist             : MixedComboCaseEx(#Gadget_PiccyData_Artist)
          Case #Gadget_PiccyData_Copyright          : MixedComboCaseEx(#Gadget_PiccyData_Copyright)
          Case #Gadget_PiccyData_Homepage           : MixedComboCaseEx(#Gadget_PiccyData_Homepage)
            
          ;-------------------------------------------
          ; 
          ;-------------------------------------------
            
          Case #Gadget_PiccyData_Save
            Select EventType()
              Case #HoverEvent_EnterGadget          : SetHoverIcons(GadgetID, #Image_PiccyDb_Save, "Hovered")                  : StatusBarTip(#Window_PiccyData, "SavePicture")
              Case #PB_EventType_LeftClick          : SetHoverIcons(GadgetID, #Image_PiccyDb_Save, "Pressed")                  : SavePictureData()
              Case #HoverEvent_LeaveGadget          : SetHoverIcons(GadgetID, #Image_PiccyDb_Save, "Normal")
            EndSelect
            
            ;----------------------------------------
            ; 
            ;----------------------------------------
            
          Case #Gadget_PiccyData_Load
            Select EventType()
              Case #HoverEvent_EnterGadget          : SetHoverIcons(GadgetID, #Image_PiccyData_Load, "Hovered")                : StatusBarTip(#Window_PiccyData, "LoadPicture")
              Case #PB_EventType_LeftClick          : SetHoverIcons(GadgetID, #Image_PiccyData_Load, "Pressed")                : AttachPicture()
              Case #HoverEvent_LeaveGadget          : SetHoverIcons(GadgetID, #Image_PiccyData_Load, "Normal")
            EndSelect
            
            ;----------------------------------------
            ; 
            ;----------------------------------------
            
          Case #Gadget_PiccyData_Exit
            Select EventType()
              Case #HoverEvent_EnterGadget          : SetHoverIcons(GadgetID, #Image_PiccyDb_Exit, "Hovered")                  : StatusBarTip(#Window_PiccyData, "ExitPicture")
              Case #PB_EventType_LeftClick          : SetHoverIcons(GadgetID, #Image_PiccyDb_Exit, "Pressed")                  : CloseMyWindow(#Window_PiccyData)
              Case #HoverEvent_LeaveGadget          : SetHoverIcons(GadgetID, #Image_PiccyDb_Exit, "Normal")            
            EndSelect
            
            ;----------------------------------------
            ; 
            ;----------------------------------------
            
        EndSelect
        
        ;--------------------------------------------
        ; Unhide the program window when the user clicks the icon in the tray
        ;--------------------------------------------
        
      Case #PB_Event_SysTray                        : ShowProgramWindow()
        
      ;----------------------------------------------
      ; 
      ;----------------------------------------------

    EndSelect
    
    ;------------------------------------------------
    ; 
    ;------------------------------------------------
    
  Until Program\QuitValue
  
  ;--------------------------------------------------
  ; Update the setup table with any changed setup items
  ;--------------------------------------------------
  
  SaveProgramOptions()
  
  ;--------------------------------------------------
  ; 
  ;--------------------------------------------------
  
  CloseWindow(#Window_PiccyDb)
  
  ;--------------------------------------------------
  ; 
  ;--------------------------------------------------
  
EndIf

;----------------------------------------------------
; 
;----------------------------------------------------

End

; IDE Options = PureBasic 5.31 (Windows - x86)
; CursorPosition = 126
; FirstLine = 123
; Folding = -
; EnableUnicode
; EnableXP
; UseIcon = Images\_Other\Whiskey Carafe.ico
; Executable = PiccyDb.exe