﻿;==========================================================================================================================================================
; Need a unicode aware version of the API directory creator
;==========================================================================================================================================================

Import "shell32.lib"                                                                                ; 
  SHCreateDirectory(*hwnd, pszPath.p-unicode)                                                        ; 
EndImport                                                                                           ; 

;==========================================================================================================================================================
; Find out if there is a working destop environment
;==========================================================================================================================================================

ExamineDesktops()                                                                                   ; 

;==========================================================================================================================================================
; Get the current postition on a gadget relative to a window
;==========================================================================================================================================================

#LVM_SUBITEMHITTEST             = #LVM_FIRST + 57                                                   ; 

;==========================================================================================================================================================
; Windows title bar height
;==========================================================================================================================================================

#CCHILDREN_TITLEBAR             = 5                                                                 ; 

;==========================================================================================================================================================
; Dealing with strikeout attributes on a font in a listicongadget
;==========================================================================================================================================================

#FontStrikeoutYes               = 0                                                                 ; 
#FontStrikeoutNo                = 1                                                                 ; 

;==========================================================================================================================================================
; My personal constants - Program details etc
;==========================================================================================================================================================

#Author                         = "Miklos G Bolvary"                                                ; Author's name
#CopyRight                      = "MGB Technical Services 2015 "                                    ; Copyright holder
#Basename                       = "PiccyDb "                                                        ; Base name for ini and dataabse
#Version                        = "v0.00 "                                                          ; Program version
#Program                        = #Basename + #Version                                              ; Copyright string
#Eol                            = Chr(13) + Chr(10)                                                 ; End of line marker
#Fish                           = "<°)))o><²³  "                                                    ; My favourite fish!!
#Traynote                       = #Basename + #Version                                              ; Copyright string

;==========================================================================================================================================================
; My personal constants - Program constants that don't need to change
;==========================================================================================================================================================

#ListIconHeadingArea            = -1                                                                ; 

#NoCurrentLine                  = -1                                                                ; 

#TitleColumn                    = 0                                                                 ; 
#LockedColumn                   = 1                                                                 ; 
#FavouriteColumn                = 2                                                                 ; 
#DeletedColumn                  = 3                                                                 ; 
#RecordColumn                   = 4                                                                 ; 

#CategoryTitleColumn            = 0                                                                 ; 
#CategoryItemsColumn            = 1                                                                 ; 
#CategoryRecordColumn           = 2                                                                 ; 

#MainPictureWidth               = 330                                                               ; 
#MainPictureHeight              = 270                                                               ; 

#DataPictureWidth               = 520                                                               ; 
#DataPictureHeight              = 485                                                               ; 

#ViewWindowWidth                = 1024                                                              ; 
#ViewWindowHeight               = 768                                                               ; 

#NoPictureHandle                = 0                                                                 ; 
#NoFileHandle                   = 0                                                                 ; 
#NoXMLNodeHandle                = 0                                                                 ; 

#NoBlobFound                    = 0                                                                 ; 
#NoDataFound                    = 0                                                                 ; 
#NoBufferDataFound              = 0                                                                 ; 

#NothingEncoded                 = 0                                                                 ; 
#NothingDecoded                 = 0                                                                 ; 

#NothingSelected                = -1                                                                ; 
#NothingFound                   = 0                                                                 ; 

#AtTheEndOfTheList              = -1                                                                ; 

#NoItems                        = 0                                                                 ; 
#FirstItem                      = 0                                                                 ; 

#EmptyString                    = ""                                                                ; 

#DatabaseQueryFail              = 0                                                                 ; 
#DatabaseUpdateFail             = 0                                                                 ; 

#NotEndOfFile                   = 0                                                                 ; 

#TitleBarClockEvent             = 624                                                               ; 

#NoMenuCreated                  = 0                                                                 ; 

;==========================================================================================================================================================
; Work out windows title bar details
;==========================================================================================================================================================

Structure TITLEBARINFO                                                                             ; 
  cbSize.l                                                                                          ; 
  rcTitleBar.RECT                                                                                   ; 
  rgstate.l[#CCHILDREN_TITLEBAR + 1]                                                                ; 
EndStructure                                                                                       ; 

;==========================================================================================================================================================
; All program variables
;==========================================================================================================================================================

Structure ProgramData
  ; Various semaphores
  QuitValue.i                                                                                       ; Program quit flag
  WindowMutex.i                                                                                     ; Open window flag  
  TrayState.i                                                                                       ; Is the form minimised to the system tray
  FirstTime.i                                                                                       ; Have certain functions already been done?
  
  ; Database specific
  DatabaseHandle.i                                                                                  ; Handle to the current database
  DatabaseDirectory.s                                                                               ; Directory for the database
  DatabaseName.s                                                                                    ; Current path and name of the system database
  
  ; Directory directives
  CurrentDirectory.s                                                                                ; The current program startup directory
  TemporaryDirectory.s                                                                              ; Temporary files directory
  
  ; Current document line and record
  CurrentLine.i                                                                                     ; Current line in the titles list
  CurrentRecord.s                                                                                   ; Current record number
  CurrentTitle.s                                                                                    ; Current picture title
  
  ; Category related functions
  CurrentCategory.s                                                                                 ; Current category item
  CurrentCategoryLine.i                                                                             ; Current category item line
  
  ; For title changes
  LastWindow.s                                                                                      ; The last window opened
  MainWindowTitle.s                                                                                 ; Main window title for clock functions
  
  ; Search cue font 
  SearchCueFont.i                                                                                   ; Searchbox cue font
  SearchNormalFont.i                                                                                ; Searchbox normal font
  SearchCueText.s                                                                                   ; Search box prompt text
  
  NewPictureName.s                                                                                  ; Name of new picture to import
  
  OldCategoryString.s                                                                               ; Name of the old category string
  
  DesktopWidth.i                                                                                    ; Current desktop width
  DesktopHeight.i                                                                                   ; Current desktop height
EndStructure

;==========================================================================================================================================================
; PiccyDb data structure
;==========================================================================================================================================================

Structure PictureData
  Title.s                                                                                           ;  
  Artist.s                                                                                          ;  
  Copyright.s                                                                                       ;  
  Homepage.s                                                                                        ;  
  Category.s                                                                                        ;  
  Subcategory.s                                                                                     ; 
  Comment.s                                                                                         ;  

  Directory.s                                                                                       ;  
  Filename.s                                                                                        ;  
  
  MD5Fingerprint.s                                                                                  ; 
  
  Created.s                                                                                         ;  
  Modified.s                                                                                        ;  
  Accessed.s                                                                                        ;  
  Archived.s                                                                                        ;  

  Horizontal.s                                                                                      ;  
  Vertical.s                                                                                        ;  
  Depth.s                                                                                           ;  

  Favourite.s                                                                                       ;  
  Locked.s                                                                                          ;  
  Deleted.s                                                                                         ;  

  RecordId.s                                                                                        ;  
EndStructure

;==========================================================================================================================================================
; 
;==========================================================================================================================================================

Structure BlobData
  Picture_Id.s                                                                                      ;  
  Picture.s                                                                                         ;  
  Record_Id.s                                                                                       ;  
EndStructure

;==========================================================================================================================================================
; Category structure
;==========================================================================================================================================================

Structure CategoryData                                                                             ; 
  Category.s                                                                                        ; 0
  Itemcount.s                                                                                       ; 1
  Record_Id.s                                                                                       ; 2
EndStructure                                                                                       ; 

;==========================================================================================================================================================
; Setup window variables
;==========================================================================================================================================================

Structure SetupData                                                                                ; 
  TitleClock.i                                                                                      ;   
  StickyWindow.i                                                                                    ; 
  ScreenSnap.i                                                                                      ; 
  LastSearch.s                                                                                      ; 
EndStructure                                                                                       ; 

;==============================================================================================================================================================================
; Button glow effects structure
;==============================================================================================================================================================================

Structure GlowData                                                                                  ; 
  GlowColour.l                                                                                       ; 
  GlowRadius.i                                                                                       ; 
  ExtendCanvas.i                                                                                     ; 
EndStructure                                                                                        ; 

;==========================================================================================================================================================
; Any global variables, lists etc
;==========================================================================================================================================================

Global Program.ProgramData                                                                          ; Structure to hold program data
Global Picture.PictureData                                                                          ; Structure to hold picture data
Global Blobs.BlobData                                                                               ; Structure to hold blob Data
Global Category.CategoryData                                                                        ; Structure to hold category data
Global Setup.SetupData                                                                              ; Structure to hold setup data
Global Glow.GlowData                                                                                ; Icon border glow effects

Global NewList FoundDirs.s()                                                                       ; List of recursed import directories

;==============================================================================================================================================================================
; Toolbar button outline parameters (Might make it random at some stage)
;==============================================================================================================================================================================

Global Dim GlowColours(11)                                                                           ; 

GlowColours(0)  = $0000FF                                                                             ; 
GlowColours(1)  = $00FF00                                                                             ; 
GlowColours(2)  = $00FFFF                                                                             ; 
GlowColours(3)  = $FF0000                                                                             ; 
GlowColours(4)  = $FF00FF                                                                             ; 
GlowColours(5)  = $FFFF00                                                                             ; 
GlowColours(6)  = $000080                                                                             ; 
GlowColours(7)  = $008000                                                                             ; 
GlowColours(8)  = $800000                                                                             ; 
GlowColours(9)  = $800080                                                                             ; 
GlowColours(10) = $808000                                                                             ; 
GlowColours(11) = $000000                                                                             ; 

Glow\GlowColour   =  Random(GlowColours())                                                            ; 
Glow\GlowRadius   = 5                                                                                 ; 
Glow\ExtendCanvas = #False                                                                            ; 

;==========================================================================================================================================================
; NetMaestro's screen snap code
;==========================================================================================================================================================

Global screenW, screenH, SnapD = 50, AutoSnap = #True                                               ;

SystemParametersInfo_(#SPI_GETWORKAREA, 0, @wa.RECT, 0)                                              ; Client area of the desktop

ScreenW = wa\right                                                                                   ;

screenH = wa\bottom                                                                                  ;

;==========================================================================================================================================================
; Setup the search box cue fonts
;==========================================================================================================================================================

Program\SearchCueFont       = LoadFont(#PB_Any,   "Georgia",       13, #PB_Font_Italic)             ; Empty search cue font
Program\SearchNormalFont    = LoadFont(#PB_Any,   "Comic Sans MS", 13, 0)                           ; Filled cue box font
Program\SearchCueText       = Space(256)                                                            ; Set the cue text buffer

PokeS(@Program\SearchCueText, "Search string here...", -1, #PB_Unicode)                             ; Fill the buffer with the cue text

;==========================================================================================================================================================
; Get working directories variables and create the physical dirs that go with them
;==========================================================================================================================================================

Program\CurrentDirectory    = GetCurrentDirectory()                                                 ; Get the current directory name

;==========================================================================================================================================================
; Setup the various system directory names and paths
;==========================================================================================================================================================

Program\DatabaseDirectory   = Program\CurrentDirectory  + "Database\"                               ; Database directory
Program\TemporaryDirectory  = Program\CurrentDirectory  + "Temporary\"                              ; Temporary files directory

;==========================================================================================================================================================
; Setup the various system file names and where they go.
;==========================================================================================================================================================

Program\DatabaseName        = Program\DatabaseDirectory   + ReplaceString(#Basename, " ", "_") + #Version  +  ".Sqlite" ; Database name and path

;==========================================================================================================================================================
; Get the current width and height of the working desktop
;==========================================================================================================================================================

Program\DesktopWidth        = DesktopWidth(0)                                                       ; 
Program\DesktopHeight       = DesktopHeight(0)                                                      ; 
  
;==========================================================================================================================================================
; Create the directories if you can
;==========================================================================================================================================================

MakeSureDirectoryPathExists(Program\DatabaseDirectory)                                              ; 
MakeSureDirectoryPathExists(Program\TemporaryDirectory)                                             ; 

;==========================================================================================================================================================
; Setup day and month literal names
;==========================================================================================================================================================

Global Dim NameOfDay.s(7)                                                                           ; Fill an array with the names of the days (Terry Hough I think)

   NameOfDay(0)      = "Sunday"
   NameOfDay(1)      = "Monday"
   NameOfDay(2)      = "Tuesday"
   NameOfDay(3)      = "Wednesday"
   NameOfDay(4)      = "Thursday"
   NameOfDay(5)      = "Friday"
   NameOfDay(6)      = "Saturday"

Global Dim DaysPerMonth(12)                                                                         ; Fill an array on how many days per month there are

  For X = 0 To 11     
    DaysPerMonth(X) = 31 
  Next

  DaysPerMonth(1)   = 28
  DaysPerMonth(3)   = 30
  DaysPerMonth(5)   = 30
  DaysPerMonth(8)   = 30
  DaysPerMonth(10)  = 30

Global Dim NameOfMonth.s(12)                                                                        ; Fill an array with the names of the months

  NameOfMonth(0)    = "January"
  NameOfMonth(1)    = "February"
  NameOfMonth(2)    = "March"
  NameOfMonth(3)    = "April"
  NameOfMonth(4)    = "May"
  NameOfMonth(5)    = "June"
  NameOfMonth(6)    = "July"
  NameOfMonth(7)    = "August"
  NameOfMonth(8)    = "September"
  NameOfMonth(9)    = "October"
  NameOfMonth(10)   = "November"
  NameOfMonth(11)   = "December"

Global Dim Years.s(19)                                                                              ; Fill an array with the years

  Years(0)          = "2002"
  Years(1)          = "2003"
  Years(2)          = "2004"
  Years(3)          = "2005"
  Years(4)          = "2006" 
  Years(5)          = "2007"
  Years(6)          = "2008"
  Years(7)          = "2009"
  Years(8)          = "2010"
  Years(9)          = "2011"
  Years(10)         = "2012"
  Years(11)         = "2013"
  Years(12)         = "2014"
  Years(13)         = "2015"
  Years(14)         = "2016"
  Years(15)         = "2017"
  Years(16)         = "2018"
  Years(17)         = "2019"
  Years(18)         = "2020"
  
;==========================================================================================================================================================
; Preallocated menu shortcuts for menu and statusbar translations
;==========================================================================================================================================================

#Keys_BackupDatabase  = #PB_Shortcut_Alt                              | #PB_Shortcut_B   ; 
#Keys_VacuumDatabase  = #PB_Shortcut_Alt                              | #PB_Shortcut_V

#Keys_AddCategory     = #PB_Shortcut_Alt                              | #PB_Shortcut_1
#Keys_CopyCategory    = #PB_Shortcut_Alt                              | #PB_Shortcut_2
#Keys_DeleteCategory  = #PB_Shortcut_Alt                              | #PB_Shortcut_3
#Keys_EditCategory    = #PB_Shortcut_Alt                              | #PB_Shortcut_4
#Keys_ExportCategory  = #PB_Shortcut_Alt                              | #PB_Shortcut_5
#Keys_ImportCategory  = #PB_Shortcut_Alt                              | #PB_Shortcut_6

#Keys_Add             = #PB_Shortcut_Alt                              | #PB_Shortcut_A
#Keys_AddFolder       = #PB_Shortcut_Alt      | #PB_Shortcut_Shift    | #PB_Shortcut_F
#Keys_Copy            = #PB_Shortcut_Alt                              | #PB_Shortcut_C
#Keys_Delete          = #PB_Shortcut_Alt                              | #PB_Shortcut_D
#Keys_Edit            = #PB_Shortcut_Alt                              | #PB_Shortcut_E
#Keys_Favourite       = #PB_Shortcut_Alt                              | #PB_Shortcut_F
#Keys_Help            = #PB_Shortcut_Alt                              | #PB_Shortcut_H
#Keys_Import          = #PB_Shortcut_Alt                              | #PB_Shortcut_I
#Keys_Kill            = #PB_Shortcut_Alt                              | #PB_Shortcut_K
#Keys_Lock            = #PB_Shortcut_Alt                              | #PB_Shortcut_L
#Keys_Save            = #PB_Shortcut_Alt                              | #PB_Shortcut_S
#Keys_SaveSelected    = #PB_Shortcut_Alt      | #PB_Shortcut_Shift    | #PB_Shortcut_S
#Keys_SaveCategory    = #PB_Shortcut_Alt      | #PB_Shortcut_Shift    | #PB_Shortcut_C
#Keys_SaveAll         = #PB_Shortcut_Alt      | #PB_Shortcut_Shift    | #PB_Shortcut_A
#Keys_View            = #PB_Shortcut_Alt      | #PB_Shortcut_Shift    | #PB_Shortcut_V
#Keys_Export          = #PB_Shortcut_Alt      | #PB_Shortcut_Shift    | #PB_Shortcut_E
#Keys_Exit            = #PB_Shortcut_Alt                              | #PB_Shortcut_X

#Keys_ScreenSnap      = #PB_Shortcut_Alt                              | #PB_Shortcut_F1
#Keys_StickyWindow    = #PB_Shortcut_Alt                              | #PB_Shortcut_F2
#Keys_TitleClock      = #PB_Shortcut_Alt                              | #PB_Shortcut_F3

#Keys_AboutProgram    = #PB_Shortcut_Alt                              | #PB_Shortcut_F4

#Keys_SearchPictures  = #PB_Shortcut_Return

;==========================================================================================================================================================
;
;==========================================================================================================================================================

#Text_BackupDatabase         = "Backup the picture database"
#Text_VacuumDatabase         = "Vacuum the picture database"

#Text_ExitProgram            = "Exit this program"

#Text_AddCategory            = "Add a new category"
#Text_CopyCategory           = "Copy category to clipboard"
#Text_DeleteCategory         = "Delete current category"
#Text_EditCategory           = "Edit current category"
#Text_ExportCategory         = "Export all categories"
#Text_ImportCategory         = "Import categories"

#Text_AddPicture             = "Add a new picture"
#Text_AddFolder              = "Add an entire folder"
#Text_CopyPicture            = "Copy picture to clipboard"
#Text_DeletePicture          = "Delete current picture"
#Text_EditPicture            = "Edit current picture"
#Text_FavouritePicture       = "Mark picture as a favourite"
#Text_KillPicture            = "Kill picture permanently"
#Text_LockPicture            = "Lock this picture"
#Text_SavePicture            = "Save this picture to disk"
#Text_SaveSelected           = "Save selected pictures to disk"
#Text_SaveCategory           = "Save pictures in current category"
#Text_SaveAllPictures        = "Save all pictures to disk"
#Text_ViewPicture            = "View this picture"
#Text_ExportPictures         = "Export data to XML file"
#Text_ImportPictures         = "Import data from XML file"

#Text_ScreenSnap             = "Snap window to screen edges"
#Text_StickyWindow           = "Sticky window on top of others"
#Text_TitleClock             = "Turn on or off the titlebar clock"

#Text_AboutProgram           = "About this program"
#Text_ProgramHelp            = "Program help (if available)"

;==========================================================================================================================================================
; 
;==========================================================================================================================================================
  
Enumeration #GadgetIndex                                                                           ;
  #Tray_PiccyDb                                                                                     ; 
  
  ; The category bar popup menu
  
  #PopMenuBar_Category                                                                              ; 
  #PopMenuBar_Category_AddCategory                                                                  ; 
  #PopMenuBar_Category_CopyCategory                                                                 ; 
  #PopMenuBar_Category_DeleteCategory                                                               ; 
  #PopMenuBar_Category_EditCategory                                                                 ; 
  #PopMenuBar_Category_ExportCategory                                                               ; 
  #PopMenuBar_Category_ImportCategory                                                               ; 
  
  ; The main list popup menubar
  
  #PopMenuBar_PiccyDb                                                                               ; 
  #PopMenuBar_PiccyDb_BackupDatabase                                                                ; 
  #PopMenuBar_PiccyDb_VacuumDatabase                                                                ; 
  #PopMenuBar_PiccyDb_ExitProgram                                                                   ; 
  #PopMenuBar_PiccyDb_AddCategory                                                                   ; 
  #PopMenuBar_PiccyDb_CopyCategory                                                                  ; 
  #PopMenuBar_PiccyDb_DeleteCategory                                                                ; 
  #PopMenuBar_PiccyDb_EditCategory                                                                  ; 
  #PopMenuBar_PiccyDb_ExportCategory                                                                ; 
  #PopMenuBar_PiccyDb_ImportCategory                                                                ; 
  #PopMenuBar_PiccyDb_AddPicture                                                                    ; 
  #PopMenuBar_PiccyDb_AddFolder                                                                     ; 
  #PopMenuBar_PiccyDb_CopyPicture                                                                   ; 
  #PopMenuBar_PiccyDb_DeletePicture                                                                 ; 
  #PopMenuBar_PiccyDb_EditPicture                                                                   ; 
  #PopMenuBar_PiccyDb_FavouritePicture                                                              ; 
  #PopMenuBar_PiccyDb_KillPicture                                                                   ; 
  #PopMenuBar_PiccyDb_LockPicture                                                                   ; 
  #PopMenuBar_PiccyDb_SavePicture                                                                   ; 
  #PopMenuBar_PiccyDb_SaveSelected                                                                  ; 
  #PopMenuBar_PiccyDb_SaveCategory                                                                  ; 
  #PopMenuBar_PiccyDb_SaveAllPictures                                                               ; 
  #PopMenuBar_PiccyDb_ViewPicture                                                                   ; 
  #PopMenuBar_PiccyDb_ExportPictures                                                                ; 
  #PopMenuBar_PiccyDb_ImportPictures                                                                ; 
  #PopMenuBar_PiccyDb_ScreenSnap                                                                    ; 
  #PopMenuBar_PiccyDb_StickyWindow                                                                  ; 
  #PopMenuBar_PiccyDb_TitleClock                                                                    ; 
  #PopMenuBar_PiccyDb_AboutProgram                                                                  ; 
  #PopMenuBar_PiccyDb_ProgramHelp                                                                   ; 
  
  ; Picture popup menu bar
  
  #PopMenuBar_Picture                                                                               ; 
  #PopMenuBar_Picture_AddPicture                                                                    ; 
  #PopMenuBar_Picture_AddFolder                                                                     ; 
  #PopMenuBar_Picture_CopyPicture                                                                   ; 
  #PopMenuBar_Picture_DeletePicture                                                                 ; 
  #PopMenuBar_Picture_EditPicture                                                                   ; 
  #PopMenuBar_Picture_FavouritePicture                                                              ; 
  #PopMenuBar_Picture_KillPicture                                                                   ; 
  #PopMenuBar_Picture_LockPicture                                                                   ; 
  #PopMenuBar_Picture_SavePicture                                                                   ; 
  #PopMenuBar_Picture_SaveSelected                                                                  ;   
  #PopMenuBar_Picture_SaveCategory                                                                  ; 
  #PopMenuBar_Picture_SaveAllPictures
  #PopMenuBar_Picture_ViewPicture
  
  ; Standard program shortcuts
  
  #ShortCut_BackupDatabase                                                                          ; 
  #ShortCut_VacuumDatabase                                                                          ; 
  
  #ShortCut_AddCategory                                                                             ; 
  #ShortCut_CopyCategory                                                                            ; 
  #ShortCut_DeleteCategory                                                                          ; 
  #ShortCut_EditCategory                                                                            ; 
  #ShortCut_ExportCategory                                                                          ; 
  #ShortCut_ImportCategory                                                                          ; 
  
  #ShortCut_Add                                                                                     ; 
  #ShortCut_AddFolder                                                                               ; 
  #ShortCut_Copy                                                                                    ; 
  #ShortCut_Delete                                                                                  ; 
  #ShortCut_Edit                                                                                    ; 
  #ShortCut_Export                                                                                  ; 
  #ShortCut_Import                                                                                  ; 
  #ShortCut_Favourite                                                                               ; 
  #ShortCut_Kill                                                                                    ; 
  #ShortCut_Lock                                                                                    ; 
  #ShortCut_Save                                                                                    ; 
  #ShortCut_Selected                                                                                ; 
  #ShortCut_Category                                                                                ; 
  #Shortcut_SaveAll                                                                                 ; 
  #ShortCut_View                                                                                    ; 
  #ShortCut_Help                                                                                    ; 
  #ShortCut_Exit                                                                                    ; 
  
  #ShortCut_ScreenSnap                                                                              ; 
  #ShortCut_StickyWindow                                                                            ; 
  #ShortCut_TitleClock                                                                              ; 
  
  #ShortCut_About                                                                                   ; 
  
  #Shortcut_SearchPictures                                                                          ; 
  
  #Shortcut_CloseCategory                                                                           ;
  #Shortcut_SaveCategory                                                                            ;
  #Shortcut_ExitCategory                                                                            ;
  
  #Shortcut_CloseData                                                                               ;
  #Shortcut_SaveData                                                                                ;
  #Shortcut_ExitData                                                                                ;
  
  #Shortcut_CloseViewer                                                                             ; 
  #Shortcut_ExitViewer                                                                              ; 
  
  #Splitter_Horizontal                                                                              ; 
EndEnumeration                                                                                     ;

;==========================================================================================================================================================
; Any image enumerations
;==========================================================================================================================================================

Enumeration #ImageIndex                                                                            ; 
  #Image_Tray_PiccyDb                                                                               ; 
  
  #Image_List_Allitems                                                                              ; 
  #Image_List_NoTitle                                                                               ; 
  #Image_List_NoCategory                                                                            ; 
  #Image_List_NoSubcategory                                                                         ; 
  #Image_List_Normal                                                                                ; 
  #Image_List_Deleted                                                                               ; 
  #Image_List_Locked                                                                                ; 
  #Image_List_Favourite                                                                             ; 
  
  #Image_Combo_Sql                                                                                  ; 
  
  #Image_Combo_Empty                                                                                ; 
  #Image_Combo_Artist                                                                               ; 
  #Image_Combo_Category                                                                             ; 
  #Image_Combo_Subcategory                                                                          ; 
  #Image_Combo_Copyright                                                                            ; 
  #Image_Combo_Homepage                                                                             ; 
EndEnumeration  

;==========================================================================================================================================================
; CatchImage section
;==========================================================================================================================================================

CatchImage(#Image_Tray_PiccyDb,             ?_Image_Tray_PiccyDb)                                   ; 

CatchImage(#Image_List_Allitems,            ?_Image_List_Allitems)                                  ; 
CatchImage(#Image_List_NoTitle,             ?_Image_List_NoTitle)                                   ; 
CatchImage(#Image_List_NoCategory,          ?_Image_List_NoCategory)                                ; 
CatchImage(#Image_List_NoSubcategory,       ?_Image_List_NoSubcategory)                             ;                                                                          ; 
CatchImage(#Image_List_Normal,              ?_Image_List_Normal)                                    ; 
CatchImage(#Image_List_Deleted,             ?_Image_List_Deleted)                                   ; 
CatchImage(#Image_List_Locked,              ?_Image_List_Locked)                                    ; 
CatchImage(#Image_List_Favourite,           ?_Image_List_Favourite)                                 ; 

CatchImage(#Image_Combo_Empty,              ?_Image_Combo_Empty)                                    ; 
CatchImage(#Image_Combo_Artist,             ?_Image_Combo_Artist)                                   ; 
CatchImage(#Image_Combo_Category,           ?_Image_Combo_Category)                                 ; 
CatchImage(#Image_Combo_Subcategory,        ?_Image_Combo_Subcategory)                              ; 
CatchImage(#Image_Combo_Copyright,          ?_Image_Combo_Copyright)                                ; 
CatchImage(#Image_Combo_Homepage,           ?_Image_Combo_Homepage)                                 ; 
CatchImage(#Image_Combo_Sql,                ?_Image_Combo_Sql)                                      ; 

;==========================================================================================================================================================
; 
;==========================================================================================================================================================

DataSection
  _Image_Tray_PiccyDb:              : IncludeBinary "Images\_16x16\Program.ico"                    ; 
  
  _Image_List_Allitems:             : IncludeBinary "Images\_16x16\All.ico"                        ; 
  _Image_List_NoTitle:              : IncludeBinary "Images\_16x16\Empty.ico"                      ; 
  _Image_List_NoCategory:           : IncludeBinary "Images\_16x16\Category.ico"                   ; 
  _Image_List_NoSubcategory:        : IncludeBinary "Images\_16x16\Subcategory.ico"                ; 
  _Image_List_Normal:               : IncludeBinary "Images\_16x16\Normal.ico"                     ; 
  _Image_List_Deleted:              : IncludeBinary "Images\_16x16\Deleted.ico"                    ; 
  _Image_List_Locked:               : IncludeBinary "Images\_16x16\Locked.ico"                     ; 
  _Image_List_Favourite:            : IncludeBinary "Images\_16x16\Favourite.ico"                  ; 
  
  _Image_Combo_Empty:               : IncludeBinary "Images\_16x16\Empty.ico"                      : 
  _Image_Combo_Artist:              : IncludeBinary "Images\_16x16\Artist.ico"                     ; 
  _Image_Combo_Category:            : IncludeBinary "Images\_16x16\Category.ico"                   ; 
  _Image_Combo_Subcategory:         : IncludeBinary "Images\_16x16\Subcategory.ico"                ; 
  _Image_Combo_Copyright:           : IncludeBinary "Images\_16x16\Copyright.ico"                  ; 
  _Image_Combo_Homepage:            : IncludeBinary "Images\_16x16\Homepage.ico"                   ; 
  _Image_Combo_Sql:                 : IncludeBinary "Images\_16x16\Sql.ico"                        ; 

  _SearchTypes_:
  
  Data.s  "Sounds like"                                                                             ; 
  Data.s  "Equal to"                                                                                ; 
  Data.s  "Does not equal"                                                                          ; 
  Data.s  "Greater than"                                                                            ; 
  Data.s  "Greater than or equal to"                                                                ; 
  Data.s  "Less than"                                                                               ; 
  Data.s  "Less than or equal to"                                                                   ; 
  Data.s  "Starts with"                                                                             ; 
  Data.s  "Ends with"                                                                               ; 
  Data.s  "_END_"                                                                                   ; 
EndDataSection
; IDE Options = PureBasic 5.31 (Windows - x86)
; CursorPosition = 317
; FirstLine = 309
; EnableXP